package ch.ige.adr.client;

import java.awt.BorderLayout;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.datatransfer.StringSelection;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;

import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JTextField;
import javax.swing.KeyStroke;
import javax.swing.border.TitledBorder;

import org.apache.log4j.Logger;

import ch.ige.adr.server.AdresseDelegate;
import ch.ige.adrhelp.HelpUtil;
import ch.ige.authz.client.AuthMain;
import ch.ige.authz.gui.AuthzJMenuItem;
import ch.ige.authz.gui.GUIAuthorizer;
import ch.ige.main.client.DeleteDialog;
import ch.ige.main.client.MainController;
import ch.ige.main.client.XxMessage;
import ch.ige.ses.client.saprequest.SapAdresse;
import ch.ige.ses.exception.SapCallException;
import ch.ige.util.IGEDate;
import ch.ige.util.vo.VersadrCheckVO;
import ch.ige.util.vo.VersadrVO;

/**
 * Detail der Versandadressen
 * <p>
 * Copyright (c) 2001, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Ueli Ryser
 * @version $Id: AdresseDtl.java,v 1.54 2008/04/28 15:32:34 galli Exp $
 */
public class AdresseDtl extends ch.ige.main.client.DetailPane
{
  // Logging
  private static final Logger LOG = Logger.getLogger( AdresseDtl.class );

  // Applikationsmeldungen
  protected XxMessage xxMessage = null;

  // Schlüssel
  protected Integer adrNr = null;

  // Frame konstruieren
  /**
   * Duplizieren Button
   */
  public JMenuItem mnuDuplicate = new AuthzJMenuItem();

  /**
   * Block Button
   */
  public JMenuItem mnuBlock = new AuthzJMenuItem();

  /**
   * Copy Button
   */
  public JMenuItem mnuCopyAdresse = new AuthzJMenuItem();

  /**
   * Copy Adresse Detail Button
   */
  public JMenuItem mnuCopyAdresseDetailPopup = new AuthzJMenuItem();

  /**
   * Copy Adresse mit Lookup
   */
  public JMenuItem mnuCopyAdresseLookupPopup = new AuthzJMenuItem();

  protected JPanel pnlMain = new JPanel();

  protected JPanel pnlAdresse = new JPanel();

  protected JPanel pnlAdresseSap = new JPanel();

  protected JLabel lblZeile2 = new JLabel();

  protected JLabel lblAdrNr = new JLabel();

  protected JLabel lblPlzOrt = new JLabel();

  protected JLabel lblLandCd = new JLabel();

  protected JLabel lblName = new JLabel();

  protected JLabel lblZeile1 = new JLabel();

  protected JTextField txfAdrNr = new JTextField();

  protected JTextField txfZeile1 = new JTextField();

  protected JTextField txfName = new JTextField();

  protected JTextField txfZeile2 = new JTextField();

  protected JTextField txfZeile4 = new JTextField();

  protected JTextField txfPlz = new JTextField();

  protected JTextField txfLandCd = new JTextField();

  protected JTextField txfZeile3 = new JTextField();

  protected JLabel lblZeile3 = new JLabel();

  protected JTextField txfOrt = new JTextField();

  protected JLabel lblSuchbegr = new JLabel();

  protected JTextField txfSuchbegr = new JTextField();

  protected JLabel lblSprachCd = new JLabel();

  protected JLabel lblTelefon = new JLabel();

  protected JTextField txfTelefon = new JTextField();

  protected JLabel lblEMail = new JLabel();

  protected JTextField txfEMail = new JTextField();

  protected JTextField txfSprachCd = new JTextField();

  protected JLabel lblZeile4 = new JLabel();

  protected JTextField txfFax = new JTextField();

  protected JLabel lblFax = new JLabel();

  protected JLabel lblGesperrt = new JLabel();

  protected JCheckBox ckbGesperrt = new JCheckBox();

  protected JLabel lblTaxClass = new JLabel();

  protected JTextField txfTaxClass = new JTextField();

  protected JLabel lblCustGroup = new JLabel();

  protected JCheckBox ckbCustGroup = new JCheckBox();

  protected JLabel lblCustGrp1 = new JLabel();

  protected JCheckBox ckbCustGrp1 = new JCheckBox();

  protected JLabel lblErst = new JLabel();

  protected JTextField txfErstBen = new JTextField();

  protected JTextField txfErstDat = new JTextField();

  protected JLabel lblGeaend = new JLabel();

  protected JTextField txfGeaendBen = new JTextField();

  protected JTextField txfGeaendDat = new JTextField();

  /**
   * default constructor
   */
  public AdresseDtl()
  {
    try
    {
      xxMessage = XxMessage.getInstance();
      jbInit();
      GUIAuthorizer.authorizeFieldsIn( this );
      initHelp();
    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      JOptionPane.showMessageDialog( mainController.getWindow(), ex.getMessage(), "Fehler", JOptionPane.ERROR_MESSAGE );
    }
  }

  /**
   * @param mainController Maincontroller
   * @param mode Modus
   */
  public AdresseDtl( MainController mainController, int mode )
  {
    super( mainController, mode );
    try
    {
      xxMessage = XxMessage.getInstance();
      jbInit();
      GUIAuthorizer.authorizeFieldsIn( this );
      initHelp();
    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      JOptionPane.showMessageDialog( mainController.getWindow(), ex.getMessage(), "Fehler", JOptionPane.ERROR_MESSAGE );
    }
  }

  /**
   * Komponente initialisieren
   * @throws Exception
   */
  private void jbInit() throws Exception
  {

    //********** Menus ******************************************************
    GridBagConstraints gridBagConstraints61 = new GridBagConstraints();
    gridBagConstraints61.insets = new Insets( 5, 2, 0, 0 );
    gridBagConstraints61.gridy = 0;
    gridBagConstraints61.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints61.weightx = 1.0;
    gridBagConstraints61.gridx = 5;
    GridBagConstraints gridBagConstraints51 = new GridBagConstraints();
    gridBagConstraints51.insets = new Insets( 5, 3, 5, 2 );
    gridBagConstraints51.gridy = 0;
    gridBagConstraints51.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints51.weighty = 1.0;
    gridBagConstraints51.gridx = 4;
    GridBagConstraints gridBagConstraints41 = new GridBagConstraints();
    gridBagConstraints41.insets = new Insets( 5, 1, 0, 3 );
    gridBagConstraints41.gridy = 0;
    gridBagConstraints41.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints41.weighty = 1.0;
    gridBagConstraints41.gridx = 3;
    GridBagConstraints gridBagConstraints35 = new GridBagConstraints();
    gridBagConstraints35.insets = new Insets( 5, 7, 5, 1 );
    gridBagConstraints35.gridy = 0;
    gridBagConstraints35.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints35.weighty = 1.0;
    gridBagConstraints35.gridx = 2;
    GridBagConstraints gridBagConstraints210 = new GridBagConstraints();
    gridBagConstraints210.fill = GridBagConstraints.NONE;
    gridBagConstraints210.gridx = 1;
    gridBagConstraints210.gridy = 0;
    gridBagConstraints210.ipadx = 156;
    gridBagConstraints210.weightx = 0.0;
    gridBagConstraints210.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints210.weighty = 1.0;
    gridBagConstraints210.insets = new Insets( 5, 6, 1, 7 );
    GridBagConstraints gridBagConstraints110 = new GridBagConstraints();
    gridBagConstraints110.insets = new Insets( 5, 23, 5, 6 );
    gridBagConstraints110.gridy = 0;
    gridBagConstraints110.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints110.fill = GridBagConstraints.NONE;
    gridBagConstraints110.weighty = 1.0;
    gridBagConstraints110.gridx = 0;
    GridBagConstraints gridBagConstraints34 = new GridBagConstraints();
    gridBagConstraints34.insets = new Insets( 5, 55, 0, 0 );
    gridBagConstraints34.gridy = 14;
    gridBagConstraints34.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints34.gridx = 0;
    GridBagConstraints gridBagConstraints33 = new GridBagConstraints();
    gridBagConstraints33.insets = new Insets( 6, 105, 3, 0 );
    gridBagConstraints33.gridy = 11;
    gridBagConstraints33.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints33.gridx = 0;
    GridBagConstraints gridBagConstraints32 = new GridBagConstraints();
    gridBagConstraints32.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints32.gridx = 6;
    gridBagConstraints32.gridy = 14;
    gridBagConstraints32.ipadx = 66;
    gridBagConstraints32.weightx = 1.0;
    gridBagConstraints32.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints32.insets = new Insets( 2, 2, 30, 47 );
    GridBagConstraints gridBagConstraints31 = new GridBagConstraints();
    gridBagConstraints31.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints31.gridx = 5;
    gridBagConstraints31.gridy = 14;
    gridBagConstraints31.ipadx = 56;
    gridBagConstraints31.weightx = 0.0;
    gridBagConstraints31.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints31.insets = new Insets( 2, 3, 30, 1 );
    GridBagConstraints gridBagConstraints30 = new GridBagConstraints();
    gridBagConstraints30.insets = new Insets( 5, 7, 30, 2 );
    gridBagConstraints30.gridy = 14;
    gridBagConstraints30.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints30.gridx = 4;
    GridBagConstraints gridBagConstraints29 = new GridBagConstraints();
    gridBagConstraints29.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints29.gridwidth = 1;
    gridBagConstraints29.gridx = 2;
    gridBagConstraints29.gridy = 14;
    gridBagConstraints29.ipadx = 66;
    gridBagConstraints29.weightx = 0.0;
    gridBagConstraints29.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints29.insets = new Insets( 2, 2, 30, 7 );
    GridBagConstraints gridBagConstraints28 = new GridBagConstraints();
    gridBagConstraints28.fill = GridBagConstraints.NONE;
    gridBagConstraints28.gridx = 1;
    gridBagConstraints28.gridy = 14;
    gridBagConstraints28.ipadx = 56;
    gridBagConstraints28.weightx = 0.0;
    gridBagConstraints28.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints28.gridheight = 1;
    gridBagConstraints28.insets = new Insets( 2, 7, 0, 0 );
    GridBagConstraints gridBagConstraints27 = new GridBagConstraints();
    gridBagConstraints27.insets = new Insets( 3, 6, 1, 0 );
    gridBagConstraints27.gridy = 13;
    gridBagConstraints27.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints27.gridx = 1;
    GridBagConstraints gridBagConstraints26 = new GridBagConstraints();
    gridBagConstraints26.insets = new Insets( 5, 81, 4, 0 );
    gridBagConstraints26.gridy = 13;
    gridBagConstraints26.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints26.gridx = 0;
    GridBagConstraints gridBagConstraints25 = new GridBagConstraints();
    gridBagConstraints25.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints25.gridwidth = 3;
    gridBagConstraints25.gridx = 1;
    gridBagConstraints25.gridy = 11;
    gridBagConstraints25.ipadx = 130;
    gridBagConstraints25.weightx = 0.0;
    gridBagConstraints25.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints25.insets = new Insets( 2, 6, 2, 0 );
    GridBagConstraints gridBagConstraints24 = new GridBagConstraints();
    gridBagConstraints24.insets = new Insets( 6, 95, 4, 0 );
    gridBagConstraints24.gridy = 12;
    gridBagConstraints24.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints24.gridx = 0;
    GridBagConstraints gridBagConstraints23 = new GridBagConstraints();
    gridBagConstraints23.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints23.gridwidth = 6;
    gridBagConstraints23.gridx = 1;
    gridBagConstraints23.gridy = 12;
    gridBagConstraints23.ipadx = 333;
    gridBagConstraints23.weightx = 0.0;
    gridBagConstraints23.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints23.insets = new Insets( 2, 6, 2, 0 );
    GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
    gridBagConstraints22.insets = new Insets( 6, 86, 3, 0 );
    gridBagConstraints22.gridy = 5;
    gridBagConstraints22.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints22.gridx = 0;
    GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
    gridBagConstraints21.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints21.gridwidth = 3;
    gridBagConstraints21.gridx = 1;
    gridBagConstraints21.gridy = 9;
    gridBagConstraints21.ipadx = 130;
    gridBagConstraints21.weightx = 0.0;
    gridBagConstraints21.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints21.insets = new Insets( 2, 6, 2, 0 );
    GridBagConstraints gridBagConstraints20 = new GridBagConstraints();
    gridBagConstraints20.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints20.gridwidth = 3;
    gridBagConstraints20.gridx = 1;
    gridBagConstraints20.gridy = 10;
    gridBagConstraints20.ipadx = 130;
    gridBagConstraints20.weightx = 0.0;
    gridBagConstraints20.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints20.insets = new Insets( 2, 6, 2, 0 );
    GridBagConstraints gridBagConstraints19 = new GridBagConstraints();
    gridBagConstraints19.insets = new Insets( 6, 83, 3, 0 );
    gridBagConstraints19.gridy = 9;
    gridBagConstraints19.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints19.gridx = 0;
    GridBagConstraints gridBagConstraints18 = new GridBagConstraints();
    gridBagConstraints18.insets = new Insets( 6, 67, 3, 0 );
    gridBagConstraints18.gridy = 8;
    gridBagConstraints18.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints18.gridx = 0;
    GridBagConstraints gridBagConstraints17 = new GridBagConstraints();
    gridBagConstraints17.insets = new Insets( 6, 88, 3, 0 );
    gridBagConstraints17.gridy = 10;
    gridBagConstraints17.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints17.gridx = 0;
    GridBagConstraints gridBagConstraints16 = new GridBagConstraints();
    gridBagConstraints16.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints16.gridwidth = 3;
    gridBagConstraints16.gridx = 1;
    gridBagConstraints16.gridy = 8;
    gridBagConstraints16.ipadx = 130;
    gridBagConstraints16.weightx = 0.0;
    gridBagConstraints16.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints16.insets = new Insets( 2, 6, 2, 0 );
    GridBagConstraints gridBagConstraints15 = new GridBagConstraints();
    gridBagConstraints15.insets = new Insets( 6, 101, 3, 0 );
    gridBagConstraints15.gridy = 6;
    gridBagConstraints15.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints15.gridx = 0;
    GridBagConstraints gridBagConstraints14 = new GridBagConstraints();
    gridBagConstraints14.insets = new Insets( 4, 86, 5, 0 );
    gridBagConstraints14.gridy = 4;
    gridBagConstraints14.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints14.gridx = 0;
    GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
    gridBagConstraints13.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints13.gridwidth = 4;
    gridBagConstraints13.gridx = 2;
    gridBagConstraints13.gridy = 7;
    gridBagConstraints13.ipadx = 249;
    gridBagConstraints13.weightx = 0.0;
    gridBagConstraints13.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints13.insets = new Insets( 2, 2, 2, 0 );
    GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
    gridBagConstraints12.insets = new Insets( 30, 73, 0, 0 );
    gridBagConstraints12.gridy = 0;
    gridBagConstraints12.anchor = GridBagConstraints.SOUTHWEST;
    gridBagConstraints12.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints12.gridx = 0;
    GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
    gridBagConstraints11.insets = new Insets( 4, 86, 5, 0 );
    gridBagConstraints11.gridy = 3;
    gridBagConstraints11.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints11.gridx = 0;
    GridBagConstraints gridBagConstraints10 = new GridBagConstraints();
    gridBagConstraints10.insets = new Insets( 6, 88, 3, 0 );
    gridBagConstraints10.gridy = 7;
    gridBagConstraints10.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints10.gridx = 0;
    GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
    gridBagConstraints9.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints9.gridwidth = 1;
    gridBagConstraints9.gridx = 1;
    gridBagConstraints9.gridy = 7;
    gridBagConstraints9.ipadx = 75;
    gridBagConstraints9.weightx = 0.0;
    gridBagConstraints9.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints9.insets = new Insets( 2, 6, 2, 0 );
    GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
    gridBagConstraints8.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints8.gridx = 1;
    gridBagConstraints8.gridy = 6;
    gridBagConstraints8.ipadx = 42;
    gridBagConstraints8.weightx = 0.0;
    gridBagConstraints8.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints8.insets = new Insets( 2, 6, 2, 0 );
    GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
    gridBagConstraints7.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints7.gridwidth = 6;
    gridBagConstraints7.gridx = 1;
    gridBagConstraints7.gridy = 5;
    gridBagConstraints7.ipadx = 333;
    gridBagConstraints7.weightx = 0.0;
    gridBagConstraints7.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints7.insets = new Insets( 2, 6, 2, 0 );
    GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
    gridBagConstraints6.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints6.gridwidth = 6;
    gridBagConstraints6.gridx = 1;
    gridBagConstraints6.gridy = 4;
    gridBagConstraints6.ipadx = 333;
    gridBagConstraints6.weightx = 0.0;
    gridBagConstraints6.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints6.insets = new Insets( 2, 6, 2, 0 );
    GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
    gridBagConstraints5.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints5.gridwidth = 6;
    gridBagConstraints5.gridx = 1;
    gridBagConstraints5.gridy = 3;
    gridBagConstraints5.ipadx = 333;
    gridBagConstraints5.weightx = 0.0;
    gridBagConstraints5.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints5.insets = new Insets( 2, 6, 2, 0 );
    GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
    gridBagConstraints4.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints4.gridwidth = 6;
    gridBagConstraints4.gridx = 1;
    gridBagConstraints4.gridy = 2;
    gridBagConstraints4.ipadx = 333;
    gridBagConstraints4.weightx = 0.0;
    gridBagConstraints4.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints4.insets = new Insets( 2, 6, 2, 0 );
    GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
    gridBagConstraints3.insets = new Insets( 6, 95, 3, 0 );
    gridBagConstraints3.gridy = 2;
    gridBagConstraints3.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints3.gridx = 0;
    GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
    gridBagConstraints2.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints2.gridwidth = 6;
    gridBagConstraints2.gridx = 1;
    gridBagConstraints2.gridy = 1;
    gridBagConstraints2.ipadx = 333;
    gridBagConstraints2.weightx = 0.0;
    gridBagConstraints2.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints2.insets = new Insets( 2, 6, 2, 0 );
    GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
    gridBagConstraints1.insets = new Insets( 6, 95, 3, 0 );
    gridBagConstraints1.gridy = 1;
    gridBagConstraints1.anchor = GridBagConstraints.NORTHWEST;
    gridBagConstraints1.gridx = 0;
    GridBagConstraints gridBagConstraints = new GridBagConstraints();
    gridBagConstraints.fill = GridBagConstraints.VERTICAL;
    gridBagConstraints.gridwidth = 2;
    gridBagConstraints.gridx = 1;
    gridBagConstraints.gridy = 0;
    gridBagConstraints.ipadx = 72;
    gridBagConstraints.weightx = 0.0;
    gridBagConstraints.anchor = GridBagConstraints.SOUTHWEST;
    gridBagConstraints.insets = new Insets( 30, 6, 0, 0 );
    mnuDuplicate.setText( "Duplizieren" );
    mnuDuplicate.setMnemonic( 'U' );
    mnuDuplicate.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuDuplicate_actionPerformed( e );
      }
    } );
    menFile.insert( mnuDuplicate, 2 );

    mnuBlock.setText( "Sperren" );
    mnuBlock.setMnemonic( 'S' );
    mnuBlock.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuBlock_actionPerformed( e );
      }
    } );
    menFile.insert( mnuBlock, 3 );

    mnuCopyAdresse.setText( "Adresse kopieren" );
    mnuCopyAdresse.setMnemonic( 'O' );
    mnuCopyAdresse.setAccelerator( KeyStroke.getKeyStroke( KeyEvent.VK_K, ActionEvent.CTRL_MASK ) );
    mnuCopyAdresse.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuCopyAdresse_actionPerformed( e );
      }
    } );
    menEdit.addSeparator();
    pnlAdresse.setMinimumSize( new Dimension( 499, 400 ) );
    pnlAdresse.setPreferredSize( new Dimension( 499, 420 ) );
    lblErst.setText( "Ersterfassung:" );
    txfErstBen.setEditable( false );
    txfErstDat.setEditable( false );
    lblGeaend.setText( "letzte Mutation:" );
    txfGeaendBen.setEditable( false );
    txfGeaendDat.setEditable( false );
    menEdit.add( mnuCopyAdresse );

    mnuCopyAdresseDetailPopup.setText( "Adresse kopieren" );
    mnuCopyAdresseDetailPopup.setMnemonic( 'O' );
    mnuCopyAdresseDetailPopup.setAccelerator( KeyStroke.getKeyStroke( KeyEvent.VK_K, ActionEvent.CTRL_MASK ) );
    mnuCopyAdresseDetailPopup.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuCopyAdresse_actionPerformed( e );
      }
    } );
    popDetail.addSeparator();
    popDetail.add( mnuCopyAdresseDetailPopup );

    mnuCopyAdresseLookupPopup.setText( "Adresse kopieren" );
    mnuCopyAdresseLookupPopup.setMnemonic( 'O' );
    mnuCopyAdresseLookupPopup.setAccelerator( KeyStroke.getKeyStroke( KeyEvent.VK_K, ActionEvent.CTRL_MASK ) );
    mnuCopyAdresseLookupPopup.addActionListener( new java.awt.event.ActionListener()
    {
      public void actionPerformed( ActionEvent e )
      {
        mnuCopyAdresse_actionPerformed( e );
      }
    } );

    lblZeile1.setToolTipText( "" );
    lblZeile1.setText( "Name:" );
    lblName.setToolTipText( "" );
    lblName.setText( "Name:" );
    lblLandCd.setText( "Land:" );
    lblPlzOrt.setToolTipText( "" );
    lblPlzOrt.setText( "PLZ/Ort:" );
    lblZeile2.setText( "Strasse:" );
    lblAdrNr.setText( "Adress-Nr:" );
    lblZeile3.setToolTipText( "" );
    lblZeile3.setText( "Strasse:" );
    lblZeile4.setText( "Strasse:" );

    pnlAdresse.setLayout( new GridBagLayout() );
    pnlAdresse.setBorder( new TitledBorder( "Versandadresse" ) );

    lblSuchbegr.setText( "Suchbegriff:" );
    lblSuchbegr.setToolTipText( "" );
    lblSprachCd.setText( "Sprache:" );
    lblSprachCd.setToolTipText( "" );
    lblTelefon.setText( "Telefon:" );
    lblTelefon.setToolTipText( "" );
    lblFax.setText( "Fax:" );
    lblEMail.setText( "E-Mail:" );
    lblEMail.setToolTipText( "" );
    lblGesperrt.setText( "Gesperrt:" );
    txfAdrNr.setEditable( false );
    txfName.setEditable( false );
    txfZeile1.setEditable( false );
    txfZeile2.setEditable( false );
    txfZeile3.setEditable( false );
    txfZeile4.setEditable( false );
    txfLandCd.setEditable( false );
    txfPlz.setEditable( false );
    txfOrt.setEditable( false );
    txfSuchbegr.setEditable( false );
    txfTelefon.setEditable( false );
    txfEMail.setEditable( false );
    txfSprachCd.setEditable( false );
    txfFax.setEditable( false );
    ckbGesperrt.setEnabled( false );

    lblTaxClass.setText( "MwSt-Klassifikation:" );
    lblCustGroup.setText( "Deponentenkonto:" );
    txfTaxClass.setEditable( false );
    lblCustGrp1.setText( "Bescheinigung:" );
    ckbCustGroup.setEnabled( false );
    ckbCustGrp1.setEnabled( false );

    pnlAdresse.add( txfAdrNr, gridBagConstraints );
    pnlAdresse.add( lblName, gridBagConstraints1 );
    pnlAdresse.add( txfName, gridBagConstraints2 );
    pnlAdresse.add( lblZeile1, gridBagConstraints3 );
    pnlAdresse.add( txfZeile1, gridBagConstraints4 );
    pnlAdresse.add( txfZeile2, gridBagConstraints5 );
    pnlAdresse.add( txfZeile3, gridBagConstraints6 );
    pnlAdresse.add( txfZeile4, gridBagConstraints7 );
    pnlAdresse.add( txfLandCd, gridBagConstraints8 );
    pnlAdresse.add( txfPlz, gridBagConstraints9 );
    pnlAdresse.add( lblPlzOrt, gridBagConstraints10 );
    pnlAdresse.add( lblZeile2, gridBagConstraints11 );
    pnlAdresse.add( lblAdrNr, gridBagConstraints12 );
    pnlAdresse.add( txfOrt, gridBagConstraints13 );
    pnlAdresse.add( lblZeile3, gridBagConstraints14 );
    pnlAdresse.add( lblLandCd, gridBagConstraints15 );
    pnlAdresse.add( txfSuchbegr, gridBagConstraints16 );
    pnlAdresse.add( lblTelefon, gridBagConstraints17 );
    pnlAdresse.add( lblSuchbegr, gridBagConstraints18 );
    pnlAdresse.add( lblSprachCd, gridBagConstraints19 );
    pnlAdresse.add( txfTelefon, gridBagConstraints20 );
    pnlAdresse.add( txfSprachCd, gridBagConstraints21 );
    pnlAdresse.add( lblZeile4, gridBagConstraints22 );
    pnlAdresse.add( txfEMail, gridBagConstraints23 );
    pnlAdresse.add( lblEMail, gridBagConstraints24 );
    pnlAdresse.add( txfFax, gridBagConstraints25 );
    pnlAdresse.add( lblGesperrt, gridBagConstraints26 );
    pnlAdresse.add( ckbGesperrt, gridBagConstraints27 );
    pnlAdresse.add( txfErstBen, gridBagConstraints28 );
    pnlAdresse.add( txfErstDat, gridBagConstraints29 );
    pnlAdresse.add( lblGeaend, gridBagConstraints30 );
    pnlAdresse.add( txfGeaendBen, gridBagConstraints31 );
    pnlAdresse.add( txfGeaendDat, gridBagConstraints32 );
    pnlAdresse.add( lblFax, gridBagConstraints33 );
    pnlAdresse.add( lblErst, gridBagConstraints34 );
    pnlAdresseSap.setLayout( new GridBagLayout() );
    pnlAdresseSap.setBorder( new TitledBorder( "Adresse SAP" ) );
    pnlAdresseSap.add( lblTaxClass, gridBagConstraints110 );
    pnlAdresseSap.add( txfTaxClass, gridBagConstraints210 );
    pnlAdresseSap.add( lblCustGroup, gridBagConstraints35 );
    pnlAdresseSap.add( ckbCustGroup, gridBagConstraints41 );
    pnlAdresseSap.add( lblCustGrp1, gridBagConstraints51 );
    pnlAdresseSap.add( ckbCustGrp1, gridBagConstraints61 );
    pnlMain.setLayout( new BorderLayout() );
    pnlMain.add( pnlAdresse, BorderLayout.NORTH );
    pnlMain.add( pnlAdresseSap, BorderLayout.CENTER );
    centerPanel.add( pnlMain, BorderLayout.CENTER );

  } // jbInit

  //********** Öffentliche Standard-Methoden *******************************

  // gibt den Titel zurück
  public String getTitle()
  {
    return "Versandadresse Detail";
  }

  /**
   *  setzt den Schlüssel
   * @param adrNr
   */
  public void setKey( Integer adrNr )
  {
    this.adrNr = adrNr;
  }

  //********** Lokale Standard-Methoden **********************************

  //********** Ereignisbehandlung zu Menus *******************************

  protected void mnuDelete_actionPerformed( ActionEvent e )
  {
    if ( DeleteDialog.showDeleteDialog( mainController.getWindow() ) )
    {
      VersadrCheckVO versAdrCheckVO = new VersadrCheckVO( adrNr.intValue() );
      // Ja, Daten löschen
      try
      {
        versAdrCheckVO = new SapAdresse().check( versAdrCheckVO );
        if ( versAdrCheckVO.openOrder.booleanValue() == false )
        {
          AdresseDelegate.getInstance().removeVersadr( adrNr.intValue() );
        }
        else
        {
          String message = "Die Adresse kann zur Zeit nicht gelöscht werden.\n" + versAdrCheckVO.openOrderMsg;
          JOptionPane.showMessageDialog( mainController.getWindow(), message, "Hinweis", JOptionPane.INFORMATION_MESSAGE );
        }
      }
      catch ( SapCallException sapex )
      {
        LOG.error( sapex );
        JOptionPane.showMessageDialog( mainController.getWindow(), sapex.getUserMessage() + " \n" + sapex.getDetailMessage(), "Fehler",
            JOptionPane.ERROR_MESSAGE );
      }
      catch ( Exception ex )
      {
        LOG.error( ex );
        String message = xxMessage.getMessage( ex );
        JOptionPane.showMessageDialog( mainController.getWindow(), message, "Fehler", JOptionPane.ERROR_MESSAGE );
        return;
      }
      mainController.back();
    }
  }

  // liest die Daten von der Datenbank
  public void read()
  {
    // Daten lesen
    VersadrVO versadrVO;
    try
    {
      versadrVO = AdresseDelegate.getInstance().getVersadr( adrNr.intValue() );
    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      String message = xxMessage.getMessage( ex );
      JOptionPane.showMessageDialog( mainController.getWindow(), message, "Fehler", JOptionPane.ERROR_MESSAGE );
      return;
    }

    if ( versadrVO.getGesperrt() == 1 )
    {
      mnuBlock.setText( "Sperrung aufheben" );
    }
    else
    {
      mnuBlock.setText( "Sperren" );
    }
    // Mutiern ist nur möglich, wenn nicht gesperrt
    mnuEdit.setEnabled( versadrVO.getGesperrt() == 0 );
    btnEdit.setEnabled( versadrVO.getGesperrt() == 0 );
    txfAdrNr.setText( "" + versadrVO.getAdrNr() );
    txfSuchbegr.setText( versadrVO.getSuchbegrOrEmptyStr() );
    txfSprachCd.setText( versadrVO.getSprachCdOrEmptyStr() );
    txfName.setText( versadrVO.getNameOrEmptyStr() );
    txfZeile1.setText( versadrVO.getZeile1OrEmptyStr() );
    txfZeile2.setText( versadrVO.getZeile2OrEmptyStr() );
    txfZeile3.setText( versadrVO.getZeile3OrEmptyStr() );
    txfZeile4.setText( versadrVO.getZeile4OrEmptyStr() );
    txfLandCd.setText( versadrVO.getLandCdOrEmptyStr() );
    txfPlz.setText( versadrVO.getPlzOrEmptyStr() );
    txfOrt.setText( versadrVO.getOrtOrEmptyStr() );
    txfTelefon.setText( versadrVO.getTelefonOrEmptyStr() );
    txfFax.setText( versadrVO.getFaxOrEmptyStr() );
    txfEMail.setText( versadrVO.getEmailNameDomainOrEmptyStr() );
    ckbGesperrt.setSelected( versadrVO.getGesperrt() == 1 );
    txfErstBen.setText( versadrVO.getErstBenOrEmptyStr() );
    txfErstDat.setText( IGEDate.dateToString( versadrVO.getErstDat() ) );
    txfGeaendBen.setText( versadrVO.getGeaendBenOrEmptyStr() );
    txfGeaendDat.setText( IGEDate.dateToString( versadrVO.getGeaendDat() ) );

    switch( versadrVO.getTaxClassOrEmptyStr().charAt( 0 ) )
    {
      case '0':
        txfTaxClass.setText( "steuerbefreit" );
        break;
      case '1':
        txfTaxClass.setText( "steuerpflichtig" );
        break;
      case '6':
        txfTaxClass.setText( "internationale Organisation" );
        break;
    }
    ckbCustGroup.setSelected( versadrVO.getCustGroup().equals( "01" ) );
    ckbCustGrp1.setSelected( versadrVO.getCustGrp1OrEmptyStr().equals( "001" ) );
    setStatusBar( "Daten gelesen !" );
  } // read

  //********** Menu Hilfe **************************************************

  protected void mnuInfo_actionPerformed( ActionEvent e )
  {
    new CustomDlgInfo( (JFrame) this.mainController.getWindow(), true ).setVisible( true );
  }

  //********** Popup-Menu **************************************************

  //********** Pane-spezifische Methoden ***********************************

  protected void mnuNew_actionPerformed( ActionEvent e )
  {
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.WAIT_CURSOR ) );
    statusBar.setText( " " );
    AdresseWizard aw = new AdresseWizard( (Frame) mainController.getWindow() );
    Integer adrNr;
    try
    {
      adrNr = aw.newVersadr();
    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      String message = xxMessage.getMessage( ex );
      JOptionPane.showMessageDialog( mainController.getWindow(), message, "Fehler", JOptionPane.ERROR_MESSAGE );
      mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
      return;
    }
    if ( adrNr == null )
    {
      //Erfassen wurde abgebrochen.
      String message = xxMessage.getMessage( 1033 );
      statusBar.setText( message );
    }
    else
    {
      setKey( adrNr );
      read();
      // Datensatz gespeichert.
      String message = xxMessage.getMessage( 1004 );
      setStatusBar( message );
    }
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
  }

  protected void mnuEdit_actionPerformed( ActionEvent e )
  {
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.WAIT_CURSOR ) );
    statusBar.setText( " " );
    AdresseWizard aw = new AdresseWizard( (Frame) mainController.getWindow() );
    boolean edit = false;
    try
    {
      edit = aw.editVersadr( adrNr.intValue() );
    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      String message = xxMessage.getMessage( ex );
      JOptionPane.showMessageDialog( mainController.getWindow(), message, "Fehler", JOptionPane.ERROR_MESSAGE );
      return;
    }
    if ( edit )
    {
      read();
      // Datensatz gespeichert.
      String message = xxMessage.getMessage( 1004 );
      setStatusBar( message );
    }
    else
    {
      // Mutieren wurde abgebrochen
      String message = xxMessage.getMessage( 1034 );
      statusBar.setText( message );
    }
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
  }

  protected void mnuDuplicate_actionPerformed( ActionEvent e )
  {
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.WAIT_CURSOR ) );
    statusBar.setText( " " );
    AdresseWizard aw = new AdresseWizard( (Frame) mainController.getWindow() );
    Integer duplicateAdrNr;
    try
    {
      duplicateAdrNr = aw.duplicateVersadr( adrNr.intValue() );
    }
    catch ( Exception ex )
    {
      LOG.error( ex );
      String message = xxMessage.getMessage( ex );
      JOptionPane.showMessageDialog( mainController.getWindow(), message, "Fehler", JOptionPane.ERROR_MESSAGE );
      mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
      return;
    }
    if ( duplicateAdrNr == null )
    {
      // Duplizieren wurde abgebrochen
//      String message = xxMessage.getMessage(1035);
      statusBar.setText( "" );
    }
    else
    {
      setKey( duplicateAdrNr );
      read();
      // Datensatz gespeichert.
      String message = xxMessage.getMessage( 1004 );
      setStatusBar( message );
    }
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
  }

  protected void mnuBlock_actionPerformed( ActionEvent e )
  {
    VersadrCheckVO versAdrCheckVO = new VersadrCheckVO( adrNr.intValue() );
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.WAIT_CURSOR ) );
    String msg;
    if ( ckbGesperrt.isSelected() )
    {
      msg = "Wollen Sie die Sperrung dieser Versandadresse wirklich aufheben?";
    }
    else
    {
      msg = "Wollen Sie diese Versandadresse wirklich sperren?";
    }
    Object[] options = { "OK", "Abbrechen" };
    int selectedOption = JOptionPane.showOptionDialog( mainController.getWindow(), msg, "Warnung", JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
        null, options, options[1] );
    if ( selectedOption == 0 )
    {
      // Ja, Daten löschen
      try
      {
        versAdrCheckVO = new SapAdresse().check( versAdrCheckVO );
        if ( versAdrCheckVO.openOrder.booleanValue() == false )
        {
          String geaendBen = AuthMain.getInstance().getSubject().getInitials();
          AdresseDelegate.getInstance().blockVersadr( adrNr.intValue(), !ckbGesperrt.isSelected(), geaendBen );
        }
        else
        {
          String message = "Die Adresse kann zur Zeit nicht gesperrt werden.\n" + versAdrCheckVO.openOrderMsg;
          JOptionPane.showMessageDialog( mainController.getWindow(), message, "Hinweis", JOptionPane.INFORMATION_MESSAGE );
        }
      }
      catch ( SapCallException sapex )
      {
        LOG.error( sapex );
        JOptionPane.showMessageDialog( mainController.getWindow(), sapex.getUserMessage() + " \n" + sapex.getDetailMessage(), "Fehler",
            JOptionPane.ERROR_MESSAGE );
      }
      catch ( Exception ex )
      {
        LOG.error( ex );
        String message = xxMessage.getMessage( ex );
        JOptionPane.showMessageDialog( mainController.getWindow(), message, "Fehler", JOptionPane.ERROR_MESSAGE );
        return;
      }
    }
    read();
    // Daten gelesen !
    String message = xxMessage.getMessage( 21 );
    statusBar.setText( message );
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
  }

  protected void mnuRefresh_actionPerformed( ActionEvent e )
  {
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.WAIT_CURSOR ) );
    read();
    // Daten gelesen !
    String message = xxMessage.getMessage( 21 );
    statusBar.setText( message );
    mainController.getWindow().setCursor( Cursor.getPredefinedCursor( Cursor.DEFAULT_CURSOR ) );
  }

  protected void mnuCopyAdresse_actionPerformed( ActionEvent e )
  {
    StringBuffer sb = new StringBuffer();
    if ( !txfName.getText().equals( "" ) )
    {
      sb.append( txfName.getText() + "\n" );
    }
    if ( !txfZeile1.getText().equals( "" ) )
    {
      sb.append( txfZeile1.getText() + "\n" );
    }
    if ( !txfZeile2.getText().equals( "" ) )
    {
      sb.append( txfZeile2.getText() + "\n" );
    }
    if ( !txfZeile3.getText().equals( "" ) )
    {
      sb.append( txfZeile3.getText() + "\n" );
    }
    if ( !txfZeile4.getText().equals( "" ) )
    {
      sb.append( txfZeile4.getText() + "\n" );
    }
    if ( !txfPlz.getText().equals( "" ) )
    {
      sb.append( txfPlz.getText() + " " );
    }
    if ( !txfOrt.getText().equals( "" ) )
    {
      sb.append( txfOrt.getText() + "\n" );
    }
    StringSelection ss = new StringSelection( sb.toString() );
    getToolkit().getSystemClipboard().setContents( ss, ss );
  }

  /**
   * @param text Text
   */
  public void setStatusBar( String text )
  {
    statusBar.setText( text );
  }

  //********** Popup-Menu **************************************************

  protected void centerPanel_mouseReleased( MouseEvent e )
  {
    if ( e.isPopupTrigger() )
    {
      if ( mode == DETAIL )
      {
        popDetail.show( this, e.getX(), e.getY() );
      }
      else
      {
        popLookup = new JPopupMenu();
        if ( mode == DETAIL_LOOKUP || mode == DETAIL_LOOKUP_OK )
        {
          popLookup.add( mnuOkLookupPopup );
        }
        if ( mode == DETAIL_LOOKUP )
        {
          popLookup.add( mnuCancelLookupPopup );
        }
        popLookup.addSeparator();
        if ( mode == DETAIL_LOOKUP || mode == DETAIL_LOOKUP_OK )
        {
          popLookup.add( mnuBackLookupPopup );
        }
        if ( mode == DETAIL_LOOKUP_OK && mnuForwardLookupPopup.isEnabled() )
        {
          popLookup.add( mnuForwardLookupPopup );
        }
        popLookup.add( mnuHomeLookupPopup );
        popLookup.addSeparator();
        popLookup.add( mnuCopyLookupPopup );
        popLookup.addSeparator();
        popLookup.add( mnuCopyAdresseLookupPopup );
        popLookup.show( this, e.getX(), e.getY() );
      }
    }
    else
    {
      super.processMouseEvent( e );
    }
  }

  //********** Authorization ***************************************************

  /**
   * @return Authorization
   */
  public static String[] getAuthzSpecifications()
  {
    return new String[] { "*New       = Schreiben/VersandAdressen", "*Edit      = Schreiben/VersandAdressen", "*Delete    = Schreiben/VersandAdressen",
        "*Duplicate = Schreiben/VersandAdressen", "*Block     = Schreiben/VersandAdressen" };
  }

  /**
  * Initialisiert JavaHelp
  */
  public void initHelp()
  {
    HelpUtil.getInstance().enableHelpKey( this.getRootPane(), "allgHilfe" );

    HelpUtil.getInstance().enableHelpOnButton( btnHelp, "allgHilfe" );
    HelpUtil.getInstance().enableHelpOnButton( mnuHelp, "allgHilfe" );

    HelpUtil.getInstance().enableHelp( toolBar, "icons" );
    HelpUtil.getInstance().enableHelp( menuBar, "auswahlmenues" );
  }
} // AdresseDtl
