package ch.ige.adr.client;

import javax.swing.table.AbstractTableModel;

import ch.ige.adr.vo.AdresseAVO;

/**
 *  Table Model für Auswahl der Versandadresse
 * <p>
 * Copyright (c) 2001, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Ueli Ryser
 * @version $Id: AdresseTableModel.java,v 1.10 2006/12/11 16:27:00 nydegger Exp $
 */
public class AdresseTableModel extends AbstractTableModel
{
  final String[] columnNames = new String[]
   { "Adress-Nr.", "Suchbegriff", "Name", "Strasse", "PLZ", "Ort", "Land" };
  AdresseAVO[] tableData = new AdresseAVO[]{};

  /**
   * aus AbstractTableModel
   */
  public int getColumnCount() { return columnNames.length; }

  /**
   * aus AbstractTableModel
   */
  public int getRowCount() { return tableData.length; }

  /**
   * aus AbstractTableModel
   */
  public String getColumnName(int column) { return columnNames[column]; }

  /**
   * aus AbstractTableModel
   */
  public Class getColumnClass(int column)
  {
    if (column == 0)
    {
      return Integer.class;
    }
    else
    {
      return Object.class;
    }
  }

  /**
   * aus AbstractTableModel
   */
  public Object getValueAt(int row, int col)
  {
    switch (col)
    {
      case 0 : return new Integer(tableData[row].adrNr);
      case 1 : return tableData[row].suchbegr;
      case 2 : return tableData[row].name;
      case 3 : return tableData[row].strasse;
      case 4 : return tableData[row].plz;
      case 5 : return tableData[row].ort;
      case 6 : return tableData[row].landCd;
    }
    return null;
  }

  /**
   * Daten übergeben
   * @param data AdresseAVO
   */
  public void setData(AdresseAVO[] data) {
    tableData = data;
    fireTableDataChanged();
  }

  /**
   * Daten in TableModel löschen
   */
  public void clear() {
    tableData = new AdresseAVO[]{};
    fireTableDataChanged();
  }
}
