package ch.ige.adr.client;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * <p>Überschrift: EmailVerifier </p>
 * <p>Beschreibung: Validiert eine Email-Adresse auf Ihre syntaktische Gültigkeit</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Organisation: Eidgenössisches Institut für Geistiges Eigentum </p>
 * @author Stefan Nydegger
 * @version $Id: EmailVerifier.java,v 1.6 2006/12/11 15:17:28 nydegger Exp $
 */

public class EmailVerifier
{

  /**
   * Verfiziert eine Email-Adresse auf syntaktische Gültigkeit
   * Es sind nicht nur ASCII-Zeichen zugelassen, sondern auch äöü usw.
   * Gültige Emailadressen sind z.B.:
   * - höldriä@gügüs.ch
   * - administrator@at.admin.com
   * Ungültige Email-Adressen sind z.B.:
   * - administrator@admincom
   * - administrator@a.
   * @param input String Email-Adresse als String
   * @return boolean ist true, wenn Email-Adresse gültig ist
   */
  public static boolean verifyEmail(String input)
  {
    Pattern pat = Pattern.compile(".+@.+\\.[a-z]+");
    Matcher matcher = pat.matcher(input);
    return matcher.find();
  }
}
