package ch.ige.adr.client;

import javax.swing.table.AbstractTableModel;

import ch.ige.adr.vo.LandAVO;

/**
 * Table Model für Auswahl des Landes
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Ueli Ryser
 * @version $Id: LandTableModel.java,v 1.9 2006/12/11 16:27:00 nydegger Exp $
 */
public class LandTableModel extends AbstractTableModel
{
  final String[] columnNames = new String[]
   { "Land Code", "Bezeichnung" };
  LandAVO[] tableData = new LandAVO[]{};

  /**
   * aus AbstractTableModel
   */
  public int getColumnCount() { return columnNames.length; }

  /**
   * aus AbstractTableModel
   */
  public int getRowCount() { return tableData.length; }

  /**
   * aus AbstractTableModel
   */
  public String getColumnName(int column) { return columnNames[column]; }

  /**
   * aus AbstractTableModel
   */
  public Object getValueAt(int row, int col)
  {
    switch (col)
    {
      case 0 : return tableData[row].landCd;
      case 1 : return tableData[row].landBez;
    }
    return null;
  }

  /**
   * Daten übergeben
   * @param data
   */
  public void setData(LandAVO[] data) {
    tableData = data;
    fireTableDataChanged();
  }

  /**
   * Daten in TableModel löschen
   */
  public void clear() {
    tableData = new LandAVO[]{};
    fireTableDataChanged();
  }
}
