package ch.ige.adr.client;

import java.awt.event.ActionEvent;

import javax.swing.JFrame;

import ch.ige.adrhelp.HelpUtil;
import ch.ige.main.client.MainController;
import ch.ige.main.client.MenuPane;

/**
 * <p>Überschrift: Einstiegsfenster abgeleitet von MenuPane</p>
 * <p>Beschreibung: Applikationsspezifische Eigenschaften setzten bzw. überschreiben</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Organisation: Institut für Geistiges Eigentum</p>
 * @author Anita Rueegsegger
 * @version $Id: MenuPaneAdr.java,v 1.13 2008/04/28 15:32:34 galli Exp $
 */

public class MenuPaneAdr extends MenuPane
{

  /**
   * constructor
   */
  public MenuPaneAdr()
  {
    super();
  }

  /**
   * Komponente erstellen
   * @param mainController Frame
   * @param mode Modus
   */
  public MenuPaneAdr( MainController mainController, int mode )
  {
    super( mainController, mode );
    initHelp();
  }

  /**
   * gibt den Titel zurück
   * @return Titel
   */
  public String getTitle()
  {
    return "Adresse Hauptmenü";
  }

  /**
   * Info-Fenster anzeigen
   * @param e ActionEvent
   */
  protected void mnuInfo_actionPerformed( ActionEvent e )
  {
    new CustomDlgInfo( (JFrame) this.mainController.getWindow(), true ).setVisible( true );
  }

  /**
   * initialisiert javahelp
   */
  public void initHelp()
  {
    HelpUtil.getInstance().enableHelpKey( this, "einfuehrung" );

    HelpUtil.getInstance().enableHelpOnButton( btnHelp, "einfuehrung" );
    HelpUtil.getInstance().enableHelpOnButton( mnuHelp, "einfuehrung" );

    HelpUtil.getInstance().enableHelp( toolBar, "icons" );
    HelpUtil.getInstance().enableHelp( menFile, "auswahlmenues" );
    HelpUtil.getInstance().enableHelp( splitPane, "allgHilfe.verwaltungsframe" );
  }
}
