package ch.ige.adr.client;

import javax.swing.table.AbstractTableModel;

import ch.ige.adr.vo.PostOrtAVO;

/**
 * Table Model für Adresse Auswahl
 * <p>
 * Copyright (c) 2001, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Ueli Ryser
 * @version $Id: PlzOrtTableModel.java,v 1.8 2006/12/11 15:17:28 nydegger Exp $
 */
public class PlzOrtTableModel extends AbstractTableModel
{
  final String[] columnNames = new String[] {"PLZ", "Ort"};
  PostOrtAVO[] tableData = new PostOrtAVO[] {};

  /**
   * @see AbstractTableModel
   */
  public int getColumnCount() { return columnNames.length; }

  /**
   * @see AbstractTableModel
   */
  public int getRowCount() { return tableData.length; }

  /**
   * @see AbstractTableModel
   */
  public String getColumnName(int column) { return columnNames[column]; }

  /**
   * @see AbstractTableModel
   */
  public Object getValueAt(int row, int col)
  {
    switch (col)
    {
      case 0 : return tableData[row].plz;
      case 1 : return tableData[row].ort;
    }
    return null;
  }

  /**
   * Daten übergeben
   * @param data Array mit Postleitzahlen und Ortschaften
   */
  public void setData(PostOrtAVO[] data)
  {
    tableData = data;
    fireTableDataChanged();
  }
}
