package ch.ige.adr.client;

import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;

import javax.swing.InputVerifier;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.ScrollPaneConstants;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.border.TitledBorder;
import javax.swing.event.DocumentEvent;

import org.apache.log4j.Logger;

import ch.ige.adr.server.AdresseDelegate;
import ch.ige.adr.vo.AdresseSelKritVO;
import ch.ige.main.client.MainController;
import ch.ige.main.client.MainRootPane;
import ch.ige.main.client.WizardObsConst;
import ch.ige.main.client.XxMessage;
import ch.ige.util.client.LimitedDocument;
import ch.ige.util.vo.RegadrVO;



/**
 * Panel für das Erfassen und Mutieren der Registeradresse
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Ueli Ryser
 * @version $Id: PnlRegadr.java,v 1.44 2007/12/13 10:13:24 galli Exp $
 */

public class PnlRegadr extends PnlAbstract
{
  // Logging
  private static final Logger LOG = Logger.getLogger(PnlRegadr.class);
  protected static final int VK_CONTROL_AND_SHIFT_DOWN = 192;

  // Applikationsmeldungen
  protected XxMessage xxMessage = null;

  protected RegadrVO regadrVO = null;

  protected JLabel lblRegOrt = new JLabel();
  protected JLabel lblAdrNr = new JLabel();
  protected JTextField txfBlandCd = new JTextField();
  protected JLabel lblRegStrasse = new JLabel();
  protected JScrollPane scpRegStrasse = new JScrollPane();
  protected JTextField txfRegadrNr = new JTextField();
  protected JScrollPane scpRegOrt = new JScrollPane();
  protected JLabel lblGesperrt = new JLabel();
  protected JTextArea txaUpVerzName = new JTextArea();
  protected JScrollPane scpRegName = new JScrollPane();
  protected JTextArea txaRegName = new JTextArea();
  protected JLabel lblRegName = new JLabel();
  protected JTextArea txaRegOrt = new JTextArea();
  protected JCheckBox ckbGesperrt = new JCheckBox();
  protected JTextArea txaRegStrasse = new JTextArea();
  protected JLabel lblRegadrNr = new JLabel();
  protected JLabel lblBlandCd = new JLabel();
  protected JTextField txfAdrNr = new JTextField();
  protected JLabel lblVerzName = new JLabel();
  protected JScrollPane scpUpVerzName = new JScrollPane();

  protected LimitedDocument ldoSortiername = new LimitedDocument();
  protected LimitedDocument ldoRegName = new LimitedDocument();
  protected LimitedDocument ldoRegStrasse = new LimitedDocument();
  protected LimitedDocument ldoRegOrt = new LimitedDocument();
  protected LimitedDocument ldoLand = new LimitedDocument();
  protected LimitedDocument ldoAdrNr = new LimitedDocument();
  protected JButton btnBlandCd = new JButton();
  protected InputVerifier blandCdInputVerifier = new BlandCdInputVerifier();
  protected JButton btnAdrNr = new JButton();
  protected InputVerifier adrNrInputVerifier = new AdrNrInputVerifier();
  protected boolean adrGesucht = false;
  protected boolean edit = false;
  GridBagLayout gridBagLayout1 = new GridBagLayout();

  /**
   * constructor
   */
  public PnlRegadr()
  {
    super();
    focusOwner = txaRegName;
    try
    {
      xxMessage = XxMessage.getInstance();
      jbInit();

    }
    catch(Exception ex)
    {
      LOG.error(ex);
      JOptionPane.showMessageDialog(parentWindow, ex.getMessage(),
                                    "Fehler", JOptionPane.ERROR_MESSAGE);
    }
  }

  /**
   * Obligatorische Initialisierungsmethode für JBuilder-Desiger
   * @throws Exception
   */
  protected void jbInit() throws Exception
  {
    scpRegStrasse.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
    lblRegStrasse.setMaximumSize(new Dimension(136, 15));
    lblRegStrasse.setMinimumSize(new Dimension(136, 15));
    lblRegStrasse.setPreferredSize(new Dimension(136, 15));
    lblRegStrasse.setHorizontalAlignment(SwingConstants.RIGHT);
    lblRegStrasse.setHorizontalTextPosition(SwingConstants.RIGHT);
    lblRegStrasse.setText("Registerstrasse:");
    lblAdrNr.setMaximumSize(new Dimension(136, 15));
    lblAdrNr.setMinimumSize(new Dimension(136, 15));
    lblAdrNr.setPreferredSize(new Dimension(136, 15));
    lblAdrNr.setHorizontalAlignment(SwingConstants.RIGHT);
    lblAdrNr.setHorizontalTextPosition(SwingConstants.RIGHT);
    lblAdrNr.setText("Versandadress-Nr:");
    lblRegOrt.setText("Registerort:");
    lblRegOrt.setMaximumSize(new Dimension(136, 15));
    lblRegOrt.setMinimumSize(new Dimension(136, 15));
    lblRegOrt.setPreferredSize(new Dimension(136, 15));
    lblRegOrt.setToolTipText("");
    lblRegOrt.setHorizontalAlignment(SwingConstants.RIGHT);
    lblRegOrt.setHorizontalTextPosition(SwingConstants.RIGHT);
    txfRegadrNr.setEditable(false);
    this.setLayout(gridBagLayout1);
    this.setBorder(new TitledBorder("Registeradresse"));
    scpRegOrt.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
    lblGesperrt.setMaximumSize(new Dimension(136, 15));
    lblGesperrt.setMinimumSize(new Dimension(136, 15));
    lblGesperrt.setPreferredSize(new Dimension(136, 15));
    lblGesperrt.setHorizontalAlignment(SwingConstants.RIGHT);
    lblGesperrt.setHorizontalTextPosition(SwingConstants.RIGHT);
    lblGesperrt.setText("gesperrt:");
    scpRegName.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
    lblRegName.setMaximumSize(new Dimension(136, 15));
    lblRegName.setMinimumSize(new Dimension(136, 15));
    lblRegName.setToolTipText("");
    lblRegName.setHorizontalAlignment(SwingConstants.RIGHT);
    lblRegName.setHorizontalTextPosition(SwingConstants.RIGHT);
    lblRegName.setText("Registername:");
    lblRegadrNr.setMaximumSize(new Dimension(136, 15));
    lblRegadrNr.setMinimumSize(new Dimension(136, 15));
    lblRegadrNr.setHorizontalAlignment(SwingConstants.RIGHT);
    lblRegadrNr.setHorizontalTextPosition(SwingConstants.RIGHT);
    lblRegadrNr.setText("Registeradress-Nr:");
    lblBlandCd.setMaximumSize(new Dimension(136, 15));
    lblBlandCd.setMinimumSize(new Dimension(136, 15));
    lblBlandCd.setPreferredSize(new Dimension(136, 15));
    lblBlandCd.setToolTipText("");
    lblBlandCd.setHorizontalAlignment(SwingConstants.RIGHT);
    lblBlandCd.setHorizontalTextPosition(SwingConstants.RIGHT);
    lblBlandCd.setText("Land:");
    lblVerzName.setMaximumSize(new Dimension(136, 15));
    lblVerzName.setMinimumSize(new Dimension(136, 15));
    lblVerzName.setPreferredSize(new Dimension(136, 15));
    lblVerzName.setHorizontalAlignment(SwingConstants.RIGHT);
    lblVerzName.setHorizontalTextPosition(SwingConstants.RIGHT);
    lblVerzName.setText("Sortiername:");
    scpUpVerzName.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
    btnBlandCd.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        btnBlandCd_actionPerformed(e);
      }
    });
    btnBlandCd.setRequestFocusEnabled(false);
    btnBlandCd.setText("...");
    btnAdrNr.setText("...");
    btnAdrNr.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        btnAdrNr_actionPerformed(e);
      }
    });
    ldoAdrNr.addDocumentListener(new javax.swing.event.DocumentListener()
    {
      public void insertUpdate(DocumentEvent e)
      {
        ldoAdrNr_insertUpdate(e);
      }
      public void removeUpdate(DocumentEvent e)
      {
        ldoAdrNr_removeUpdate(e);
      }
      public void changedUpdate(DocumentEvent e)
      {
        ldoAdrNr_changedUpdate(e);
      }
    });

    // KeyAdapters
    txaRegName.setFocusTraversalKeysEnabled(false);
    txaRegName.addKeyListener(new java.awt.event.KeyAdapter()
    {
      public void keyPressed(KeyEvent e)
      {
        if (e.getModifiersEx() == InputEvent.CTRL_DOWN_MASK)
        {
          if (e.getKeyCode() == KeyEvent.VK_TAB)
          {
            txaRegStrasse.requestFocus();
          }
        }
        if (e.getModifiersEx() == VK_CONTROL_AND_SHIFT_DOWN)
        {
          if (e.getKeyCode() == KeyEvent.VK_TAB)
          {
            ckbGesperrt.requestFocus();
          }
        }

      }
    });
    addCharsetVerifier( txaRegName );

    txaRegStrasse.setFocusTraversalKeysEnabled(false);
    txaRegStrasse.addKeyListener(new java.awt.event.KeyAdapter()
    {
      public void keyPressed(KeyEvent e)
      {
        if (e.getModifiersEx() == InputEvent.CTRL_DOWN_MASK)
        {
          if (e.getKeyCode() == KeyEvent.VK_TAB)
          {
            txaRegOrt.requestFocus();
          }
        }
        if (e.getModifiersEx() == VK_CONTROL_AND_SHIFT_DOWN)
        {
          if (e.getKeyCode() == KeyEvent.VK_TAB)
          {
            txaRegName.requestFocus();
          }
        }
      }
    });
    addCharsetVerifier( txaRegStrasse );

    txaRegOrt.setFocusTraversalKeysEnabled(false);
    txaRegOrt.addKeyListener(new java.awt.event.KeyAdapter()
    {
      public void keyPressed(KeyEvent e)
      {
        if (e.getModifiersEx() == InputEvent.CTRL_DOWN_MASK)
        {
          if (e.getKeyCode() == KeyEvent.VK_TAB)
          {
            txfBlandCd.requestFocus();
          }
        }
        if (e.getModifiersEx() == VK_CONTROL_AND_SHIFT_DOWN)
        {
          if (e.getKeyCode() == KeyEvent.VK_TAB)
          {
            txaRegStrasse.requestFocus();
          }
        }
      }
    });
    addCharsetVerifier( txaRegOrt );

    txaUpVerzName.setFocusTraversalKeysEnabled(false);
    txaUpVerzName.addKeyListener(new java.awt.event.KeyAdapter()
    {
      public void keyPressed(KeyEvent e)
      {
        if (e.getModifiersEx() == InputEvent.CTRL_DOWN_MASK)
        {
          if (e.getKeyCode() == KeyEvent.VK_TAB)
          {
            ckbGesperrt.requestFocus();
          }
        }
        if (e.getModifiersEx() == VK_CONTROL_AND_SHIFT_DOWN)
        {
          if (e.getKeyCode() == KeyEvent.VK_TAB)
          {
            txfAdrNr.requestFocus();
          }
        }
      }
    });
    addCharsetVerifier( txaUpVerzName );


    this.add(txfRegadrNr,   new GridBagConstraints(1, 0, 2, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(1, 12, 1, 0), 70, 0));
    this.add(lblRegadrNr,     new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(1, 0, 1, 0), 3, 6));
    this.add(lblBlandCd,      new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(1, 0, 1, 0), 0, 0));
    this.add(lblRegStrasse,      new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(1, 0, 1, 0), 0, 0));
    this.add(lblAdrNr,      new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(1, 0, 1, 0), 0, 0));
    this.add(lblVerzName,      new GridBagConstraints(0, 6, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(1, 0, 1, 0), 0, 0));
    this.add(lblGesperrt,      new GridBagConstraints(0, 7, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(1, 0, 1, 0), 0, 0));
    this.add(lblRegOrt,      new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(1, 0, 1, 0), 0, 0));
    this.add(scpRegName,   new GridBagConstraints(1, 1, 3, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(1, 12, 1, 7), 333, 33));
    this.add(scpRegStrasse,   new GridBagConstraints(1, 2, 3, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(1, 12, 1, 7), 333, 63));
    this.add(scpRegOrt,   new GridBagConstraints(1, 3, 3, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(1, 12, 1, 7), 333, 23));
    this.add(txfBlandCd,   new GridBagConstraints(1, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(1, 12, 1, 0), 40, 0));
    this.add(txfAdrNr,   new GridBagConstraints(1, 5, 2, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(1, 12, 1, 0), 70, 0));
    this.add(scpUpVerzName,   new GridBagConstraints(1, 6, 3, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(1, 12, 1, 7), 332, 23));
    this.add(ckbGesperrt,     new GridBagConstraints(1, 7, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1, 12, 1, 1), 0, 0));
    this.add(lblRegName,     new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(1, 0, 1, 0), 7, 0));
    this.add(btnBlandCd,   new GridBagConstraints(2, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(1, 0, 1, 6), -22, -4));
    this.add(btnAdrNr,    new GridBagConstraints(3, 5, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1, 7, 1, 0), -22, -4));
    scpUpVerzName.getViewport().add(txaUpVerzName, null);
    scpRegOrt.getViewport().add(txaRegOrt, null);
    scpRegStrasse.getViewport().add(txaRegStrasse, null);
    scpRegName.getViewport().add(txaRegName, null);

    ldoSortiername.setMaxLength(200);
    ldoSortiername.setUpperCase(true);
    ldoRegName.setMaxLength(126);
    ldoRegStrasse.setMaxLength(168);
    ldoRegOrt.setMaxLength(84);
    ldoLand.setMaxLength(3);
    ldoLand.setUpperCase(true);
    ldoAdrNr.setMaxLength(10);
    ldoAdrNr.setInteger(true);

    txaUpVerzName.setDocument(ldoSortiername);
    txaRegName.setDocument(ldoRegName);
    txaRegStrasse.setDocument(ldoRegStrasse);
    txaRegOrt.setDocument(ldoRegOrt);
    txfBlandCd.setDocument(ldoLand);
    txfBlandCd.setInputVerifier(blandCdInputVerifier);
    txfAdrNr.setDocument(ldoAdrNr);
    txfAdrNr.setInputVerifier(adrNrInputVerifier);
  }

  /**
   * Wird aufgerufen, sobald das Panel im Wizard-Dialog sichtbar ist.
   */
  public void activate()
  {
    super.activate();
    observable.setChanged();
    if (!adrGesucht)
    {
      observable.notifyObservers(new Integer(WizardObsConst.DISABLE_FORWARD));
    }
  }
  /**
   * Setzt die Registeradresse.
   * @param regadrVO Registeradresse
   * @param edit true = mutieren, false = erfassen
   */
  public void setRegadr(RegadrVO regadrVO, boolean edit)
  {
    this.regadrVO = regadrVO;
    this.edit = edit;
    txfRegadrNr.setText("" + regadrVO.getRegadrNr());
    txaRegName.setText(regadrVO.getRegNameOrEmptyString());
    txaRegStrasse.setText(regadrVO.getRegStrasseOrEmptyString());
    txaRegOrt.setText(regadrVO.getRegOrtOrEmptyString());
    txfBlandCd.setText(regadrVO.getBlandCdOrEmptyString());
    if (regadrVO.getAdrNr() != 0)
    {
      txfAdrNr.setText("" + regadrVO.getAdrNr());
    }
    txaUpVerzName.setText(regadrVO.getUpVerzNameOrEmptyString());
    ckbGesperrt.setSelected(regadrVO.getGesperrt() == 1);
  }

  /**
   * Gibt die erfasste bzw. mutierte Registeradresse zurück.
   * @return Registeradresse
   */
  public RegadrVO getRegadr()
  {
    if (regadrVO == null)
    {
      regadrVO = new RegadrVO();
    }
    try
    {
      regadrVO.setRegadrNr(Integer.parseInt(txfRegadrNr.getText()));
    }
    catch (NumberFormatException ex)
    {
      LOG.error(ex);
      regadrVO.setRegadrNr(0);
    }
    regadrVO.setRegName(txaRegName.getText());
    regadrVO.setRegStrasse(txaRegStrasse.getText());
    regadrVO.setRegOrt(txaRegOrt.getText());
    regadrVO.setBlandCd(txfBlandCd.getText());
    try
    {
      regadrVO.setAdrNr(Integer.parseInt(txfAdrNr.getText()));
    }
    catch (NumberFormatException ex)
    {
      LOG.error(ex);
      regadrVO.setAdrNr(0);
    }
    regadrVO.setUpVerzName(txaUpVerzName.getText());
    regadrVO.setGesperrt(ckbGesperrt.isSelected() ? 1 : 0);
    return regadrVO;
  }

  void btnBlandCd_actionPerformed(ActionEvent e)
  {
    String blandCd = DlgBland.showBland((Dialog)parentWindow, txfBlandCd.getText());
    if (!blandCd.equals(""))
    {
      // Land ausgewählt
      txfBlandCd.setText(blandCd);
    }

  }

  /**
   * Validiert die Eingaben auf dem Panel
   * @return true - Validierung war erfolgreich
   */
  public boolean verifyInput()
  {
    // Feld darf nicht leer sein!
    String feldLeer = xxMessage.getMessage(5033);
    if (txaRegName.getText().trim().length() == 0)
    {
      JOptionPane.showMessageDialog(null,
         feldLeer,
         "Information",
         JOptionPane.INFORMATION_MESSAGE);
         txaRegName.requestFocus();
         return false;
    }
    if (txaRegOrt.getText().trim().length() == 0)
    {
      JOptionPane.showMessageDialog(null,
         feldLeer,
         "Information",
         JOptionPane.INFORMATION_MESSAGE);
         txaRegOrt.requestFocus();
         return false;
    }
    if (txfBlandCd.getText().trim().length() == 0)
    {
      JOptionPane.showMessageDialog(null,
         feldLeer,
         "Information",
         JOptionPane.INFORMATION_MESSAGE);
         txfBlandCd.requestFocus();
         return false;
    }
    if (txaUpVerzName.getText().trim().length() == 0)
    {
      JOptionPane.showMessageDialog(null,
         feldLeer,
         "Information",
         JOptionPane.INFORMATION_MESSAGE);
         txaUpVerzName.requestFocus();
         return false;
    }
    //Versandadresse muss vorhanden sein
    if(!verifyAdrNr(txfAdrNr.getText().trim(), this))
    {
      return false;
    }   
    if ( !txaRegName.getInputVerifier().verify( txaRegName ) )
    {
      txaRegName.requestFocus();
      return false;
    }
    if ( !txaRegStrasse.getInputVerifier().verify( txaRegStrasse ) )
    {
      txaRegStrasse.requestFocus();
      return false;
    }
    if ( !txaRegOrt.getInputVerifier().verify( txaRegOrt ) )
    {
      txaRegOrt.requestFocus();
      return false;
    }
    if ( !txaUpVerzName.getInputVerifier().verify( txaUpVerzName ) )
    {
      txaUpVerzName.requestFocus();
      return false;
    }
    return true;
  }

  void btnAdrNr_actionPerformed(ActionEvent e)
  {
    MainController mc = new MainController((Dialog)SwingUtilities.windowForComponent(this), true);
    AdresseAwl aa = new AdresseAwl(mc, MainRootPane.SEARCH_LOOKUP);
    mc.first(aa);
    AdresseSelKritVO selKrit = new AdresseSelKritVO();
    try
    {
      selKrit.adrNr = Integer.parseInt(txfAdrNr.getText());
    }
    catch (NumberFormatException ex)
    {
      LOG.error(ex);
      selKrit.adrNr = 0;
    }
    if (selKrit.adrNr == 0)
    {
      // keine Adressnummer eingegeben, also Name, Ort etc. übernehmen
      int pos = txaRegName.getText().indexOf('\n');
      if (pos >= 0)
      {
        selKrit.name = txaRegName.getText().substring(0, pos);
      }
      else
      {
        selKrit.name = txaRegName.getText();
      }
      // Falls die Zeichen vor dem ersten " " alles Ziffern sind,
      // werden diese als Postleitzahl übernommen.
      String plz = "";
      String ort = "";
      String regOrt = txaRegOrt.getText();
      pos = regOrt.indexOf('\n');
      if (pos >= 0)
      {
        regOrt = regOrt.substring(0, pos);
      }
      pos = regOrt.indexOf(' ');
      if (pos == -1)
      {
        pos = regOrt.length();
      }
      plz = regOrt.substring(0, pos);
      try
      {
        // Mit Postleitzahl
        Integer.parseInt(plz);
        if (pos < regOrt.length())
        {
          ort = regOrt.substring(pos+1, regOrt.length());
        }
      }
      catch (NumberFormatException ex)
      {
        // Keine Postleitzahl
        plz = "";
        ort = regOrt;
      }
      selKrit.plz = plz;
      selKrit.ort = ort;
      try
      {
        selKrit.landCd = AdresseDelegate.getInstance().getLandCd(txfBlandCd.getText());
        if (selKrit.landCd == null)
        {
          selKrit.landCd = "";
        }
      }
      catch (Exception ex)
      {
        LOG.error(ex);
        String message = xxMessage.getMessage(ex);
        JOptionPane.showMessageDialog(parentWindow, message,
                                      "Fehler", JOptionPane.ERROR_MESSAGE);
      }
    }
    aa.setSelKrit(selKrit);
    // Modaler Aufruf der Selektion einer Adresse
    int adrNr = aa.getAdrNrModal();
    adrGesucht = true;
    if (adrNr == 0)
    {
      // Weiter-Knopf enablen
      observable.setChanged();
      observable.notifyObservers(new Integer(WizardObsConst.ENABLE_FORWARD));
    }
    else
    {
      txfAdrNr.setText("" + adrNr);
    }
  }

  /**
   * Verifiziert die Eingabe des Ländercodes
   */
  class BlandCdInputVerifier extends InputVerifier
  {
    public boolean verify(JComponent input)
    {
      String blandCd = ((JTextField)input).getText();
      if (blandCd.equals(""))
      {
        return true;
      }
      try
      {
        if (!AdresseDelegate.getInstance().existsBland(txfBlandCd.getText()))
        {
          // Landcode "!P1" ist unbekannt !
          String message = xxMessage.getMessage(40, txfBlandCd.getText());
          input.setInputVerifier(null);
          JOptionPane.showMessageDialog(null,
             message,
             "Information",
             JOptionPane.INFORMATION_MESSAGE);
          input.setInputVerifier(blandCdInputVerifier);
          return false;
        }
      }
      catch (Exception ex)
      {
        LOG.error(ex);
        String message = xxMessage.getMessage(ex);
        input.setInputVerifier(null);
        JOptionPane.showMessageDialog(parentWindow, message,
                                      "Fehler", JOptionPane.ERROR_MESSAGE);
        input.setInputVerifier(blandCdInputVerifier);
        return false;
      }
      return true;
    }
  }


  /**
       * Überprüft, ob die eingebene Versandadresse existiert
       * @param adrNrStr Nummer der Versandadresse
       * @return boolean true-Adresse vorhanden, false-Adresse nicht vorhanden
       */
      private boolean verifyAdrNr(String adrNrStr, JComponent input) {
        if (adrNrStr.equals(""))
        {
          return true;
        }
        int adrNr = 0;
        try
        {
          adrNr = Integer.parseInt(adrNrStr);
        }
        catch (NumberFormatException ex)
        {
          LOG.error(ex);
          String message = xxMessage.getMessage(ex);
          input.setInputVerifier(null);
          JOptionPane.showMessageDialog(parentWindow, message,
                                        "Fehler", JOptionPane.ERROR_MESSAGE);
          input.setInputVerifier(adrNrInputVerifier);
        }
        try
        {
          if (!AdresseDelegate.getInstance().existsVersadr(adrNr))
          {
            // Versandadresse "!P1" ist unbekannt !
            String message = xxMessage.getMessage(41, adrNrStr);
            input.setInputVerifier(null);
            JOptionPane.showMessageDialog(null,
               message,
               "Information",
               JOptionPane.INFORMATION_MESSAGE);
            input.setInputVerifier(adrNrInputVerifier);
            return false;
          }
        }
        catch (Exception ex)
        {
          LOG.error(ex);
          String message = xxMessage.getMessage(ex);
          input.setInputVerifier(null);
          JOptionPane.showMessageDialog(parentWindow, message,
                                        "Fehler", JOptionPane.ERROR_MESSAGE);
          input.setInputVerifier(adrNrInputVerifier);
          return false;
        }
        return true;
      }



  /**
   * Verifiziert die Eingabe der Adressnummer
   */
  class AdrNrInputVerifier extends InputVerifier
  {
    public boolean verify(JComponent input)
    {
      String adrNrStr = ((JTextField)input).getText();
      return verifyAdrNr(adrNrStr, input);
    }
  }


  void ldoAdrNr_changedUpdate(DocumentEvent e)
  {
    if (txfAdrNr.getText().length() > 0)
    {
      observable.setChanged();
      observable.notifyObservers(new Integer(WizardObsConst.DISABLE_FORWARD));
    }
  }

  void ldoAdrNr_insertUpdate(DocumentEvent e)
  {
    if (txfAdrNr.getText().length() > 0)
    {
      observable.setChanged();
      observable.notifyObservers(new Integer(WizardObsConst.DISABLE_FORWARD));
    }
  }

  void ldoAdrNr_removeUpdate(DocumentEvent e)
  {
    if (adrGesucht && txfAdrNr.getText().length() == 0)
    {
      observable.setChanged();
      observable.notifyObservers(new Integer(WizardObsConst.ENABLE_FORWARD));
    }
  }
}
