package ch.ige.adr.server;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import javax.ejb.EJBException;

import org.apache.log4j.Logger;

import ch.ige.adr.server.dao.AdresseDAO;
import ch.ige.adr.server.dao.AdressePttPendDAO;
import ch.ige.adr.server.dao.PostOrtDAO;
import ch.ige.adr.vo.AdresseVO;

/**
 * Kontrolliert falsche Plz/Ort Einträge und speichert eine Pendenz in adresse_ptt_pend
 * <p>
 * Copyright (c) 2001, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Michael Zaugg / Stefan Nydegger
 * @version $Id: OrtsabgleichBO.java,v 1.15 2006/12/11 15:17:28 nydegger Exp $
 */

public class OrtsabgleichBO
{
  private static final Logger LOG = Logger.getLogger(OrtsabgleichBO.class);

  //protected Hashtable ht = new Hashtable(5000);

  /**
  * Fehlerhafte Adressen werden in der HashTable verglichen und anschliessend
  * in die Tabelle adresse_ptt_pend geschrieben.
  */
  public void startOrtsabgleich()
  {
    Map hashMap = new HashMap(5000);
    AdressePttPendDAO adrPttDAO = null;
    AdresseVO adrVO = null;
    ArrayList alAdr = null;
    int rowCount = 0;
    int count = 0;

    try
    {
      // alle Ortschaften mit dazugehörigen Postleitzahlen selektieren
      hashMap = new PostOrtDAO().select();

      // alle Einträge in Tabelle adresse_ptt_pend löschen
      adrPttDAO = new AdressePttPendDAO();
      rowCount = adrPttDAO.delete();
      LOG.debug("startOrtsabgleich - " + rowCount + " records from adresse_ptt_pend deleted");
      //alle aktiven Adressen ab 01.07.2003 selektieren
      alAdr = new AdresseDAO().select();
      LOG.debug("startOrtsabgleich - wrong adresses since seit 01.07.2003: " + alAdr.size());

      if(alAdr != null && alAdr.size() > 0)
      {
        for (int i = 0; i < alAdr.size(); i++)
        {
          adrVO = (AdresseVO)alAdr.get(i);
          if(!(hashMap.containsKey(adrVO.getPlz() + adrVO.getOrt())))
          {
            adrPttDAO.insert(adrVO.getAdrNr(), adrVO.getOrt());
            count++;
          }
        }
      }
      LOG.debug("startOrtsabgleich - records inserted into adr_ptt_pend: " + count);
    }
    catch (Exception ex)
    {
      LOG.error(ex.getMessage());
      throw new EJBException(ex);
    }
  }
}
