package ch.ige.adr.vo;

import java.io.Serializable;

/**
 * ValueObject für die Ortsnormalisierung (PostOrtBean)
 * <p>
 * Copyright (c) 2001, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Michael Zaugg
 * @version $Id: PostOrtVO.java,v 1.7 2006/12/12 07:55:43 nydegger Exp $
 */

public class PostOrtVO implements Serializable
{

//---------------------------------------------------------------------------
// fields
//---------------------------------------------------------------------------

  private int ordNrPost;
  private String plzTyp = "";
  private String plz = "";
  private String plzZusatz = "";
  private String ort = "";
  private String ortNorm = "";
  private String kanton = "";
  private String landCd = "";
  private int version = 0;


//---------------------------------------------------------------------------
// methods
//---------------------------------------------------------------------------

  public String toString()
  {
    StringBuffer  buf = new StringBuffer();
    buf.append ("  ordNrPost = <"  + this.ordNrPost + "> \n");
    buf.append ("  plzTyp    = <"  + this.plzTyp    + "> \n");
    buf.append ("  plz       = <"  + this.plz       + "> \n");
    buf.append ("  plzZusatz = <"  + this.plzZusatz + "> \n");
    buf.append ("  ort       = <"  + this.ort       + "> \n");
    buf.append ("  ortNorm   = <"  + this.ortNorm   + "> \n");
    buf.append ("  kanton    = <"  + this.kanton    + "> \n");
    buf.append ("  landCd    = <"  + this.landCd    + "> \n");
    buf.append ("  version   = <"  + this.version   + "> \n");
    return buf.toString();
  }

//---------------------------------------------------------------------------
// getter/setter methods
//---------------------------------------------------------------------------

  /**
   * @return version
   */
  public int getVersion()
  {
    return version;
  }
  /**
   * @param version
   */
  public void setVersion(int version)
  {
    this.version = version;
  }
  /**
   * @param plzZusatz
   */
  public void setPlzZusatz(String plzZusatz)
  {
    this.plzZusatz = plzZusatz;
  }
  /**
   * @param plzTyp
   */
  public void setPlzTyp(String plzTyp)
  {
    this.plzTyp = plzTyp;
  }
  /**
   * @param plz
   */
  public void setPlz(String plz)
  {
    this.plz = plz;
  }
  /**
   * @param ortNorm
   */
  public void setOrtNorm(String ortNorm)
  {
    this.ortNorm = ortNorm;
  }
  /**
   * @param ort
   */
  public void setOrt(String ort)
  {
    this.ort = ort;
  }
  /**
   * @param ordNrPost
   */
  public void setOrdNrPost(int ordNrPost)
  {
    this.ordNrPost = ordNrPost;
  }
  /**
   * @param landCd
   */
  public void setLandCd(String landCd)
  {
    this.landCd = landCd;
  }
  /**
   * @param kanton
   */
  public void setKanton(String kanton)
  {
    this.kanton = kanton;
  }
  /**
   * @return kanton
   */
  public String getKanton()
  {
    return kanton;
  }
  /**
   * @return landCd
   */
  public String getLandCd()
  {
    return landCd;
  }
  /**
   * @return ordNrPost
   */
  public int getOrdNrPost()
  {
    return ordNrPost;
  }
  /**
   * @return ort
   */
  public String getOrt()
  {
    return ort;
  }
  /**
   * @return ortNorm
   */
  public String getOrtNorm()
  {
    return ortNorm;
  }
  /**
   * @return plz
   */
  public String getPlz()
  {
    return plz;
  }
  /**
   * @return plzTyp
   */
  public String getPlzTyp()
  {
    return plzTyp;
  }
  /**
   * @return plzZusatz
   */
  public String getPlzZusatz()
  {
    return plzZusatz;
  }
}
