package ch.ige.adr.vo;

import java.io.Serializable;

/**
 * Value Object für Auswahl der Registeradresse.
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Ueli Ryser
 * @version $Id: RegadrAVO.java,v 1.6 2006/12/12 07:55:43 nydegger Exp $
 */
public class RegadrAVO implements Serializable
{
  private int regadrNr;
  private String blandCd = "";
  private int adrNr;
  private String regName = "";
  private String regStrasse = "";
  private String regOrt = "";
  private String upVerzName = "";

  public String toString()
  {
    StringBuffer  buf = new StringBuffer();
    buf.append ("  regadrNr   = <"  + this.regadrNr   + "> \n");
    buf.append ("  blandCd    = <"  + this.blandCd    + "> \n");
    buf.append ("  adrNr      = <"  + this.adrNr      + "> \n");
    buf.append ("  regName    = <"  + this.regName    + "> \n");
    buf.append ("  regStrasse = <"  + this.regStrasse + "> \n");
    buf.append ("  regOrt     = <"  + this.regOrt     + "> \n");
    buf.append ("  upVerzName = <"  + this.upVerzName + "> \n");
    return buf.toString();
  }
  /**
   * @return adrNr
   */
  public int getAdrNr()
  {
    return adrNr;
  }
  /**
   * @param adrNr
   */
  public void setAdrNr(int adrNr)
  {
    this.adrNr = adrNr;
  }
  /**
   * @param blandCd
   */
  public void setBlandCd(String blandCd)
  {
    this.blandCd = (blandCd != null && blandCd.equals("") ? null : blandCd);
  }
  /**
   * @param regadrNr
   */
  public void setRegadrNr(int regadrNr)
  {
    this.regadrNr = regadrNr;
  }
  /**
   * @param regName
   */
  public void setRegName(String regName)
  {
    this.regName = (regName != null && regName.equals("") ? null : regName);
  }
  /**
   * @param regOrt
   */
  public void setRegOrt(String regOrt)
  {
    this.regOrt = (regOrt != null && regOrt.equals("") ? null : regOrt);
  }
  /**
   * @param regStrasse
   */
  public void setRegStrasse(String regStrasse)
  {
    this.regStrasse = (regStrasse != null && regStrasse.equals("") ? null : regStrasse);
  }
  /**
   * @param upVerzName
   */
  public void setUpVerzName(String upVerzName)
  {
    this.upVerzName = (upVerzName != null && upVerzName.equals("") ? null : upVerzName);
  }

  /**
   * @return upVerzName
   */
  public String getUpVerzName()
  {
    return upVerzName;
  }
  /**
   * @return upVerzName
   */
  public String getUpVerzNameOrEmptyString()
  {
    return (upVerzName == null ? "" : upVerzName);
  }
  /**
   * @return regStrasse
   */
  public String getRegStrasse()
  {
    return regStrasse;
  }
  /**
   * @return regStrasse
   */
  public String getRegStrasseOrEmptyString()
  {
    return (regStrasse == null ? "" : regStrasse);
  }
  /**
   * @return regOrt
   */
  public String getRegOrt()
  {
    return regOrt;
  }
  /**
   * @return regOrt
   */
  public String getRegOrtOrEmptyString()
  {
    return (regOrt == null ? "" : regOrt);
  }
  /**
   * @return regName
   */
  public String getRegName()
  {
    return regName;
  }
  /**
   * @return regName
   */
  public String getRegNameOrEmptyString()
  {
    return (regName == null ? "" : regName);
  }
  /**
   * @return regadrNr
   */
  public int getRegadrNr()
  {
    return regadrNr;
  }
  /**
   * @return blandCd
   */
  public String getBlandCd()
  {
    return blandCd;
  }
  /**
   * @return blandCd
   */
  public String getBlandCdOrEmptyString()
  {
    return (blandCd == null ? "" : blandCd);
  }
}
