package ch.ige.adr.vo;

import java.io.Serializable;

/**
 * Value Object für Selektionskriterien der Registeradresse.
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Ueli Ryser
 * @version $Id: RegadrSelKritVO.java,v 1.6 2006/12/12 07:55:43 nydegger Exp $
 */
public class RegadrSelKritVO implements Serializable
{
  /**
   * Suchkritierium alle
   */
  public static int SUCHUMFANG_ALLE = 0;
  /**
   * Suchkriterium nur gültige
   */
  public static int SUCHUMFANG_NUR_GUELTIGE = 1;
  /**
   * Suchkriterium nur gesperrte
   */
  public static int SUCHUMFANG_NUR_GESPERRTE = 2;

  /**
   * register Adresse Nummer
   */
  public int regadrNr;

  /**
   * bland Code
   */
  public String blandCd = "";

  /**
   * Adresse Nummer
   */
  public int adrNr;

  /**
   * Register Name
   */
  public String regName = "";

  /**
   * Register Strasse
   */
  public String regStrasse = "";

  /**
   * register Ordt
   */
  public String regOrt = "";

  /**
   * upVerzName
   */
  public String upVerzName = "";

  /**
   * nur mit Versandadresse
   */
  public boolean nurMitVersAdr = true; 

  /**
   * nur in der Schweiz (CH) oder Liechtenstein (LI)
   */
  public boolean nurChLi = true; 

  /**
   * Volltext Suchmodus
   */
  public boolean suchmodusVolltext = false;

  /**
   * Suchumfang
   */
  public int suchumfang = SUCHUMFANG_ALLE;

  public String toString()
  {
    StringBuffer  buf = new StringBuffer();
    buf.append ("  regadrNr          = <"  + this.regadrNr          + "> \n");
    buf.append ("  blandCd           = <"  + this.blandCd           + "> \n");
    buf.append ("  adrNr             = <"  + this.adrNr             + "> \n");
    buf.append ("  regName           = <"  + this.regName           + "> \n");
    buf.append ("  regStrasse        = <"  + this.regStrasse        + "> \n");
    buf.append ("  regOrt            = <"  + this.regOrt            + "> \n");
    buf.append ("  upVerzName        = <"  + this.upVerzName        + "> \n");
    buf.append ("  nurMitVersAdr     = <"  + this.nurMitVersAdr     + "> \n");
    buf.append ("  nurChLi           = <"  + this.nurChLi           + "> \n");
    buf.append ("  suchmodusVolltext = <"  + this.suchmodusVolltext + "> \n");
    buf.append ("  suchumfang        = <"  + this.suchumfang        + "> \n");
    return buf.toString();
  }
}
