package ch.ige.art.client.art;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.SystemColor;
import java.util.List;

import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SwingConstants;

import org.apache.log4j.Logger;

import ch.ige.art.client.util.ComboBoxObject;
import ch.ige.art.client.util.PnlArtikelWizard;
import ch.ige.art.client.util.UserMessage;
import ch.ige.art.client.util.renderer.ComboRenderer;
import ch.ige.art.util.XxDomain;
import ch.ige.art.util.XxDomainFactory;
import ch.ige.art.vo.ArtikelGuiAVO;
import ch.ige.art.vo.XxDomainVO;
import ch.ige.arthelp.HelpUtil;
import ch.ige.util.client.LimitedDocument;

/**
 * <p>Überschrift: Artikel-Bagisdaten</p>
 * <p>Beschreibung: Panel mit Bagisdaten</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Organisation: Institut für Geistiges Eigentum</p>
 * @author Anita Rueegsegger
 * @version $Id: PnlArtBagis1.java,v 1.23 2008/07/02 11:00:20 heinzer Exp $
 */

public class PnlArtBagis1 extends PnlArtikelWizard
{

  private ArtikelGuiAVO artikelGuiAVO = null;

  // Logging
  private static final Logger LOG = Logger.getLogger( PnlArtBagis1.class );

  private UserMessage userMessage = new UserMessage();

  private JPanel pnlCenter = new JPanel();

  private BorderLayout borderLayout1 = new BorderLayout();

  private GridBagLayout gridBagLayout1 = new GridBagLayout();

  private JLabel lblFormartCd = new JLabel();

  private JLabel lblEinzFaktpos = new JLabel();

  private JLabel lblDruckModus = new JLabel();

  private JLabel lblAnzKopie = new JLabel();

  private JLabel lblKzUntschr = new JLabel();

  private JLabel lblErfassProc = new JLabel();

  private JLabel lblProcessModus = new JLabel();

  private JLabel lblProcessNr = new JLabel();

  private JLabel lblStatcd1 = new JLabel();

  private JLabel lblStatcd2 = new JLabel();

  private JComboBox cbxDruckModus = new JComboBox();

  private JComboBox cbxEinzFaktpos = new JComboBox();

  private JComboBox cbxProcessModus = new JComboBox();

  private JComboBox cbxStatcd2 = new JComboBox();

  private JComboBox cbxStatcd1 = new JComboBox();

  private JComboBox cbxErfassProc = new JComboBox();

  private JComboBox cbxKzUntschr = new JComboBox();

  private JTextField txfAnzKopie = new JTextField();

  private JTextField txfFormartCd = new JTextField();

  private JTextField txfProcessNr = new JTextField();

  private JCheckBox ckbKzEinschr = new JCheckBox();

  private JCheckBox ckbKzBesch = new JCheckBox();

  private LimitedDocument ldoAnzKopie = new LimitedDocument();

  private LimitedDocument ldoFormartCd = new LimitedDocument();

  private LimitedDocument ldoWbeschZeit = new LimitedDocument();

  private LimitedDocument ldoProcessNr = new LimitedDocument();

  /**
   * holt Instanz von xxDomain um Werte aus xx_domain lesen zu können<br>
   * ruft jbInit() auf
   * @param artikelGuiVO  ValueObject mit allen Daten eines Artikels
   */
  public PnlArtBagis1()
  {
    try
    {
      jbInit();
      initHelp();
    }
    catch ( Exception ex )
    {
      LOG.info( ex.getClass() + " " + ex.getMessage() );
      String message = userMessage.getUserMessage( ex );
      JOptionPane.showMessageDialog( null, message, "Information", JOptionPane.INFORMATION_MESSAGE );
    }
  }

  void jbInit() throws Exception
  {
    this.setLayout( borderLayout1 );
    this.setPreferredSize( new Dimension( 400, 300 ) );
    this.setMinimumSize( new Dimension( 300, 200 ) );
    txfAnzKopie.setMaximumSize( new Dimension( 80, 20 ) );
    txfAnzKopie.setMinimumSize( new Dimension( 80, 20 ) );
    txfAnzKopie.setPreferredSize( new Dimension( 80, 20 ) );
    cbxDruckModus.setMaximumSize( new Dimension( 300, 20 ) );
    cbxDruckModus.setMinimumSize( new Dimension( 300, 20 ) );
    cbxDruckModus.setPreferredSize( new Dimension( 300, 20 ) );
    cbxEinzFaktpos.setMaximumSize( new Dimension( 300, 20 ) );
    cbxEinzFaktpos.setMinimumSize( new Dimension( 300, 20 ) );
    cbxEinzFaktpos.setPreferredSize( new Dimension( 300, 20 ) );
    cbxEinzFaktpos.setMaximumRowCount( 8 );
    txfFormartCd.setMaximumSize( new Dimension( 80, 20 ) );
    txfFormartCd.setMinimumSize( new Dimension( 80, 20 ) );
    txfFormartCd.setPreferredSize( new Dimension( 80, 20 ) );
    ckbKzEinschr.setMaximumSize( new Dimension( 164, 22 ) );
    ckbKzEinschr.setMinimumSize( new Dimension( 164, 22 ) );
    ckbKzEinschr.setPreferredSize( new Dimension( 164, 22 ) );
    cbxKzUntschr.setMaximumSize( new Dimension( 300, 20 ) );
    cbxKzUntschr.setMinimumSize( new Dimension( 300, 20 ) );
    cbxKzUntschr.setPreferredSize( new Dimension( 300, 20 ) );
    cbxErfassProc.setMaximumSize( new Dimension( 300, 20 ) );
    cbxErfassProc.setMinimumSize( new Dimension( 300, 20 ) );
    cbxErfassProc.setPreferredSize( new Dimension( 300, 20 ) );
    cbxProcessModus.setMaximumSize( new Dimension( 300, 20 ) );
    cbxProcessModus.setMinimumSize( new Dimension( 300, 20 ) );
    cbxProcessModus.setPreferredSize( new Dimension( 300, 20 ) );
    cbxStatcd1.setMaximumSize( new Dimension( 300, 20 ) );
    cbxStatcd1.setMinimumSize( new Dimension( 300, 20 ) );
    cbxStatcd1.setPreferredSize( new Dimension( 300, 20 ) );
    cbxStatcd1.setMaximumRowCount( 8 );
    cbxStatcd2.setMaximumSize( new Dimension( 300, 20 ) );
    cbxStatcd2.setMinimumSize( new Dimension( 300, 20 ) );
    cbxStatcd2.setPreferredSize( new Dimension( 300, 20 ) );
    txfProcessNr.setMaximumSize( new Dimension( 80, 20 ) );
    txfProcessNr.setMinimumSize( new Dimension( 80, 20 ) );
    txfProcessNr.setPreferredSize( new Dimension( 80, 20 ) );
    ckbKzBesch.setMaximumSize( new Dimension( 174, 22 ) );
    ckbKzBesch.setMinimumSize( new Dimension( 174, 22 ) );
    ckbKzBesch.setPreferredSize( new Dimension( 174, 22 ) );
    this.add( pnlCenter, BorderLayout.CENTER );

    pnlCenter.setLayout( gridBagLayout1 );
    pnlCenter.setPreferredSize( new Dimension( 400, 300 ) );

    lblAnzKopie.setToolTipText( "anz_kopie" );
    lblDruckModus.setToolTipText( "druck_modus" );
    lblEinzFaktpos.setToolTipText( "einz_faktpos" );
    lblFormartCd.setToolTipText( "formart_cd" );
    lblKzUntschr.setToolTipText( "kz_untschr" );
    lblErfassProc.setToolTipText( "erfass_proc" );
    lblProcessModus.setToolTipText( "process_modus" );
    lblProcessNr.setToolTipText( "process_nr" );
    lblStatcd1.setToolTipText( "statcd_1" );
    lblStatcd2.setToolTipText( "statcd_2" );

    ckbKzEinschr.setText( "Einschreiben erforderlich" );
    ckbKzBesch.setText( "Bescheinigung erforderlich" );
    ckbKzEinschr.setToolTipText( "kz_einschr" );
    ckbKzBesch.setToolTipText( "kz_besch" );

    cbxDruckModus.setBackground( SystemColor.controlLtHighlight );
    cbxEinzFaktpos.setBackground( SystemColor.controlLtHighlight );
    cbxStatcd2.setBackground( SystemColor.controlLtHighlight );
    cbxStatcd1.setBackground( SystemColor.controlLtHighlight );
    cbxErfassProc.setBackground( SystemColor.controlLtHighlight );
    cbxProcessModus.setBackground( SystemColor.controlLtHighlight );
    cbxKzUntschr.setBackground( SystemColor.controlLtHighlight );

    lblFormartCd.setText( "Formular:" );
    lblFormartCd.setHorizontalAlignment( SwingConstants.RIGHT );
    lblEinzFaktpos.setText( "Einzelfakturaposition:" );
    lblEinzFaktpos.setHorizontalAlignment( SwingConstants.RIGHT );
    lblDruckModus.setHorizontalAlignment( SwingConstants.RIGHT );
    lblDruckModus.setText( "Druckmodus:" );
    lblAnzKopie.setHorizontalAlignment( SwingConstants.RIGHT );
    lblAnzKopie.setText( "Anzahl Kopien:" );
    lblKzUntschr.setText( "Unterschrift erforderlich:" );
    lblKzUntschr.setHorizontalAlignment( SwingConstants.RIGHT );
    lblErfassProc.setHorizontalAlignment( SwingConstants.RIGHT );
    lblErfassProc.setText( "Erfassungsprozess:" );
    lblProcessModus.setText( "Prozessmodus:" );
    lblProcessModus.setHorizontalAlignment( SwingConstants.RIGHT );
    lblProcessNr.setHorizontalAlignment( SwingConstants.RIGHT );
    lblProcessNr.setText( "Prozessnummer:" );
    lblStatcd1.setHorizontalAlignment( SwingConstants.RIGHT );
    lblStatcd1.setText( "Listentyp EP-Jahresgebühren:" );
    lblStatcd2.setText( "Löschregel Ereignis:" );
    lblStatcd2.setHorizontalAlignment( SwingConstants.RIGHT );

    pnlCenter.add( lblAnzKopie, new GridBagConstraints( 0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 25, 6, 0, 0 ), 111,
        5 ) );
    pnlCenter.add( txfAnzKopie, new GridBagConstraints( 1, 0, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 25, 10, 3, 0 ), 0,
        0 ) );
    pnlCenter.add( lblDruckModus, new GridBagConstraints( 0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ),
        118, 5 ) );
    pnlCenter.add( cbxDruckModus, new GridBagConstraints( 1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 3, 10, 3, 0 ), 0,
        0 ) );
    pnlCenter.add( lblEinzFaktpos, new GridBagConstraints( 0, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ),
        75, 5 ) );
    pnlCenter.add( cbxEinzFaktpos, new GridBagConstraints( 1, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 3, 10, 3, 0 ),
        0, 0 ) );
    pnlCenter.add( lblFormartCd, new GridBagConstraints( 0, 3, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 139,
        5 ) );
    pnlCenter.add( txfFormartCd, new GridBagConstraints( 1, 3, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 3, 10, 3, 0 ), 0,
        0 ) );
    pnlCenter.add( ckbKzEinschr, new GridBagConstraints( 1, 4, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 3, 10, 3, 0 ), 0,
        0 ) );
    pnlCenter
        .add( ckbKzBesch, new GridBagConstraints( 1, 5, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 3, 10, 3, 0 ), 0, 0 ) );
    pnlCenter.add( lblKzUntschr, new GridBagConstraints( 0, 6, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 61,
        5 ) );
    pnlCenter.add( cbxKzUntschr, new GridBagConstraints( 1, 6, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 3, 10, 3, 0 ), 0,
        0 ) );
    pnlCenter.add( lblErfassProc, new GridBagConstraints( 0, 7, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 81,
        5 ) );
    pnlCenter.add( cbxErfassProc, new GridBagConstraints( 1, 7, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 3, 10, 3, 0 ), 0,
        0 ) );
    pnlCenter.add( lblProcessModus, new GridBagConstraints( 0, 8, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ),
        105, 5 ) );
    pnlCenter.add( cbxProcessModus, new GridBagConstraints( 1, 8, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 3, 10, 3, 0 ),
        0, 0 ) );
    pnlCenter.add( lblProcessNr, new GridBagConstraints( 0, 9, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 97,
        5 ) );
    pnlCenter.add( lblStatcd1,
        new GridBagConstraints( 0, 10, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ), 26, 5 ) );
    pnlCenter.add( cbxStatcd1,
        new GridBagConstraints( 1, 10, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 3, 10, 3, 0 ), 0, 0 ) );
    pnlCenter.add( lblStatcd2, new GridBagConstraints( 0, 11, 1, 1, 0.0, 0.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets( 0, 6, 0, 0 ),
        78, 5 ) );
    pnlCenter.add( cbxStatcd2, new GridBagConstraints( 1, 11, 1, 1, 0.0, 1.0, GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets( 3, 10, 3, 0 ),
        0, 0 ) );
    pnlCenter.add( txfProcessNr, new GridBagConstraints( 1, 9, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets( 3, 10, 3, 0 ), 0,
        0 ) );

    //Combobox druck_modus   
    List<XxDomainVO> listDomain = XxDomain.getDomains( XxDomainFactory.DRUCK_MODUS );
    for ( XxDomainVO xxDomainVO: listDomain )
    {
      cbxDruckModus.addItem( new ComboBoxObject( Integer.toString( xxDomainVO.domainLnr ), xxDomainVO.getBez() ) );
    }
    //Combobox einz_faktpos    
    listDomain = XxDomain.getDomains( XxDomainFactory.EINZ_FAKTPOS );
    for ( XxDomainVO xxDomainVO: listDomain )
    {
      cbxEinzFaktpos.addItem( new ComboBoxObject( Integer.toString( xxDomainVO.domainLnr ), xxDomainVO.getBez() ) );
    }
    //Combobox kz_untschr    
    listDomain = XxDomain.getDomains( XxDomainFactory.KZ_UNTSCHR );
    for ( XxDomainVO xxDomainVO: listDomain )
    {
      cbxKzUntschr.addItem( new ComboBoxObject( Integer.toString( xxDomainVO.domainLnr ), xxDomainVO.getBez() ) );
    }
    // Combobox process_modus
    cbxProcessModus.setRenderer( new ComboRenderer() );
    listDomain = XxDomain.getDomains( XxDomainFactory.PROCESS_MODUS );
    for ( XxDomainVO xxDomainVO: listDomain )
    {
      cbxProcessModus.addItem( new ComboBoxObject( Integer.toString( xxDomainVO.domainLnr ), xxDomainVO.getKbez(), xxDomainVO.getBez() ) );
    }
    // Combobox statcd_1
    cbxStatcd1.setRenderer( new ComboRenderer() );
    cbxStatcd1.addItem( new ComboBoxObject() );
    listDomain = XxDomain.getDomains( XxDomainFactory.STATCD_1 );
    for ( XxDomainVO xxDomainVO: listDomain )
    {
      cbxStatcd1.addItem( new ComboBoxObject( Integer.toString( xxDomainVO.domainLnr ), xxDomainVO.getKbez(), xxDomainVO.getBez() ) );
    }
    // Combobox statcd_2
    cbxStatcd2.setRenderer( new ComboRenderer() );
    cbxStatcd2.addItem( new ComboBoxObject() );
    listDomain = XxDomain.getDomains( XxDomainFactory.STATCD_2 );
    for ( XxDomainVO xxDomainVO: listDomain )
    {
      cbxStatcd2.addItem( new ComboBoxObject( Integer.toString( xxDomainVO.domainLnr ), xxDomainVO.getKbez(), xxDomainVO.getBez() ) );
    }
    // Combobox erfass_proc
    cbxErfassProc.setRenderer( new ComboRenderer() );
    cbxErfassProc.addItem( new ComboBoxObject() );
    listDomain = XxDomain.getDomains( XxDomainFactory.ERFASS_PROC );
    for ( XxDomainVO xxDomainVO: listDomain )
    {
      cbxErfassProc.addItem( new ComboBoxObject( Integer.toString( xxDomainVO.domainLnr ), xxDomainVO.getKbez(), xxDomainVO.getBez() ) );
    }

    // Validierungen via Documents
    txfAnzKopie.setDocument( ldoAnzKopie );
    txfFormartCd.setDocument( ldoFormartCd );
    txfProcessNr.setDocument( ldoProcessNr );

    ldoAnzKopie.setInteger( true );
    ldoAnzKopie.setMaxLength( 2 );
    ldoFormartCd.setInteger( true );
    ldoFormartCd.setMaxLength( 3 );
    ldoWbeschZeit.setInteger( true );
    ldoWbeschZeit.setMaxLength( 9 );
    ldoProcessNr.setInteger( true );
    ldoProcessNr.setMaxLength( 4 );
  }

  /**
   * Füllt Controls mit den Werten des artikelGuiAVO<br>
   * Setzt den Index der Comboboxen auf die Werte des artikelGuiAVO
   * @param artikelGuiAVO ValueObject mit den Werten
   */
  public void setData( ArtikelGuiAVO artikelGuiAVO )
  {
    this.artikelGuiAVO = artikelGuiAVO;

    // ComboBoxen
    if ( artikelGuiAVO.druckModus != null && !artikelGuiAVO.druckModus.equals( "" ) )
    {
      cbxDruckModus.setSelectedItem( new ComboBoxObject( artikelGuiAVO.druckModus, XxDomain.getBez( new Integer( artikelGuiAVO.druckModus ).intValue(),
          XxDomainFactory.DRUCK_MODUS ) ) );
    }
    else
    {
      cbxDruckModus.setSelectedItem( new ComboBoxObject( "1", XxDomain.getBez( 1, XxDomainFactory.DRUCK_MODUS ) ) ); //defaultwert = 1
    }

    if ( artikelGuiAVO.einzFaktpos != null && !artikelGuiAVO.einzFaktpos.equals( "" ) && !artikelGuiAVO.einzFaktpos.equals( "0" ) )
    {
      cbxEinzFaktpos.setSelectedItem( new ComboBoxObject( artikelGuiAVO.einzFaktpos, XxDomain.getBez( new Integer( artikelGuiAVO.einzFaktpos ).intValue(),
          XxDomainFactory.EINZ_FAKTPOS ) ) );
    }
    if ( artikelGuiAVO.kzUntschr != null && !artikelGuiAVO.kzUntschr.equals( "" ) && !artikelGuiAVO.kzUntschr.equals( "0" ) )
    {
      cbxKzUntschr.setSelectedItem( new ComboBoxObject( artikelGuiAVO.kzUntschr, XxDomain.getBez( new Integer( artikelGuiAVO.kzUntschr ).intValue(),
          XxDomainFactory.KZ_UNTSCHR ) ) );
    }
    if ( artikelGuiAVO.processModus != null && !artikelGuiAVO.processModus.equals( "" ) )
    {
      cbxProcessModus.setSelectedItem( new ComboBoxObject( artikelGuiAVO.processModus, XxDomain.getKbez( XxDomainFactory.PROCESS_MODUS, new Integer(
          artikelGuiAVO.processModus ).intValue() ) ) );
    }
    if ( artikelGuiAVO.statcd1 != null && !artikelGuiAVO.statcd1.equals( "" ) )
    {
      cbxStatcd1.setSelectedItem( new ComboBoxObject( artikelGuiAVO.statcd1, XxDomain.getKbez( XxDomainFactory.STATCD_1, new Integer( artikelGuiAVO.statcd1 )
          .intValue() ) ) );
    }
    if ( artikelGuiAVO.statcd2 != null && !artikelGuiAVO.statcd2.equals( "" ) )
    {
      cbxStatcd2.setSelectedItem( new ComboBoxObject( artikelGuiAVO.statcd2, XxDomain.getKbez( XxDomainFactory.STATCD_2, new Integer( artikelGuiAVO.statcd2 )
          .intValue() ) ) );
    }
    if ( artikelGuiAVO.erfassProc != null )
    {
      cbxErfassProc.setSelectedItem( new ComboBoxObject( artikelGuiAVO.erfassProc.toString(), XxDomain.getKbez( "erfass_proc", artikelGuiAVO.erfassProc
          .intValue() ) ) );
    }

    // Checkboxen
    ckbKzEinschr.setSelected( artikelGuiAVO.kzEinschr != null && artikelGuiAVO.kzEinschr.equals( "1" ) );
    ckbKzBesch.setSelected( artikelGuiAVO.kzBesch != null && artikelGuiAVO.kzBesch.equals( "1" ) );

    // Textfelder
    txfFormartCd.setText( artikelGuiAVO.formartCd == null ? "" : artikelGuiAVO.formartCd );
    txfProcessNr.setText( artikelGuiAVO.processNr == null ? "" : artikelGuiAVO.processNr.toString() );
    txfAnzKopie.setText( artikelGuiAVO.anzKopie == null ? "1" : artikelGuiAVO.anzKopie.toString() );
  }

  /**
   * ArtikelGuiAVO wird mit den geänderten Werten abgefüllt<br>
   * @return ArtikelGuiAVO mit aktuellen Werten
   */
  public ArtikelGuiAVO getData()
  {
    //Comboboxen
    artikelGuiAVO.druckModus = getComboValue( cbxDruckModus );
    artikelGuiAVO.einzFaktpos = getComboValue( cbxEinzFaktpos );
    artikelGuiAVO.erfassProc = getComboValue( cbxErfassProc ).equals( "" ) ? null : new Integer( getComboValue( cbxErfassProc ) );
    artikelGuiAVO.kzUntschr = getComboValue( cbxKzUntschr );
    artikelGuiAVO.processModus = getComboValue( cbxProcessModus );
    artikelGuiAVO.statcd1 = getComboValue( cbxStatcd1 ).equals( "" ) ? null : getComboValue( cbxStatcd1 );
    artikelGuiAVO.statcd2 = getComboValue( cbxStatcd2 ).equals( "" ) ? null : getComboValue( cbxStatcd2 );

    //Checkboxen
    artikelGuiAVO.kzBesch = ckbKzBesch.isSelected() ? "1" : "0";
    artikelGuiAVO.kzEinschr = ckbKzEinschr.isSelected() ? "1" : "0";

    //Textfelder
    artikelGuiAVO.anzKopie = txfAnzKopie.getText().equals( "" ) ? null : new Integer( txfAnzKopie.getText() );
    artikelGuiAVO.processNr = txfProcessNr.getText().equals( "" ) ? null : new Integer( txfProcessNr.getText() );
    artikelGuiAVO.formartCd = txfFormartCd.getText().equals( "" ) ? null : txfFormartCd.getText();
    return artikelGuiAVO;
  }

  /**
   * Teilt den Array des ComboBoxItems auf und gibt das erste Element zurück<br>
   * Dies entspricht entweder der domain_lnr oder der kbez der Tabelle xx_domain<br>
   * @param  cbxCombo JComboBox
   * @return erstes Element des ComboBoxItems
   */
  private String getComboValue( JComboBox cbxCombo )
  {
    ComboBoxObject cbo = (ComboBoxObject) cbxCombo.getSelectedItem();
    if ( cbo.key == null || cbo.key.equals( "" ) )
    {
      return "";
    }
    else
    {
      return cbo.key;
    }
  }

  /**
   * Überprüft Eingaben
   * @return  fehler == null --> keine Fehler Artikel kann gespeicher werden
   *          fehler.equals("") --> Fehler aufgetreten und angezeigt, Panel nicht wechseln
   *          anderenfalls den im fehler enthaltenen String anzeigen
   */
  public String validForward()
  {
    if ( txfAnzKopie.getText().equals( "" ) )
      return "Anzahl Kopien muss eingegeben werden";
    return null;
  }

  public String validBackward()
  {
    return null;
  }

  private void initHelp()
  {
    HelpUtil.getInstance().enableHelpKey( this, "intro" );
    HelpUtil.getInstance().enableHelp( this.pnlCenter, "artikelwizard.bagisdaten1" );
    HelpUtil.getInstance().enableHelp( this.lblFormartCd, "artikelwizard.bagisdaten1" );
    HelpUtil.getInstance().enableHelp( this.lblAnzKopie, "artikelwizard.bagisdaten1" );
    HelpUtil.getInstance().enableHelp( this.lblDruckModus, "artikelwizard.bagisdaten1" );
    HelpUtil.getInstance().enableHelp( this.lblEinzFaktpos, "artikelwizard.bagisdaten1" );
    HelpUtil.getInstance().enableHelp( this.lblErfassProc, "artikelwizard.bagisdaten1" );
    HelpUtil.getInstance().enableHelp( this.lblKzUntschr, "artikelwizard.bagisdaten1" );
    HelpUtil.getInstance().enableHelp( this.lblProcessModus, "artikelwizard.bagisdaten1" );
    HelpUtil.getInstance().enableHelp( this.lblProcessNr, "artikelwizard.bagisdaten1" );
    HelpUtil.getInstance().enableHelp( this.lblStatcd1, "artikelwizard.bagisdaten1" );
    HelpUtil.getInstance().enableHelp( this.lblStatcd2, "artikelwizard.bagisdaten1" );
    HelpUtil.getInstance().enableHelp( this.txfAnzKopie, "artikelwizard.bagisdaten1" );
    HelpUtil.getInstance().enableHelp( this.txfFormartCd, "artikelwizard.bagisdaten1" );
    HelpUtil.getInstance().enableHelp( this.txfProcessNr, "artikelwizard.bagisdaten1" );
    HelpUtil.getInstance().enableHelp( this.cbxDruckModus, "artikelwizard.bagisdaten1" );
    HelpUtil.getInstance().enableHelp( this.cbxEinzFaktpos, "artikelwizard.bagisdaten1" );
    HelpUtil.getInstance().enableHelp( this.cbxErfassProc, "artikelwizard.bagisdaten1" );
    HelpUtil.getInstance().enableHelp( this.cbxKzUntschr, "artikelwizard.bagisdaten1" );
    HelpUtil.getInstance().enableHelp( this.cbxProcessModus, "artikelwizard.bagisdaten1" );
    HelpUtil.getInstance().enableHelp( this.cbxStatcd1, "artikelwizard.bagisdaten1" );
    HelpUtil.getInstance().enableHelp( this.cbxStatcd2, "artikelwizard.bagisdaten1" );
    HelpUtil.getInstance().enableHelp( this.ckbKzBesch, "artikelwizard.bagisdaten1" );
    HelpUtil.getInstance().enableHelp( this.ckbKzEinschr, "artikelwizard.bagisdaten1" );
  }
}
