package ch.ige.art.server.dao;

import java.sql.*;
import ch.ige.util.server.DBHelper;

/**
 * Data Access Objekt für DB-Meta-Daten.
 *
 * Copyright (c) 2003, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Marc Bouquet; Johannes Lang
 * @version $Id: InfoDAO.java,v 1.8 2006/12/13 10:08:31 ruegsegger Exp $
 */
public class InfoDAO
{

  /**
   * Standard-Konstruktor
   */
  public InfoDAO()
  {}

  /**
   * Holt die Meta-Daten der Bagis-Datenbank.
   * @return url URL der Bagis-Datenbank
   * @throws SQLException Unerwarteter SQL-Fehler
   */
  public String getBagisDbURL() throws SQLException
  {
    Connection con = DBHelper.getConnection( DBHelper.BAGIS );
    String url = con.getMetaData().getURL();
    con.close();
    return url;
  }
}

