package ch.ige.art.server.dao.test;

import java.util.List;

import ch.ige.art.server.dao.XxDomainDAO;
import ch.ige.art.vo.XxDomainSelKritVO;
import ch.ige.art.vo.XxDomainVO;

/**
 * Test der Klasse xxDomainDAO
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Stefan Nydegger
 * @version $Id: XxDomainDAOTest.java,v 1.9 2008/06/25 13:47:29 ruegsegger Exp $
 */

public class XxDomainDAOTest extends DAOTestCase
{
  private XxDomainDAO xxDomainDAO = new XxDomainDAO();

  /**
   * Test XxDomainDAO
   * @param s
   */
  public XxDomainDAOTest( String s )
  {
    super( s );
  }

  /**
   * Testet SELECT von einer oder mehreren Domains
   */
  public void testSelect()
  {
    XxDomainSelKritVO xxDomainSelKritVO = new XxDomainSelKritVO();
    List<XxDomainVO> list;
    XxDomainVO xxDomainVO;

    // Abfüllen der Selektionskriterien
    xxDomainSelKritVO.domain.add( new String( "adr_typ" ) );
    xxDomainSelKritVO.domain.add( new String( "obj_typ" ) );
    xxDomainSelKritVO.domain.add( new String( "soapurl" ) );
    xxDomainSelKritVO.sprache = 1;

    try
    {
      list = xxDomainDAO.select( xxDomainSelKritVO );

      if ( list == null || list.size() == 0 )
      {
        fail( "No Domains found" );
      }
      else
      {
        for ( int i = 0; i < list.size(); i++ )
        {
          xxDomainVO = list.get( i );
          assertEquals( xxDomainVO.domain, xxDomainSelKritVO.domain.get( i ) );
        }
      }
    }
    catch ( Exception e )
    {
      e.printStackTrace();
      fail( e.toString() );
    }
  }

  /**
   * Testet SELECT von einer Domains
   */
  public void testSelectDomain()
  {
    List<XxDomainVO> list;
    XxDomainVO xxDomainVO;

    try
    {
      list = xxDomainDAO.select( "adr_typ" );

      if ( list == null || list.size() == 0 )
      {
        fail( "No Domains found" );
      }
      else
      {

        for ( int i = 0; i < list.size(); i++ )
        {
          xxDomainVO = list.get( i );
          assertEquals( "adr_typ", xxDomainVO.domain );
        }
      }
    }
    catch ( Exception e )
    {
      e.printStackTrace();
      fail( e.toString() );
    }
  }

  /**
   * Testet SELECT von allen Domains
   */
  public void testSelectAll()
  {
    List<XxDomainVO> list;

    try
    {

      list = xxDomainDAO.select();

      if ( list == null || list.size() == 0 )
      {
        fail( "No Domains found" );
      }
      else
      {
        assertTrue( "Anzahl > 900: ", ( list.size() > 900 ) );
      }
    }
    catch ( Exception e )
    {
      e.printStackTrace();
      fail( e.toString() );
    }
  }
}
