package ch.ige.art.util;

import javax.jms.*;
import javax.naming.*;
import ch.ige.util.jms.*;


/**
 * Receiver for Queue QUEUE_DOMAIN_INFORMATION
 * for incoming messages processMessage-Methode of messageListener is called
 * <p>
 * Copyright (c) 2006, Swiss Federal Institute of Intellectual Property
 * @author A. Rueegsegger
 * @version $Id: DomainJMSReceiver.java,v 1.3 2006/09/07 16:08:00 ruegsegger Exp $
 */
public class DomainJMSReceiver extends JMSReceiver
{
  private static final String APPLICATION_NAME = "artikelgui";

  public final static DomainJMSReceiver createInstance( MessageListener messageListener ) throws NamingException
  {
    JMSFactory jmsFactory = IGEJMSFactory.getInstance();
    Queue domainQueue = jmsFactory.getQueue( IGEJMSFactory.QUEUE_DOMAIN_INFORMATION );
    JMSAccessor a = jmsFactory.getAccessor( APPLICATION_NAME );

    return new DomainJMSReceiver( a, domainQueue, messageListener );
  }


  private DomainJMSReceiver( JMSAccessor accessor, Queue queue, MessageListener listener )
  {
    super( accessor, queue, listener );
  }

}
