package ch.ige.art.util;

import java.util.ArrayList;

/**
 * 
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   ruegsegger
 * @version  $Id: PublicationChapter.java,v 1.1 2007/12/17 16:19:45 ruegsegger Exp $
 */
public class PublicationChapter
{

  /**
   * @param artNr
   * @return
   */
  private static int getSchutitTyp( final String artNr )
  {
    try
    {
      final int art = Integer.parseInt( artNr );

      if ( art >= 10000 && art <= 19999 )
      {
        return 1;
      }
      else if ( art >= 20000 && art <= 29999 )
      {
        return 2;
      }
      else if ( art >= 40000 && art <= 49999 )
      {
        return 4;
      }
      else if ( art >= 60000 && art <= 69999 )
      {
        return 6;
      }
      else if ( art >= 110000 && art <= 119999 )
      {
        return 11;
      }
      else
      {
        return 0;
      }

    }
    catch ( final NumberFormatException e )
    {
      return 0;
    }
  }
  
  public static String getCorrespondingDomainValue( String artNr )
  {
    String publKap = null;
    switch( PublicationChapter.getSchutitTyp( artNr ) )
    {          
      case 1:
      case 2:        
        publKap = XxDomainFactory.PUBL_KAP_PAT;
        break;
      case 4:
        publKap =  XxDomainFactory.PUBL_KAP_CHM ;
       break;
      case 6:
        publKap =  XxDomainFactory.PUBL_KAP_DES;
        break;
      case 11:
        publKap =  XxDomainFactory.PUBL_KAP_ESZ;
        break;  
    }
    return publKap;
  }
}
