package ch.ige.art.util.test;

import java.util.Enumeration;
import java.util.Hashtable;

import junit.framework.TestCase;
import ch.ige.art.server.ArtikelFacadeBean;
import ch.ige.art.util.*;
import ch.ige.util.ServiceLocator;

import javax.naming.*;
import org.apache.log4j.*;

public class DomainJMSReceiverTest extends TestCase
{
  private static final Logger LOG = Logger.getLogger( DomainJMSReceiverTest.class );
  
  public DomainJMSReceiverTest(String s)
  {
    super(s);
    BasicConfigurator.configure();
    
    // init test as standalone client    
    Hashtable hash = ServiceLocator.getRemoteJNDIEnvironment();
       
    Enumeration e = hash.keys();
    while ( e.hasMoreElements())
    {
      String key = (String)e.nextElement(); 
      System.setProperty( key,  (String)hash.get(key) ); 
    }        
  }


  public void test01()
  {
    DomainJMSReceiver receiver = null;

    try
    {
      DomainMessageListener listener = new DomainMessageListener();

      receiver = DomainJMSReceiver.createInstance( listener );
      receiver.start();
      Thread.sleep(30000);
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail(ex.getMessage());
      receiver.stop();
    }
  }
}
