package ch.ige.art.util.test;

import java.util.List;

import junit.framework.TestCase;

import org.apache.log4j.BasicConfigurator;

import ch.ige.art.util.XxDomain;
import ch.ige.art.util.XxDomainFactory;

/**
 * Beschreibung: Junit-Test der Klasse XxDomain
 * Copyright (c) 2005, Institut für Geistiges Eigentum
 * @author A. Rüegsegger
 * @version $Id: XxDomainTest.java,v 1.8 2008/07/02 11:00:20 heinzer Exp $
 */

public class XxDomainTest extends TestCase
{

  static
  {
    // init log4j
    BasicConfigurator.configure();
  }

  public XxDomainTest( String s )
  {
    super( s );
  }

  protected void setUp()
  {
    try
    {
      XxDomain.init();
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.toString() );
    }
  }

  public void test01GetText()
  {
    String text = null;

    text = XxDomain.getText( XxDomainFactory.KONDART_CD, "ALL8050" );
    assertEquals( "Uebertragung", text );

    text = XxDomain.getText( XxDomainFactory.PROCESS_MODUS, "1" );
    assertEquals( "Online manuell", text );

    text = XxDomain.getText( XxDomainFactory.DRUCK_MODUS, "0" );
    assertEquals( "Nur für SETA", text );

    text = XxDomain.getText( XxDomainFactory.KONDART_CD, "" );
    assertEquals( "", text );

    text = XxDomain.getText( XxDomainFactory.KONDART_CD, null );
    assertEquals( "", text );

    text = XxDomain.getText( "not_valid", "ALL8050" );
    assertEquals( "", text );
  }

  public void test02GetLegend()
  {
    String text = null;

    text = XxDomain.getLegend( "ALL8050", XxDomainFactory.KONDART_CD );
    assertEquals( "ALL8050, Uebertragung", text );

    text = XxDomain.getLegend( "1", XxDomainFactory.PROCESS_MODUS );
    assertEquals( "1, Online manuell", text );

    text = XxDomain.getLegend( "0", XxDomainFactory.DRUCK_MODUS );
    assertEquals( "0, Nur für SETA", text );

    text = XxDomain.getLegend( "263", XxDomainFactory.PUBL_KAP );
    assertEquals( "263, Zurückziehungen / Zurückweisungen", text );

    text = XxDomain.getLegend( "A01", XxDomainFactory.KONDART_CD ); //kein gültiger wertebereich
    assertEquals( "A01", text );

    text = XxDomain.getLegend( "ALL8050", "not_valid" );
    assertEquals( "ALL8050", text );

    text = XxDomain.getLegend( null, XxDomainFactory.KONDART_CD );
    assertEquals( null, text );
  }

  public void test03()
  {
    String bez = XxDomain.getBez( "publ_kap_pat", "223" );

    List l1 = XxDomain.getDomains( "publ_kap_pat" );
    System.out.println( l1.size() );

    List l2 = XxDomain.getDomains( "publ_kap_chm" );
    System.out.println( l2.size() );

    List l3 = XxDomain.getDomains( "publ_kap_chm", "publ_kap_pat" );
    System.out.println( l3.size() );

    List l4 = XxDomain.getDomains();

  }
}
