package ch.ige.art.vo;

import java.io.Serializable;

/**
 * Überschrift:   ArtikelAVO
 * Beschreibung:  Value Object der Auswahlanzeige des ArtikelGui
 * Copyright:     Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * Organisation:  IGE
 * @author        Stefan Nydegger
 * @version $Id: ArtikelAVO.java,v 1.7 2008/05/22 09:02:31 ruegsegger Exp $
 */

public class ArtikelAVO implements Serializable
{
  public String artNr = "";

  public String bezArt = "";

  public String kzGratis = "0";

  public String kondartCd = null;

  public String sperrCd = "";

  public String statcd1 = null;

  public String statcd2 = null;

  public String statcd3 = null;

  public String druckModus = "1";

  public String einzFaktpos = "1";

  public String formartCd = null;

  public String kzEinschr = "0";

  public String publPflicht = "0";

  public int regauszGrp = 0;

  public String fristArt = "0";

  public String fristEinh = "0";

  public Integer fristDauer = new Integer( 0 );

  public String kzBesch = "0";

  public Integer erfassProc = null;

  public String processModus = "1";

  public Integer processNr = null;

  //----------------------------------------------------------------------------
  // methods
  //----------------------------------------------------------------------------

  public String toString()
  {
    StringBuffer buf = new StringBuffer();

    buf.append( "  artNr            = <" + this.artNr + "> \n" );
    buf.append( "  bezArt           = <" + this.bezArt + "> \n" );
    buf.append( "  kzGratis         = <" + this.kzGratis + ">\n" );
    buf.append( "  kondartCd        = <" + this.kondartCd + ">\n" );
    buf.append( "  sperrCd          = <" + this.sperrCd + "> \n" );
    buf.append( "  statcd1          = <" + this.statcd1 + ">\n" );
    buf.append( "  statcd2          = <" + this.statcd2 + ">\n" );
    buf.append( "  statcd3          = <" + this.statcd3 + ">\n" );
    buf.append( "  druckModus       = <" + this.druckModus + ">\n" );
    buf.append( "  einzFaktpos      = <" + this.einzFaktpos + ">\n" );
    buf.append( "  formartCd        = <" + this.formartCd + ">\n" );
    buf.append( "  kzEinschr        = <" + this.kzEinschr + ">\n" );
    buf.append( "  publPflicht      = <" + this.publPflicht + ">\n" );
    buf.append( "  regauszGrp       = <" + this.regauszGrp + ">\n" );
    buf.append( "  fristArt         = <" + this.fristArt + ">\n" );
    buf.append( "  fristEinh        = <" + this.fristEinh + ">\n" );
    buf.append( "  fristDauer       = <" + this.fristDauer + ">\n" );
    buf.append( "  kzBesch          = <" + this.kzBesch + ">\n" );
    buf.append( "  erfassProc       = <" + this.erfassProc + ">\n" );
    buf.append( "  processModus     = <" + this.processModus + ">\n" );
    buf.append( "  processNr        = <" + this.processNr + ">\n" );

    return buf.toString();
  }

  /**
   * Gets the artNr.
   * converts article number from String to Integer (sort-order)
   * @return the artNr
   */
  public Integer getArtNr()
  {
    return Integer.valueOf( this.artNr );
  }

  /**
   * Sets the artNr.
   * @param artNr The artNr to set
   */
  public void setArtNr( String artNr )
  {
    this.artNr = artNr;
  }

  /**
   * Gets the bezArt.
   * @return the bezArt
   */
  public String getBezArt()
  {
    return this.bezArt;
  }

  /**
   * Sets the bezArt.
   * @param bezArt The bezArt to set
   */
  public void setBezArt( String bezArt )
  {
    this.bezArt = bezArt;
  }

  /**
   * Gets the kzGratis.
   * @return the kzGratis
   */
  public Boolean getKzGratis()
  {
    return this.kzGratis != null && this.kzGratis.equals( "1" );
  }

  /**
   * Sets the kzGratis.
   * @param kzGratis The kzGratis to set
   */
  public void setKzGratis( String kzGratis )
  {
    this.kzGratis = kzGratis;
  }

  /**
   * Sets the kzGratis.
   * @param kzGratis The kzGratis to set
   */
  public void setKzGratis( Boolean kzGratis )
  {
    this.kzGratis = kzGratis ? "1" : "0";
  }

  /**
   * Gets the kondartCd.
   * @return the kondartCd
   */
  public String getKondartCd()
  {
    return this.kondartCd;
  }

  /**
   * Sets the kondartCd.
   * @param kondartCd The kondartCd to set
   */
  public void setKondartCd( String kondartCd )
  {
    this.kondartCd = kondartCd;
  }

  /**
   * Gets the sperrCd.
   * @return the sperrCd
   */
  public Boolean getSperrCd()
  {
    return this.sperrCd != null && this.sperrCd.equals( "9" );
  }

  /**
   * Sets the sperrCd.
   * @param sperrCd The sperrCd to set
   */
  public void setSperrCd( String sperrCd )
  {
    this.sperrCd = sperrCd;
  }

  /**
   * Gets the statcd1.
   * @return the statcd1
   */
  public String getStatcd1()
  {
    return this.statcd1;
  }

  /**
   * Sets the statcd1.
   * @param statcd1 The statcd1 to set
   */
  public void setStatcd1( String statcd1 )
  {
    this.statcd1 = statcd1;
  }

  /**
   * Gets the statcd2.
   * @return the statcd2
   */
  public String getStatcd2()
  {
    return this.statcd2;
  }

  /**
   * Sets the statcd2.
   * @param statcd2 The statcd2 to set
   */
  public void setStatcd2( String statcd2 )
  {
    this.statcd2 = statcd2;
  }

  /**
   * Gets the statcd3.
   * @return the statcd3
   */
  public String getStatcd3()
  {
    return this.statcd3;
  }

  /**
   * Sets the statcd3.
   * @param statcd3 The statcd3 to set
   */
  public void setStatcd3( String statcd3 )
  {
    this.statcd3 = statcd3;
  }

  /**
   * Gets the druckModus.
   * @return the druckModus
   */
  public String getDruckModus()
  {
    return this.druckModus;
  }

  /**
   * Sets the druckModus.
   * @param druckModus The druckModus to set
   */
  public void setDruckModus( String druckModus )
  {
    this.druckModus = druckModus;
  }

  /**
   * Gets the einzFaktpos.
   * @return the einzFaktpos
   */
  public String getEinzFaktpos()
  {
    return this.einzFaktpos;
  }

  /**
   * Sets the einzFaktpos.
   * @param einzFaktpos The einzFaktpos to set
   */
  public void setEinzFaktpos( String einzFaktpos )
  {
    this.einzFaktpos = einzFaktpos;
  }

  /**
   * Gets the formartCd.
   * @return the formartCd
   */
  public String getFormartCd()
  {
    return this.formartCd;
  }

  /**
   * Sets the formartCd.
   * @param formartCd The formartCd to set
   */
  public void setFormartCd( String formartCd )
  {
    this.formartCd = formartCd;
  }

  /**
   * Gets the kzEinschr.
   * @return the kzEinschr
   */
  public Boolean getKzEinschr()
  {
    return this.kzEinschr != null && this.kzEinschr.equals( "1" );
  }

  /**
   * Sets the kzEinschr.
   * @param kzEinschr The kzEinschr to set
   */
  public void setKzEinschr( String kzEinschr )
  {
    this.kzEinschr = kzEinschr;
  }

  /**
   * Gets the publPflicht.
   * @return the publPflicht
   */
  public String getPublPflicht()
  {
    return this.publPflicht;
  }

  /**
   * Sets the publPflicht.
   * @param publPflicht The publPflicht to set
   */
  public void setPublPflicht( String publPflicht )
  {
    this.publPflicht = publPflicht;
  }

  /**
   * Gets the regauszGrp.
   * @return the regauszGrp
   */
  public int getRegauszGrp()
  {
    return this.regauszGrp;
  }

  /**
   * Sets the regauszGrp.
   * @param regauszGrp The regauszGrp to set
   */
  public void setRegauszGrp( int regauszGrp )
  {
    this.regauszGrp = regauszGrp;
  }

  /**
   * Gets the fristArt.
   * @return the fristArt
   */
  public String getFristArt()
  {
    return this.fristArt;
  }

  /**
   * Sets the fristArt.
   * @param fristArt The fristArt to set
   */
  public void setFristArt( String fristArt )
  {
    this.fristArt = fristArt;
  }

  /**
   * Gets the fristEinh.
   * @return the fristEinh
   */
  public String getFristEinh()
  {
    return this.fristEinh;
  }

  /**
   * Sets the fristEinh.
   * @param fristEinh The fristEinh to set
   */
  public void setFristEinh( String fristEinh )
  {
    this.fristEinh = fristEinh;
  }

  /**
   * Gets the fristDauer.
   * @return the fristDauer
   */
  public Integer getFristDauer()
  {
    return this.fristDauer;
  }

  /**
   * Sets the fristDauer.
   * @param fristDauer The fristDauer to set
   */
  public void setFristDauer( Integer fristDauer )
  {
    this.fristDauer = fristDauer;
  }

  /**
   * Gets the kzBesch.
   * @return the kzBesch
   */
  public Boolean getKzBesch()
  {
    return this.kzBesch != null && this.kzBesch.equals( "1" );
  }

  /**
   * Sets the kzBesch.
   * @param kzBesch The kzBesch to set
   */
  public void setKzBesch( String kzBesch )
  {
    this.kzBesch = kzBesch;
  }

  /**
   * Gets the erfassProc.
   * @return the erfassProc
   */
  public Integer getErfassProc()
  {
    return this.erfassProc;
  }

  /**
   * Sets the erfassProc.
   * @param erfassProc The erfassProc to set
   */
  public void setErfassProc( Integer erfassProc )
  {
    this.erfassProc = erfassProc;
  }

  /**
   * Gets the processModus.
   * @return the processModus
   */
  public String getProcessModus()
  {
    return this.processModus;
  }

  /**
   * Sets the processModus.
   * @param processModus The processModus to set
   */
  public void setProcessModus( String processModus )
  {
    this.processModus = processModus;
  }

  /**
   * Gets the processNr.
   * @return the processNr
   */
  public Integer getProcessNr()
  {
    return this.processNr;
  }

  /**
   * Sets the processNr.
   * @param processNr The processNr to set
   */
  public void setProcessNr( Integer processNr )
  {
    this.processNr = processNr;
  }
}
