package ch.ige.art.vo;

import java.io.Serializable;
import ch.ige.art.xml.*;


/**
 * Überschrift:   ArtikelSelKritVO
 * Beschreibung:  Value Object für Selektionskriterien der Artikel
 * Copyright:     Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * Organisation:  IGE
 * @author        Stefan Nydegger
 * @version $Id: ArtikelSelKritVO.java,v 1.7 2006/12/13 10:08:31 ruegsegger Exp $
 */

public class ArtikelSelKritVO implements Serializable
{
  public String artNr = "";
  public String bezArt = "";
  public String formartCd = "";
  public String	kondartCd = "";
  public Integer erfassProc = null;
  public Integer regauszGrp = null;
  public String publPflicht = "";
  public String statcd3 = "";
  public String	sperrCd = "";

  //----------------------------------------------------------------------------
  // methods
  //----------------------------------------------------------------------------

  public String toString()
  {
    StringBuffer  buf = new StringBuffer();

    buf.append ("  artNr            = <"  + this.artNr          + "> \n");
    buf.append ("  bezArt           = <"  + this.bezArt         + "> \n");
    buf.append ("  formartCd        = <"  + this.formartCd      + "> \n");
    buf.append ("  kondartCd        = <"  + this.kondartCd      + "> \n");
    buf.append ("  erfassProc       = <"  + this.erfassProc     + "> \n");
    buf.append ("  regauszGrp       = <"  + this.regauszGrp     + "> \n");
    buf.append ("  publPflicht      = <"  + this.publPflicht    + "> \n");
    buf.append ("  statcd3          = <"  + this.statcd3        + "> \n");
    buf.append ("  sperrCd          = <"  + this.sperrCd        + "> \n");

    return buf.toString();
  }


  public String getSperrCdText()
  {
    if ( sperrCd == null || sperrCd.equals( "" ) )
    {
      return "";
    }
    else
    {
      return sperrCd.equals( "0" ) ? "0, nicht gesperrt" : "9, gesperrt";
    }
  }
}


