package ch.ige.art.vo.test;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

import ch.ige.art.vo.AltArtVO;
import ch.ige.art.vo.ArtbezVO;
import ch.ige.art.vo.ArtextVO;
import ch.ige.art.vo.ArtikelGuiAVO;
import ch.ige.art.vo.ArtikelVO;
import ch.ige.art.vo.ArtpreisVO;
import ch.ige.art.vo.BArtikelVO;
import ch.ige.art.vo.BformDruckVO;
import ch.ige.art.vo.BformartVO;
import ch.ige.art.vo.BformtxtDruckVO;
import ch.ige.art.vo.MaVO;

/**
 * <p>Überschrift: </p>
 * <p>Beschreibung: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Organisation: Institut für Geistiges Eigentum</p>
 * @author unbekannt
 * @version 1.0
 */

public class Testdata
{

  private static String testArtNr = "999999";

  private static String testFormartCd = "99";

  /* ------------------------------------------------------------------------------------------*/
  /*    ARTIKEL
  /* ------------------------------------------------------------------------------------------*/

  public static ArtikelVO createArtikelVO()
  {
    return createArtikelVO( testArtNr );
  }

  public static ArtikelVO createArtikelVO( final String artNr )
  {
    ArtikelVO artikelVO = new ArtikelVO();

    artikelVO.artNr = artNr;
    artikelVO.altNrCd = "1";
    artikelVO.artgrpCd = artNr;
    artikelVO.bonusCd = "2";
    artikelVO.kondartCd = "ALL8020";
    artikelVO.kzGratis = "1";
    artikelVO.kzMetnot = "1";
    artikelVO.lageinh = "15'";
    artikelVO.minverkMenge = new BigDecimal( 2 );
    artikelVO.optBestMenge = new BigDecimal( 99 );
    artikelVO.provCd = "1";
    artikelVO.sperrCd = "9";
    artikelVO.statcd1 = "200";
    artikelVO.statcd2 = "1";
    artikelVO.statcd3 = "D36";
    artikelVO.suchbegrArt = "TESTARTIKEL";
    artikelVO.erstDat = new java.util.Date();
    artikelVO.erstBen = "junit";
    artikelVO.geaendDat = new java.util.Date();
    artikelVO.geaendBen = "junit";
    artikelVO.status = "I";

    return artikelVO;
  }

  /* ------------------------------------------------------------------------------------------*/
  /*    ARTBEZ
  /* ------------------------------------------------------------------------------------------*/

  public static ArtbezVO createArtBezVO()
  {
    return createArtBezVO( testArtNr );
  }

  public static ArtbezVO createArtBezVO( final String artNr )
  {
    ArtbezVO artbezVO = new ArtbezVO();

    artbezVO.artNr = artNr;
    artbezVO.bezArt = "JUnit-Test";

    return artbezVO;
  }

  /* ------------------------------------------------------------------------------------------*/
  /*    ALTART
  /* ------------------------------------------------------------------------------------------*/

  public static AltArtVO createAltArtVO()
  {
    return createAltArtVO( testArtNr );
  }

  public static AltArtVO createAltArtVO( String artNr )
  {
    AltArtVO altVO = new AltArtVO();
    altVO.artNr = artNr;
    altVO.altArtNr = "18500";
    altVO.priorCd = "1";
    return altVO;
  }

  public static List<AltArtVO> createListAltArtVO( String artNr )
  {
    String[] altArtNr = { "18500", "18100" };
    return createListAltArtVO( artNr, altArtNr );
  }

  public static List<AltArtVO> createListAltArtVO( String artNr, String[] altArtNr )
  {
    AltArtVO altVO = null;
    List<AltArtVO> list = new ArrayList<AltArtVO>();

    for ( int i = 0; i < altArtNr.length; i++ )
    {
      altVO = new AltArtVO();
      altVO.artNr = artNr;
      altVO.altArtNr = altArtNr[i];
      altVO.priorCd = "1";
      altVO.status = "I";

      list.add( altVO );
    }
    return list;
  }

  /* ------------------------------------------------------------------------------------------*/
  /*    ARTEXT
  /* ------------------------------------------------------------------------------------------*/

  public static ArtextVO createArtextVO()
  {
    return createArtextVO( testArtNr );
  }

  public static ArtextVO createArtextVO( String artNr )
  {
    String artTextArtCd = "SCH";
    String sprachCd = "D";
    return createArtextVO( artNr, artTextArtCd, sprachCd );
  }

  public static ArtextVO createArtextVO( String artNr, String artTextArtCd, String sprachCd )
  {
    ArtextVO artextVO = new ArtextVO();
    artextVO.artNr = artNr;
    artextVO.artTextArtCd = artTextArtCd;
    artextVO.sprachCd = sprachCd;
    artextVO.status = "I";
    artextVO.text = "TEST INSERT MIT art_nr: " + artNr + " Sprache= " + artextVO.sprachCd;
    return artextVO;
  }

  public static List<ArtextVO> createListArtextVO( String artNr )
  {
    String[] artTextArtCd = { "SCH", "REG" };
    return createListArtextVO( artNr, artTextArtCd );
  }

  public static List<ArtextVO> createListArtextVO( String artNr, String[] artTextArtCd )
  {
    ArtextVO artextVO = null;
    List<ArtextVO> listText = new ArrayList<ArtextVO>();

    for ( int i = 0; i < artTextArtCd.length; i++ )
    {
      // arttext einfüllen
      for ( int j = 0; j < 3; j++ )
      {
        artextVO = new ArtextVO();
        artextVO.artNr = artNr;
        artextVO.artTextArtCd = artTextArtCd[i];
        artextVO.status = "I";
        switch( j )
        {
          case 0:
            artextVO.sprachCd = "D";
            break;
          case 1:
            artextVO.sprachCd = "F";
            break;
          case 2:
            artextVO.sprachCd = "I";
            break;
        }
        artextVO.text = "TEST INSERT MIT art_nr: " + artNr + " Sprache= " + artextVO.sprachCd;
        listText.add( artextVO );
      }
    }
    return listText;
  }

  /* ------------------------------------------------------------------------------------------*/
  /*    ARTPREIS
  /* ------------------------------------------------------------------------------------------*/

  public static ArtpreisVO createArtpreisVO()
  {
    return createArtpreisVO( testArtNr );
  }

  public static ArtpreisVO createArtpreisVO( String artNr )
  {
    ArtpreisVO artpreisVO = new ArtpreisVO();
    artpreisVO.artNr = artNr;
    artpreisVO.gueltigAb = new java.util.Date();
    artpreisVO.preis = ( new BigDecimal( 100.156 ) ).setScale( 2, BigDecimal.ROUND_HALF_UP );
    artpreisVO.erstBen = "junit";
    artpreisVO.erstDat = new java.util.Date();
    artpreisVO.uVersion = "!";
    artpreisVO.status = "I";

    return artpreisVO;
  }

  public static List<ArtpreisVO> createListArtpreisVO( String artNr )
  {
    String[] artpreisartCd = { "NP", "MRP", "APE" };
    return createListArtpreisVO( artNr, artpreisartCd );
  }

  public static List<ArtpreisVO> createListArtpreisVO( String artNr, String[] artpreisartCd )
  {
    ArtpreisVO artpreisVO = null;
    List<ArtpreisVO> list = new ArrayList<ArtpreisVO>();

    for ( int i = 0; i < artpreisartCd.length; i++ )
    {
      artpreisVO = new ArtpreisVO();
      artpreisVO.artNr = artNr;
      artpreisVO.artpreisartCd = artpreisartCd[i];
      artpreisVO.preis = ( new BigDecimal( 100.50 + i ) ).setScale( 2, BigDecimal.ROUND_HALF_UP );
      artpreisVO.gueltigAb = new java.util.Date();
      artpreisVO.erstBen = "junit";
      artpreisVO.erstDat = new java.util.Date();
      artpreisVO.uVersion = "!";
      artpreisVO.status = "I";

      list.add( artpreisVO );
    }
    return list;
  }

  /* ------------------------------------------------------------------------------------------*/
  /*    BARTIKEL
  /* ------------------------------------------------------------------------------------------*/

  public static BArtikelVO createBartikelVO()
  {
    return createBartikelVO( testArtNr );
  }

  public static BArtikelVO createBartikelVO( String artNr )
  {
    BArtikelVO bArtikelVO = new BArtikelVO();

    bArtikelVO.artNr = artNr;
    bArtikelVO.anzKopie = null;// new Integer(1);
    bArtikelVO.druckModus = "0";
    bArtikelVO.einzFaktpos = "1";
    bArtikelVO.formartCd = null;
    bArtikelVO.kzEinschr = "1";
    bArtikelVO.kzUntschr = "1";
    bArtikelVO.publPflicht = "1";
    bArtikelVO.regauszGrp = 100;
    bArtikelVO.fristArt = "1";
    bArtikelVO.fristEinh = "1";
    bArtikelVO.fristDauer = new Integer( 1 );
    bArtikelVO.kzBesch = "1";
    bArtikelVO.ereigPlaus = null;
    bArtikelVO.erfassProc = null;
    bArtikelVO.processModus = "1";
    bArtikelVO.processNr = new Integer( 1 );
    bArtikelVO.erstDat = new java.util.Date();
    bArtikelVO.erstBen = "junit";
    bArtikelVO.geaendDat = null;
    bArtikelVO.geaendBen = null;

    return bArtikelVO;
  }

  /* ------------------------------------------------------------------------------------------*/
  /*    BFORMART
  /* ------------------------------------------------------------------------------------------*/

  public static BformartVO createBformartVO()
  {
    return createBformartVO( testFormartCd );
  }

  public static BformartVO createBformartVO( String formartCd )
  {
    BformartVO bformartVO = new BformartVO();

    bformartVO.formartCd = formartCd;
    bformartVO.bez = "Junit Bezeichnung";
    bformartVO.druckSystem = "JIPPS";
    bformartVO.version = 0;
    bformartVO.uVersion = "!";
    bformartVO.status = "I";

    return bformartVO;
  }

  /* ------------------------------------------------------------------------------------------*/
  /*    BFORMTXT_DRUCK
  /* ------------------------------------------------------------------------------------------*/

  public static BformtxtDruckVO createBformtxtDruckVO()
  {
    return createBformtxtDruckVO( testFormartCd );
  }

  public static BformtxtDruckVO createBformtxtDruckVO( String formartCd )
  {
    BformtxtDruckVO bformtxtDruckVO = new BformtxtDruckVO();

    bformtxtDruckVO.formartCd = formartCd;
    bformtxtDruckVO.sprachCd = "D";
    bformtxtDruckVO.textart = "1";
    bformtxtDruckVO.text = "Junit Abteilung";
    bformtxtDruckVO.version = 0;
    bformtxtDruckVO.status = "I";

    return bformtxtDruckVO;
  }

  public static List<BformtxtDruckVO> createListBformtxtDruckVO( String formartCd )
  {
    return createListBformtxtDruckVO( formartCd, true, false );
  }

  public static List<BformtxtDruckVO> createListBformtxtDruckVO( String formartCd, boolean art, boolean sprache )
  {
    String[] textart = { "1", "2", "3" };
    String[] sprachCd = { "D", "F", "I" };

    if ( art && sprache )
    {
      return createListBformtxtDruckVO( formartCd, textart, sprachCd );
    }
    else
    {
      return createListBformtxtDruckVO( formartCd, textart );
    }
  }

  public static List<BformtxtDruckVO> createListBformtxtDruckVO( String formartCd, String[] textart )
  {
    BformtxtDruckVO bformtxtDruckVO = null;
    List<BformtxtDruckVO> list = new ArrayList<BformtxtDruckVO>();

    for ( int i = 0; i < textart.length; i++ )
    {
      bformtxtDruckVO = new BformtxtDruckVO();

      bformtxtDruckVO.formartCd = formartCd;
      bformtxtDruckVO.sprachCd = "F";
      bformtxtDruckVO.textart = textart[i];
      bformtxtDruckVO.text = "Junit Textart " + textart[i];
      bformtxtDruckVO.version = 0;
      bformtxtDruckVO.status = "I";

      list.add( bformtxtDruckVO );
    }
    return list;
  }

  public static List<BformtxtDruckVO> createListBformtxtDruckVO( String formartCd, String[] textart, String[] sprachCd )
  {
    BformtxtDruckVO bformtxtDruckVO = null;
    List<BformtxtDruckVO> list = new ArrayList<BformtxtDruckVO>();

    for ( int i = 0; i < textart.length; i++ )
    {
      for ( int j = 0; j < textart.length; j++ )
      {
        bformtxtDruckVO = new BformtxtDruckVO();
        bformtxtDruckVO.formartCd = formartCd;
        bformtxtDruckVO.sprachCd = sprachCd[j];
        bformtxtDruckVO.textart = textart[i];
        bformtxtDruckVO.text = "Junit Textart " + textart[i] + " Sprache " + sprachCd[j];
        bformtxtDruckVO.version = 0;
        bformtxtDruckVO.status = "I";

        list.add( bformtxtDruckVO );
      }
    }
    return list;
  }

  /* ------------------------------------------------------------------------------------------*/
  /*    BFORM_DRUCK
   /* ------------------------------------------------------------------------------------------*/

  public static BformDruckVO createBformDruckVO()
  {
    return createBformDruckVO( testFormartCd );
  }

  public static BformDruckVO createBformDruckVO( String formartCd )
  {
    BformDruckVO bformDruckVO = new BformDruckVO();

    bformDruckVO.bformartVO = createBformartVO( formartCd );
    List<BformtxtDruckVO> listBformtxtDruckVO = createListBformtxtDruckVO( formartCd, true, true );
    bformDruckVO.bformtxtDruckVO = listBformtxtDruckVO.toArray( new BformtxtDruckVO[0] );

    return bformDruckVO;
  }

  /* ------------------------------------------------------------------------------------------*/
  /*    ARTIKELGUIAVO
  /* ------------------------------------------------------------------------------------------*/

  public static ArtikelGuiAVO createArtikelGuiAVO()
  {
    ArtikelGuiAVO artikelGuiAVO = new ArtikelGuiAVO();
    ArtikelVO artikelVO = createArtikelVO();
    BArtikelVO bArtikelVO = createBartikelVO();
    ArtbezVO artbezVO = createArtBezVO();

    List<ArtextVO> listArtextVO = createListArtextVO( testArtNr );
    List<AltArtVO> listAltArtVO = createListAltArtVO( testArtNr );
    List<ArtpreisVO> listArtpreisVO = createListArtpreisVO( testArtNr );

    ArtextVO[] artextVO = listArtextVO.toArray( new ArtextVO[0] );
    AltArtVO[] altArtVO = listAltArtVO.toArray( new AltArtVO[0] );
    ArtpreisVO[] artpreisVO = listArtpreisVO.toArray( new ArtpreisVO[0] );

    artikelGuiAVO.artNr = artikelVO.artNr;
    artikelGuiAVO.artextVO = artextVO;
    artikelGuiAVO.altArtVO = altArtVO;
    artikelGuiAVO.artpreisVO = artpreisVO;
    artikelGuiAVO.bezArt = artbezVO.bezArt;
    artikelGuiAVO.altNrCd = artikelVO.altNrCd;
    artikelGuiAVO.artgrpCd = artikelVO.artgrpCd;
    artikelGuiAVO.bonusCd = artikelVO.bonusCd;
    artikelGuiAVO.kondartCd = artikelVO.kondartCd;
    artikelGuiAVO.kzGratis = artikelVO.kzGratis;
    artikelGuiAVO.kzMetnot = artikelVO.kzMetnot;
    artikelGuiAVO.lageinh = artikelVO.lageinh;
    artikelGuiAVO.minverkMenge = artikelVO.minverkMenge;
    artikelGuiAVO.optBestMenge = artikelVO.optBestMenge;
    artikelGuiAVO.provCd = artikelVO.provCd;
    artikelGuiAVO.sperrCd = artikelVO.sperrCd;
    artikelGuiAVO.statcd1 = artikelVO.statcd1;
    artikelGuiAVO.statcd2 = artikelVO.statcd2;
    artikelGuiAVO.statcd3 = artikelVO.statcd3;
    artikelGuiAVO.suchbegrArt = artikelVO.suchbegrArt;

    artikelGuiAVO.anzKopie = bArtikelVO.anzKopie;
    artikelGuiAVO.druckModus = bArtikelVO.druckModus;
    artikelGuiAVO.einzFaktpos = bArtikelVO.einzFaktpos;
    artikelGuiAVO.formartCd = bArtikelVO.formartCd;
    artikelGuiAVO.kzEinschr = bArtikelVO.kzEinschr;
    artikelGuiAVO.kzUntschr = bArtikelVO.kzUntschr;
    artikelGuiAVO.publPflicht = bArtikelVO.publPflicht;
    artikelGuiAVO.regauszGrp = bArtikelVO.regauszGrp;
    artikelGuiAVO.fristArt = bArtikelVO.fristArt;
    artikelGuiAVO.fristEinh = bArtikelVO.fristEinh;
    artikelGuiAVO.fristDauer = bArtikelVO.fristDauer;
    artikelGuiAVO.kzBesch = bArtikelVO.kzBesch;
    artikelGuiAVO.erfassProc = bArtikelVO.erfassProc;
    artikelGuiAVO.processModus = bArtikelVO.processModus;
    artikelGuiAVO.processNr = bArtikelVO.processNr;

    artikelGuiAVO.status = artikelVO.status;
    artikelGuiAVO.artikelVersion = artikelVO.uVersion == null ? "!" : artikelVO.uVersion;
    artikelGuiAVO.artBezVersion = artbezVO.uVersion == null ? "!" : artbezVO.uVersion;

    return artikelGuiAVO;
  }

  /* ------------------------------------------------------------------------------------------*/
  /*    MA
  /* ------------------------------------------------------------------------------------------*/

  public static MaVO createMaVO()
  {
    MaVO maVO = new MaVO();

    maVO.maNr = 871;
    maVO.maKurzz = "ar";
    maVO.vmsUsername = "ruegsegger";
    maVO.maName = "Rüegsegger";
    maVO.maVname = "Anita";

    return maVO;
  }
}
