package ch.ige.epband.clientneu.test;

import java.io.*;

import org.apache.log4j.BasicConfigurator;

import ch.ige.epband.clientneu.KontrollFileReader;
import ch.ige.epband.vo.StatistikVO;
import junit.framework.TestCase;


/**
 * <p>Überschrift: Europäische Patente (EP) einlesen</p>
 * <p>Beschreibung: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Organisation: Eidgenössisches Institut für Geistiges Eigentum</p>
 * @author A.Rueegsegger
 * @version $Id: KontrollFileReaderTest.java,v 1.8 2007/01/25 17:26:38 ruegsegger Exp $
 */

public class KontrollFileReaderTest extends TestCase
{
  private static final String PATH = "c:\\data\\epband\\";
  private static final String FILENAME = "st320320.zip";

  /**
   * Constructor
   * @param s
   */
  public KontrollFileReaderTest( String s )
  {
    super( s );
    BasicConfigurator.configure();
    //new File(FILENAME).delete();
  }

/** 
 * Testfall
 *
 */
  public void testFile()
  {
    StatistikVO oldVO = new StatistikVO();
    oldVO.anzChzurueck = 100;
    oldVO.anzChzurueckfalse = 2222;
    oldVO.anzcreateEp = 33333;
    oldVO.anzcreateEpfalse = 44444;
    oldVO.anzkeinEinsp = 8745698;
    oldVO.anzkeinEinspfalse = 988856235;
    oldVO.anzWipo = 10;
    oldVO.anzWipofalse = 11;

    try
    {
      File file = new File( PATH );
      if( !file.isDirectory() )
      {
        file.mkdirs();
      }

      KontrollFileReader kreader = new KontrollFileReader( PATH + FILENAME );
      kreader.writeFileEntry( "1", "1234569999", oldVO );
      kreader.readFileEntry();
      String fi = kreader.getWhichFi();
      StatistikVO newVO = kreader.getStatistik();
      String nr = kreader.getGesuchNr();

      assertEquals( "1", fi );
      assertEquals( "1234569999", nr );
      assertEquals( oldVO.toString(), newVO.toString() );

      kreader.writeFileEntry( "0", "123456", oldVO );
      kreader.readFileEntry();
      fi = kreader.getWhichFi();
      newVO = kreader.getStatistik();
      nr = kreader.getGesuchNr();

      assertEquals( "0", fi );
      assertEquals( "123456", nr );
      assertEquals( oldVO.toString(), newVO.toString() );

      kreader.writeFileEntry( "0", "", new StatistikVO() );
      kreader.readFileEntry();
      fi = kreader.getWhichFi();
      newVO = kreader.getStatistik();
      nr = kreader.getGesuchNr();

      assertEquals( "0", fi );
      assertEquals( "", nr );
      assertEquals( new StatistikVO().toString(), newVO.toString() );

      kreader.close();
      
      assertTrue( new File( PATH, "Kontrollfile.txt" ).delete() );
      
    }
    catch( IOException ex )
    {
      fail( ex.getMessage() );
    }
  }
}

