package ch.ige.epband.clientneu.test;

import junit.framework.TestCase;

import org.apache.log4j.BasicConfigurator;

import ch.ige.epband.clientneu.ParseSGML;
import ch.ige.epband.clientneu.RegAdr;
import ch.ige.epband.clientneu.Util;
import ch.ige.epband.util.XMLDoc;
import ch.ige.epband.vo.EpbandVO;
import ch.ige.epband.vo.EreigTxtVO;
import ch.ige.epband.vo.EreignisVO;
import ch.ige.epband.vo.SchutitRegadrVO;
import ch.ige.util.vo.RegadrVO;

/**
 * Junit-Test Adressen mit test-gesuch-adressen.xml
 * <p>
 * Beschreibung:
 * </p>
 * <p>
 * Copyright: Copyright (c) 2003
 * </p>
 * <p>
 * Organisation: Eidgenössisches Institut für Geistiges Eigentum
 * </p>
 * 
 * @author unbekannt
 * @version $id: $
 */

public class TestAdressen extends TestCase
{

  /**
   * Initialisieren der Klasse
   * 
   * @param s
   */
  public TestAdressen( String s )
  {
    super( s );
    BasicConfigurator.configure();
  }

  /**
   * Testfall
   */
  public void test00()
  {
    RegadrVO regadrVO = null;
    SchutitRegadrVO srVO = null;
    EreignisVO ereigVO = null;
    EreigTxtVO ereigTxtVO = null;
    EpbandVO epbandVO = new EpbandVO();

    String adressen = CreateTestpatent.createGesuchAdressen();

    try
    {
      XMLDoc xml = new XMLDoc( adressen );
      ParseSGML parsesgml = new ParseSGML( null );
      parsesgml.setData( epbandVO, xml );

      // Patentart und Änderungsstatus ermitteln
      epbandVO.epArt = xml.getAttribute( "ep-bulletin", "kind" );
      epbandVO.epStatus = xml.getAttribute( "ep-bulletin", "status" );

      // Werte die verwendet werden
      epbandVO.anmeldeIdat = Util.calculateIdat( xml.getValueOf( "B220", "date" ) );
      epbandVO.schutitVO.sprache = 1;

      RegAdr regAdr = new RegAdr( CreateTestpatent.createblandWork() );
      regAdr.parseSGML( xml, epbandVO );

      // RegAdr
      assertEquals( "Anzahl Regadr falsch", 11, epbandVO.regAdrAL.size() );

      regadrVO = epbandVO.regAdrAL.get( 0 );
      assertEquals( "RegName 1 falsch", "Sulzer Osypka GmbH", regadrVO.getRegName() );
      assertEquals( "RegStr 1 falsch", "Basler Strasse 109", regadrVO.getRegStrasse() );
      assertEquals( "RegOrt 1 falsch", "79639 Grenzach-Wyhlen", regadrVO.getRegOrt() );
      assertEquals( "BlandCd 1 falsch", "DE", regadrVO.getBlandCd() );
      assertEquals( "Herkunft", 1, regadrVO.getHerkunft() );
      assertEquals( "HerkAdrNr 1 falsch", 2253470, regadrVO.getHerkAdrNr() );
      assertEquals( "AdrNr 1", 0, regadrVO.getAdrNr() );
      assertEquals( "Gesperrt 1", 0, regadrVO.getGesperrt() );
      assertEquals( "UpVerzName 1 falsch", "Osypka GmbH, Sulzer", regadrVO.getUpVerzName() );
      assertNull( "UpRegOrt 1 falsch", regadrVO.getUpRegOrt() );

      regadrVO = epbandVO.regAdrAL.get( 1 );
      assertEquals( "HerkAdrNr 2 falsch", 0, regadrVO.getHerkAdrNr() );
      assertEquals( "RegName 2 falsch", "Osswald, Stefan", regadrVO.getRegName() );
      assertEquals( "RegStr 2 falsch", "Oberalpstrasse 14", regadrVO.getRegStrasse() );
      assertEquals( "RegOrt 2 falsch", "CH-4054 Basel", regadrVO.getRegOrt() );
      assertEquals( "BlandCd 2 falsch", "CH", regadrVO.getBlandCd() );
      assertEquals( "Herkunft 2", 1, regadrVO.getHerkunft() );
      assertEquals( "AdrNr 2", 0, regadrVO.getAdrNr() );
      assertEquals( "Gesperrt 2", 0, regadrVO.getGesperrt() );
      assertEquals( "UpVerzName 2 falsch", "Osswald, Stefan", regadrVO.getUpVerzName() );
      assertNull( "UpRegOrt 2 falsch", regadrVO.getUpRegOrt() );

      regadrVO = epbandVO.regAdrAL.get( 2 );
      assertEquals( "HerkAdrNr 3 falsch", 0, regadrVO.getHerkAdrNr() );
      assertEquals( "RegName 3 falsch", "Eberhart, Andreas", regadrVO.getRegName() );
      assertEquals( "RegStr 3 falsch", "Bergstrasse 34D", regadrVO.getRegStrasse() );
      assertEquals( "RegOrt 3 falsch", "D-79539 Lörrach", regadrVO.getRegOrt() );
      assertEquals( "BlandCd 3 falsch", "DE", regadrVO.getBlandCd() );
      assertEquals( "Herkunft 3", 1, regadrVO.getHerkunft() );
      assertEquals( "AdrNr 3", 0, regadrVO.getAdrNr() );
      assertEquals( "Gesperrt 3", 0, regadrVO.getGesperrt() );
      assertEquals( "UpVerzName 3 falsch", "Eberhart, Andreas", regadrVO.getUpVerzName() );
      assertNull( "UpRegOrt 3 falsch", regadrVO.getUpRegOrt() );

      regadrVO = epbandVO.regAdrAL.get( 3 );
      assertEquals( "HerkAdrNr 4 falsch", 0, regadrVO.getHerkAdrNr() );
      assertEquals( "RegName 4 falsch", "Baumgartner, Daniel", regadrVO.getRegName() );
      assertEquals( "RegStr 4 falsch", "Baümleweg 5", regadrVO.getRegStrasse() );
      assertEquals( "RegOrt 4 falsch", "D-79639 Grenzach-Wyhlen", regadrVO.getRegOrt() );
      assertEquals( "BlandCd 4 falsch", "DE", regadrVO.getBlandCd() );
      assertEquals( "Herkunft 4", 1, regadrVO.getHerkunft() );
      assertEquals( "AdrNr 4", 0, regadrVO.getAdrNr() );
      assertEquals( "Gesperrt 4", 0, regadrVO.getGesperrt() );
      assertEquals( "UpVerzName 4 falsch", "Baumgartner, Daniel", regadrVO.getUpVerzName() );
      assertNull( "UpRegOrt 4 falsch", regadrVO.getUpRegOrt() );

      regadrVO = epbandVO.regAdrAL.get( 4 );
      assertEquals( "HerkAdrNr 5 falsch", 0, regadrVO.getHerkAdrNr() );
      assertEquals( "RegName 5 falsch", "Prior, Joachim", regadrVO.getRegName() );
      assertEquals( "RegStr 5 falsch", "Nibelungengasse 22/11", regadrVO.getRegStrasse() );
      assertEquals( "RegOrt 5 falsch", "A-8010 Graz", regadrVO.getRegOrt() );
      assertEquals( "BlandCd 5 falsch", "CH", regadrVO.getBlandCd() );
      assertEquals( "Herkunft 5", 1, regadrVO.getHerkunft() );
      assertEquals( "AdrNr 5", 0, regadrVO.getAdrNr() );
      assertEquals( "Gesperrt 5", 0, regadrVO.getGesperrt() );
      assertEquals( "UpVerzName 5 falsch", "Prior, Joachim", regadrVO.getUpVerzName() );
      assertNull( "UpRegOrt 5 falsch", regadrVO.getUpRegOrt() );

      regadrVO = epbandVO.regAdrAL.get( 5 );
      assertEquals( "HerkAdrNr 6 falsch", 598655, regadrVO.getHerkAdrNr() );
      assertEquals( "RegName 6 falsch", "KYORIN PHARMACEUTICAL CO., LTD.", regadrVO.getRegName() );
      assertEquals( "RegStr 6 falsch", "5, Kandasurugadai 2-chome, Chiyoda-ku", regadrVO.getRegStrasse() );
      assertEquals( "RegOrt 6 falsch", "Tokyo 101-8311", regadrVO.getRegOrt() );
      assertEquals( "BlandCd 6 falsch", "JP", regadrVO.getBlandCd() );
      assertEquals( "Herkunft 6", 1, regadrVO.getHerkunft() );
      assertEquals( "AdrNr 6", 0, regadrVO.getAdrNr() );
      assertEquals( "Gesperrt 6", 0, regadrVO.getGesperrt() );
      assertEquals( "UpVerzName 6 falsch", "KYORIN PHARMACEUTICAL CO., LTD.", regadrVO.getUpVerzName() );
      assertNull( "UpRegOrt 6 falsch", regadrVO.getUpRegOrt() );

      regadrVO = epbandVO.regAdrAL.get( 6 );
      assertEquals( "HerkAdrNr 7 falsch", 8000, regadrVO.getHerkAdrNr() );
      assertEquals( "RegName 7 falsch", "APOH - TECHNOLOGIES, Société Anonyme", regadrVO.getRegName() );
      assertEquals( "RegStr 7 falsch", "IRD- Centre de Montpellier -  911, avenue Agropolis", regadrVO.getRegStrasse() );
      assertEquals( "RegOrt 7 falsch", "34032 Montpellier", regadrVO.getRegOrt() );
      assertEquals( "BlandCd 7 falsch", "FR", regadrVO.getBlandCd() );
      assertEquals( "Herkunft 7", 1, regadrVO.getHerkunft() );
      assertEquals( "AdrNr 7", 0, regadrVO.getAdrNr() );
      assertEquals( "Gesperrt 7", 0, regadrVO.getGesperrt() );
      assertEquals( "UpVerzName 7 falsch", "APOH - TECHNOLOGIES, Société Anonyme", regadrVO.getUpVerzName() );
      assertNull( "UpRegOrt 7 falsch", regadrVO.getUpRegOrt() );

      // SchutitRegadr
      assertEquals( "Anzahl SchutitRegadrVO falsch", 12, epbandVO.schutitregAdrAL.size() );

      srVO = epbandVO.schutitregAdrAL.get( 0 );
      assertEquals( "SchutAdrLnr 1", 0, srVO.schutadrLnr );
      assertEquals( "SchutitTyp 1", 2, srVO.schutitTyp );
      assertEquals( "AdrRolleCd 1", 1, srVO.adrRolleCd );
      assertEquals( "VonEreigIdat 1", 1996111305, srVO.vonEreigIdat );
      assertEquals( "Regstat 1", 8, srVO.regStat );
      assertEquals( "RegadrNr 1", 0, srVO.regadrNr );

      srVO = epbandVO.schutitregAdrAL.get( 1 );
      assertEquals( "SchutAdrLnr 2", 0, srVO.schutadrLnr );
      assertEquals( "SchutitTyp 2", 2, srVO.schutitTyp );
      assertEquals( "AdrRolleCd 2", 4, srVO.adrRolleCd );
      assertEquals( "VonEreigIdat 2", 1996111305, srVO.vonEreigIdat );
      assertEquals( "Regstat 2", 8, srVO.regStat );
      assertEquals( "RegadrNr 2", 0, srVO.regadrNr );

      srVO = epbandVO.schutitregAdrAL.get( 2 );
      assertEquals( "SchutAdrLnr 3", 0, srVO.schutadrLnr );
      assertEquals( "SchutitTyp 3", 2, srVO.schutitTyp );
      assertEquals( "AdrRolleCd 3", 4, srVO.adrRolleCd );
      assertEquals( "VonEreigIdat 3", 1996111305, srVO.vonEreigIdat );
      assertEquals( "Regstat 3", 8, srVO.regStat );
      assertEquals( "RegadrNr 3", 0, srVO.regadrNr );

      srVO = epbandVO.schutitregAdrAL.get( 3 );
      assertEquals( "SchutAdrLnr 4", 0, srVO.schutadrLnr );
      assertEquals( "SchutitTyp 4", 2, srVO.schutitTyp );
      assertEquals( "AdrRolleCd 4", 4, srVO.adrRolleCd );
      assertEquals( "VonEreigIdat 4", 1996111305, srVO.vonEreigIdat );
      assertEquals( "Regstat 4", 8, srVO.regStat );
      assertEquals( "RegadrNr 4", 0, srVO.regadrNr );

      srVO = epbandVO.schutitregAdrAL.get( 4 );
      assertEquals( "SchutAdrLnr 5", 0, srVO.schutadrLnr );
      assertEquals( "SchutitTyp 5", 2, srVO.schutitTyp );
      assertEquals( "AdrRolleCd 5", 4, srVO.adrRolleCd );
      assertEquals( "VonEreigIdat 5", 1996111305, srVO.vonEreigIdat );
      assertEquals( "Regstat 5", 8, srVO.regStat );
      assertEquals( "RegadrNr 5", 4069998, srVO.regadrNr );

      srVO = epbandVO.schutitregAdrAL.get( 5 );
      assertEquals( "SchutAdrLnr 6", 0, srVO.schutadrLnr );
      assertEquals( "SchutitTyp 1", 2, srVO.schutitTyp );
      assertEquals( "AdrRolleCd 1", 1, srVO.adrRolleCd );
      assertEquals( "VonEreigIdat 1", 1996111305, srVO.vonEreigIdat );
      assertEquals( "Regstat 1", 8, srVO.regStat );
      assertEquals( "RegadrNr 1", 0, srVO.regadrNr );

      srVO = epbandVO.schutitregAdrAL.get( 6 );
      assertEquals( "SchutAdrLnr 7", 0, srVO.schutadrLnr );
      assertEquals( "SchutitTyp 1", 2, srVO.schutitTyp );
      assertEquals( "AdrRolleCd 1", 1, srVO.adrRolleCd );
      assertEquals( "VonEreigIdat 1", 1996111305, srVO.vonEreigIdat );
      assertEquals( "Regstat 1", 8, srVO.regStat );
      assertEquals( "RegadrNr 1", 0, srVO.regadrNr );

      srVO = epbandVO.schutitregAdrAL.get( 7 );
      assertEquals( "SchutAdrLnr 6", 0, srVO.schutadrLnr );
      assertEquals( "SchutitTyp 6", 2, srVO.schutitTyp );
      assertEquals( "AdrRolleCd 6", 6, srVO.adrRolleCd );
      assertEquals( "VonEreigIdat 6", 2002042705, srVO.vonEreigIdat );
      assertEquals( "Regstat 6", 8, srVO.regStat );
      assertEquals( "RegadrNr 6", 0, srVO.regadrNr );

      // Ereignisse
      assertEquals( "Anzahl Ereignisse falsch", 5, epbandVO.ereigAL.size() );
      ereigVO = epbandVO.ereigAL.get( 4 );
      assertEquals( "EreigIdat muss 2004121315 sein", 2004121315, ereigVO.ereigIdat );

      ereigTxtVO = epbandVO.ereigTxtAL.get( 0 );
      assertEquals( "EreigTextCode muss 2 sein", 2, ereigTxtVO.ereigTxtCd );
      assertEquals( "EreigText muss Ausschliessliche Lizenz sein", "Ausschliessliche Lizenz", ereigTxtVO.ereigTxt );
    }
    catch ( Exception ex )
    {
      ex.printStackTrace();
      fail( ex.getMessage() );
    }
  }
}
