package ch.ige.epband.clientneu.test;

import junit.framework.TestCase;

import org.apache.log4j.BasicConfigurator;

import ch.ige.epband.clientneu.ParseSGML;
import ch.ige.epband.clientneu.Prioritaet;
import ch.ige.epband.clientneu.Util;
import ch.ige.epband.util.XMLDoc;
import ch.ige.epband.vo.EpbandVO;
import ch.ige.epband.vo.PrioritaetVO;

/**
 * Junit-Test Prioritaet mit test-gesuch-prioritaeten.xml
 * <p>
 * Beschreibung:
 * </p>
 * <p>
 * Copyright: Copyright (c) 2003
 * </p>
 * <p>
 * Organisation: Eidgenössisches Institut für Geistiges Eigentum
 * </p>
 * 
 * @author unbekannt
 * @version $id: $
 */

public class TestPrioritaeten extends TestCase
{

  /**
   * Konstruktor
   * @param s
   */
  public TestPrioritaeten( String s )
  {
    super( s );
    BasicConfigurator.configure();
  }

  /** 
   * Testen, ob alle Prioritätsdaten richtig aufbereitet werden.
   *
   */
  public void test00()
  {
    PrioritaetVO prioVO = null;
    EpbandVO epbandVO = new EpbandVO();

    String prioritaeten = CreateTestpatent.createPrioritaeten();

    try
    {
      XMLDoc xml = new XMLDoc( prioritaeten );
      ParseSGML parsesgml = new ParseSGML( null );
      parsesgml.setData( epbandVO, xml );

      // Patentart und Änderungsstatus ermitteln
      epbandVO.epArt = xml.getAttribute( "ep-bulletin", "kind" );
      epbandVO.epStatus = xml.getAttribute( "ep-bulletin", "status" );

      Prioritaet prioritaet = new Prioritaet( CreateTestpatent.createblandWork() );
      prioritaet.parseSGML( xml, epbandVO );

      // Priorität
      assertEquals( "Anzahl Priorität falsch", 3, epbandVO.prioAL.size() );

      prioVO = epbandVO.prioAL.get( 0 );
      assertEquals( "PrioLaufNr falsch", 1, prioVO.prioLnr );
      assertEquals( "PrioNr falsch", "PP904799", prioVO.prioNr );
      assertEquals( "PrioBlandCd falsch", "AU", prioVO.blandCd );
      assertEquals( "PrioDat falsch", Util.stringToDate( "19990304" ), prioVO.prioDat );
      assertEquals( "RegStat Prio", 8, prioVO.regStat );

      prioVO = epbandVO.prioAL.get( 1 );
      assertEquals( "PrioLaufNr falsch", 2, prioVO.prioLnr );
      assertNull( "PrioNr falsch", prioVO.prioNr );
      assertEquals( "RrioBland falsch", "CH", prioVO.blandCd );
      assertNull( "PrioDat falsch", prioVO.prioDat );
      assertEquals( "RegStat Prio", 8, prioVO.regStat );

      prioVO = epbandVO.prioAL.get( 2 );
      assertEquals( "PrioLaufNr falsch", 3, prioVO.prioLnr );
      assertEquals( "PrioNr falsch", "AA904N99", prioVO.prioNr );
      assertEquals( "RrioBland falsch", "CH", prioVO.blandCd );
      assertNull( "PrioDat falsch", prioVO.prioDat );
      assertEquals( "RegStat Prio", 8, prioVO.regStat );
    }
    catch ( Exception ex )
    {
      fail( ex.getMessage() );
      ex.printStackTrace();
    }
  }
}
