package ch.ige.epband.server.dao.test;

import ch.ige.epband.server.dao.SchutitDAO;
import ch.ige.epband.vo.SchutitVO;
import ch.ige.epband.vo.test.Testdata;
import ch.ige.util.IGEDate;


/**
 * Junit-Test der Klasse SchutitDAO
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: SchutitDAOTest.java,v 1.6 2007/07/20 11:17:40 wild Exp $
 */

public class SchutitDAOTest extends DAOTestCase
{
  SchutitDAO schutitDAO = new SchutitDAO();
  SchutitVO schutitVO = null;

  /**
   * Konstruktor 
   * @param s
   */
  public SchutitDAOTest( String s )
  {
    super( s );
  }

/**
 * Titel einfügen
 *
 */
  public void test00Insert()
  {
    try
    {
      schutitVO = Testdata.createSchutit();
      int result = schutitDAO.insert( schutitVO );
      assertEquals(1, result);
    }
    catch( Exception ex )
    {
      fail(ex.getMessage());
    }
  }

  /**
   * Vorhanden sein testen 1. 
   *
   */
  public void test01Exist()
  {
    try
    {
      schutitVO = Testdata.createSchutit();
      int schutitKey = schutitDAO.selectSchutitKeyWithGesuchNr( schutitVO.gesuchNr,
          schutitVO.schutitTyp );
      assertEquals(schutitVO.schutitKey, schutitKey );
    }
    catch( Exception ex )
    {
      fail(ex.getMessage());
    }
  }

  /**
   * Vorhanden sein testen 2. 
   *
   */
  public void test02Exist()
  {
    try
    {
      schutitVO = Testdata.createSchutit();
      int schutitKey = schutitDAO.selectSchutitKeyWithSchutitNr( schutitVO.schutitNr,
          schutitVO.schutitTyp );
      assertEquals(schutitVO.schutitKey, schutitKey );
    }
    catch( Exception ex )
    {
      fail(ex.getMessage());
    }
  }


  /**
   * Update
   *
   */
  public void test03Update()
  {
    try
    {
      schutitVO = Testdata.createSchutit();
      schutitVO.loeschDat = IGEDate.stringToDate( "13.06.2002" );
      int result = schutitDAO.updateSchutit( schutitVO );
      assertEquals(1, result);
    }
    catch( Exception ex )
    {
      fail(ex.getMessage());
    }
  }
  
/**
 * Schutit löschen
 * 
 */
  public void test99Delete()
  {
    try
     {
       schutitVO = Testdata.createSchutit();
       int result = schutitDAO.deleteSchutit( schutitVO.schutitKey );
       assertEquals(1, result);
     }
     catch( Exception ex )
     {
       fail(ex.getMessage());
     }

  }
}
