package ch.ige.epband.vo;

import java.io.Serializable;
import java.util.Date;

/**
 * Überschrift:   PatVO
 * Beschreibung:  PatVO ist das VO der Tabelle Pat.
 * Copyright:     Copyright (c) 2002
 * Organisation:  IGE
 * @author       Daniel Haller Strahm
 * @version      $Id: PatVO.java,v 1.10 2008/05/22 15:53:18 ruegsegger Exp $
 */

public class PatVO implements Serializable
{
  /**
   *  Defaultwert für die serialVersionUID
   */
  private static final long serialVersionUID = 1L;

  public int schutitKey = 0;

  public int patVerfahr = 0;

  public String pctAnmNr = null;

  public String pctAnmSpra = null;

  public String pctPublNr = null;

  public String pctPublSpra = null; // wird nicht geliefert

  public Date pctPublDat = null;

  public String epAnmSpra = null;

  public String epApublSpra = null;

  public Date epApublDat = null;

  public String epBpublSpra = null;

  public Date epBpublDat = null;

  public String epStammpatNr = null;

  /**
   * Gibt den Inhalt des ValueObject PatVO zurück
   * @return Inhalt von PatVO
   */
  @Override
  public String toString()
  {
    StringBuffer buf = new StringBuffer();

    buf.append( "  schutitKey       = <" + this.schutitKey + ">\n" );
    buf.append( "  patVerfahr       = <" + this.patVerfahr + ">\n" );
    buf.append( "  pctAnmNr         = <" + this.pctAnmNr + ">\n" );
    buf.append( "  pctAnmSpra       = <" + this.pctAnmSpra + ">\n" );
    buf.append( "  pctPublNr        = <" + this.pctPublNr + ">\n" );
    buf.append( "  pctPublSpra      = <" + this.pctPublSpra + ">\n" );
    buf.append( "  pctPublDat       = <" + this.pctPublDat + ">\n" );
    buf.append( "  epAnmSpra        = <" + this.epAnmSpra + ">\n" );
    buf.append( "  epApublSpra      = <" + this.epApublSpra + ">\n" );
    buf.append( "  epApublDat       = <" + this.epApublDat + ">\n" );
    buf.append( "  epBpublSpra      = <" + this.epBpublSpra + ">\n" );
    buf.append( "  epBpublDat       = <" + this.epBpublDat + ">\n" );
    buf.append( "  epStammpatNr     = <" + this.epStammpatNr + ">\n" );

    return buf.toString();
  }
}
