package ch.ige.epband.vo.test;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import ch.ige.epband.clientneu.Ereignis;
import ch.ige.epband.vo.EreigTxtVO;
import ch.ige.epband.vo.EreignisVO;
import ch.ige.epband.vo.IpcVO;
import ch.ige.epband.vo.PatIpcVO;
import ch.ige.epband.vo.PatVO;
import ch.ige.epband.vo.PrioritaetVO;
import ch.ige.epband.vo.SchutitEmpfadrVO;
import ch.ige.epband.vo.SchutitRegadrVO;
import ch.ige.epband.vo.SchutitVO;
import ch.ige.util.IGEDate;

/**
 * <p>Überschrift: Europäische Patente (EP) einlesen</p>
 * <p>Beschreibung: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Organisation: Eidgenössisches Institut für Geistiges Eigentum</p>
 * @author unbekannt
 * @version $id: $
 */

public class Testdata
{
  private static int schutitKey = 1300000000;

  private static int ereigIdat = 2005121405;

  private static SimpleDateFormat sdf = new SimpleDateFormat( "yyyyMMdd" );

  public static SchutitVO createSchutit() throws ParseException
  {
    SchutitVO schutitVO = new SchutitVO();

    schutitVO.schutitKey = schutitKey;
    schutitVO.schutitTyp = SchutitVO.SCHUTIT_TYP_EP;
    schutitVO.sprache = 1;
    schutitVO.gesuchNr = "022974248";
    schutitVO.schutitNr = "2006999999";
    schutitVO.schutzBegin = IGEDate.stringToDate( "13.11.1996" );
    schutitVO.schutzEnde = IGEDate.stringToDate( "12.11.2016" );
    schutitVO.loeschDat = IGEDate.stringToDate( "23.05.2002" );
    schutitVO.beschreibung = "Junit-Test äöü @$()éèàñâï";
    schutitVO.erstEreigDat = IGEDate.stringToDate( "13.11.1996" );
    schutitVO.faelligJahr = 2300;

    return schutitVO;
  }

  public static PrioritaetVO createPrioritaet() throws Exception
  {
    PrioritaetVO priortaetVO = new PrioritaetVO();

    priortaetVO.schutitKey = schutitKey;
    priortaetVO.blandCd = "CH";
    priortaetVO.prioNr = "PP904799";
    priortaetVO.regStat = 8;
    priortaetVO.prioDat = sdf.parse( "19990304" );
    priortaetVO.prioLnr = 1;

    return priortaetVO;
  }

  public static PatVO createPat() throws Exception
  {
    PatVO patVO = new PatVO();

    patVO.schutitKey = schutitKey;
    patVO.pctAnmSpra = "";
    patVO.patVerfahr = 6;
    patVO.epAnmSpra = "De";
    patVO.epApublSpra = "De";
    patVO.epApublDat = IGEDate.stringToDate( "20.05.1998" );

    return patVO;
  }

  public static EreigTxtVO createEreigTxt() throws Exception
  {
    EreigTxtVO ereigTxtVO = new EreigTxtVO();

    ereigTxtVO.schutitKey = schutitKey;
    ereigTxtVO.ereigIdat = ereigIdat;
    ereigTxtVO.ereigTxtCd = 1;
    ereigTxtVO.ereigTxt = "EreignisText";

    return ereigTxtVO;
  }

  public static EreignisVO createEreignisErsterfassung()
  {
    EreignisVO ereignisVO = new EreignisVO();

    ereignisVO.schutitKey = schutitKey;
    ereignisVO.ereigIdat = ereigIdat;
    ereignisVO.maNr = 199;
    ereignisVO.ereigStatNr = 20;
    ereignisVO.artNr = EreignisVO.ERSTERFASSUNG;
    ereignisVO.regStat = 8;

    return ereignisVO;
  }

  public static EreignisVO createEreignisCHZuruecknahme()
  {
    EreignisVO ereignisVO = new Ereignis().getEreignisZuruecknahme();

    ereignisVO.schutitKey = schutitKey;
    ereignisVO.ereigIdat = ereigIdat;

    return ereignisVO;
  }

  public static SchutitRegadrVO createSchutitRegAdr()
  {
    SchutitRegadrVO schutitRegAdrVO = new SchutitRegadrVO();

    schutitRegAdrVO.schutitKey = schutitKey;
    schutitRegAdrVO.regadrNr = 11299915;
    schutitRegAdrVO.schutitTyp = SchutitVO.SCHUTIT_TYP_EP;
    schutitRegAdrVO.adrRolleCd = 1;
    schutitRegAdrVO.vonEreigIdat = ereigIdat;
    schutitRegAdrVO.regStat = 8;

    return schutitRegAdrVO;
  }

  public static SchutitEmpfadrVO createSchutitEmpfAdr()
  {
    SchutitEmpfadrVO schutitEmpfadrVO = new SchutitEmpfadrVO();

    schutitEmpfadrVO.schutitKey = schutitKey;
    schutitEmpfadrVO.adrNr = 6017910;
    schutitEmpfadrVO.empfTyp = 3;
    schutitEmpfadrVO.erfassMa = new Integer( 199 );

    return schutitEmpfadrVO;
  }

  /**
   * Erstellt ein PatIpcVO
   * @return PatIpcVO
   */
  public static PatIpcVO createPatIpcVO() throws ParseException
  {
    PatIpcVO patIpcVO = new PatIpcVO();

    patIpcVO.schutitKey = 2100393404;
    patIpcVO.patIpcCd = PatIpcVO.IPC_CD_N;
    patIpcVO.patIpcLnr = 1;
    patIpcVO.ipcSymb = "B25B000712";
    patIpcVO.ipcGueltigVon = sdf.parse( "20060101" );
    patIpcVO.erfassDat = new Date();

    return patIpcVO;
  }

  /**
   * Erstellt ein IpcVO
   * @return IpcVO
   */
  public static IpcVO createIpcVO() throws ParseException
  {
    IpcVO ipcVO = new IpcVO();

    ipcVO.ipcSymb = "A01B000116";
    ipcVO.zusatz = IpcVO.ZUSATZ_CLASSIFICATION;
    ipcVO.gueltigVon = sdf.parse( "20060101" );
    ipcVO.gueltigBis = null;
    ipcVO.classLevel = "A";
    ipcVO.corePred = "A01B0001000000";
    ipcVO.version = 0;

    return ipcVO;
  }
}
