package ch.ige.image.test;

import java.io.File;
import java.io.IOException;

import ch.ige.image.EncodedImage;
import ch.ige.image.ImageException;
import ch.ige.image.ImageFactoryImpl;

/**
 * Some example images.
 *
 * <p>Copyright (c) 2008, Swiss Federal Institute of Intellectual Property</p>
 * @author   Michael Locher
 * @version  $Id: SampleImages.java,v 1.4 2008/08/07 14:45:52 locher Exp $
 */
public class SampleImages
{

  public static EncodedImage getCirclePNG() throws Exception
  {
    return load( "circle.png" );
  }

  public static EncodedImage getAnimatedGIF() throws IOException, ImageException
  {
    return loadFile( "test_img/Image_Format/animatedGif.gif" );
  }

  public static EncodedImage getRGBImageWithICCProfile() throws IOException, ImageException
  {
    return loadFile( "test_img/Colormanagement/RGB/TestRGBA16.tif" );
  }

  public static EncodedImage getGrayImageWithICCProfile() throws IOException, ImageException
  {
    return loadFile( "test_img/Colormanagement/Gray/TestGrayA16.tif" );
  }

  public static EncodedImage getCYMKImageWithICCProfile() throws IOException, ImageException
  {
    return loadFile( "test_img/Colormanagement/CMYK/TestCMYKA8.tif" );
  }

  public static EncodedImage getGrayDesignTIFF() throws Exception
  {
    return loadFile( "test_img/Random_Customer_ProblemImages/grayScaleDesign_1201663207_8.tif" );
  }

  private static EncodedImage loadFile( String path ) throws IOException, ImageException
  {
    return new ImageFactoryImpl().loadFile( new File( path ) );
  }

  private static EncodedImage load( String name ) throws Exception
  {
    return new ImageFactoryImpl().loadURL( ImageFactoryTest.class.getResource( name ) );
  }

}
