package ch.ige.imagehandler.rule;

import ch.ige.image.Image;
import ch.ige.image.ImageException;

/**
 * A Rule for Converting Images.
 * <p>
 * Copyright (c) 2005, Swiss Federal Institute of Intellectual Property
 * 
 * @author Michael Locher
 * @version $Id: Converter.java,v 1.7 2009/04/14 11:38:02 locher Exp $
 */
public interface Converter<I extends Image, O extends Image> extends Rule<I>
{

  /**
   * Converts the image and leaves the source image unaffected.
   * @param source the source image
   * @return the converted image or the source image if "passed-through"
   * @throws RuleException if the rule is not applicable
   * @throws ImageException if imaging operations fail
   */
  public O convert( I source ) throws RuleException, ImageException;
}
