package ch.ige.imagehandler.test;

import junit.framework.TestCase;

import org.apache.log4j.BasicConfigurator;

import ch.ige.imagehandler.profile.Profile;
import ch.ige.imagehandler.profile.ProfileFactory;
import ch.ige.imagehandler.rule.Rule;
import ch.ige.imagehandler.rule.RuleException;
import ch.ige.imagehandler.rule.RuleVisitor;

/**
 * Test Image Profile.
 * <p>
 * Copyright (c) 2005, Swiss Federal Institute of Intellectual Property
 * 
 * @author Michael Locher
 * @version $Id: ProfileTest.java,v 1.11 2007/05/30 16:31:10 locher Exp $
 */
public class ProfileTest extends TestCase
{

  public ProfileTest( String name )
  {
    super( name );
  }

  public void testRuleVisitor() throws Exception
  {
    final int NUMBER_OF_ROLE_NODES = 26;
    Profile p = ProfileFactory.createFromXML( ProfileFactoryTest.getProfile() );
    RuleCounter counter = new RuleCounter();
    p.getRules( "checkingRules" ).accept( counter );
    assertEquals( "Count of Full Traversal", NUMBER_OF_ROLE_NODES, counter.nodeCount );
  }

  private static class RuleCounter implements RuleVisitor
  {
    public int nodeCount;

    public void handleRule( Rule rule ) throws RuleException
    {
      this.nodeCount++;
    }
  }

  public static void main( String[] args )
  {
    BasicConfigurator.configure();
    junit.textui.TestRunner.run( ProfileTest.class );
  }

}
