package ch.ige.ipcloadscheme.client.file;

import java.util.Date;

/**
 * Repräsentiert ein Http-File
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: HttpFile.java,v 1.6 2008/07/01 06:25:50 lewis_lee Exp $
 */
public class HttpFile extends ProcessableFile
{
  protected String contentType = "text/html";

  protected String url = null;

  public HttpFile( String pathname, Date processingDate )
  {
    super( pathname, processingDate );
  }

  public HttpFile( String parent, String child, Date processingDate )
  {
    super( parent, child, processingDate );
  }

  public String getUrl()
  {
    return url;
  }

  public void checkContentType( String type ) throws Exception
  {
    if ( !this.contentType.equals( type ) )
    {
      throw new Exception( "content type is: " + type + " expected type is: " + contentType );
    }
  }
}
