package ch.ige.ipcloadscheme.client.test;

import java.util.Locale;

import junit.framework.TestCase;

import org.apache.log4j.BasicConfigurator;

import ch.ige.ipcloadscheme.client.IPCLoad;
import ch.ige.ipcloadscheme.client.SchemeProperties;
import ch.ige.util.client.batch.BatchReportFile;
import ch.ige.util.client.batch.BatchReportMail;

/**
 * The base class for all tests, initializes the configuration for local runs.
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   ruegsegger
 * @version  $Id: ClientTestCase.java,v 1.2 2008/07/01 06:27:02 lewis_lee Exp $
 */
public class ClientTestCase extends TestCase
{
  /**
   * Creates this.
   * @param name The test's name
   */
  public ClientTestCase( String name )
  {
    super( name );
  }

  static
  {
    BasicConfigurator.configure();
    String configfile = "file:///c:/jp/projects/ipcloadscheme/install/programme/ige/ipcloadscheme/config/ipcloadscheme.properties";
    System.setProperty( SchemeProperties.CONFIG, configfile );
    System.setProperty( SchemeProperties.MAIL_SMTP_HOST, "dummy" );
    System.setProperty( SchemeProperties.MAIL_SEND_FROM, "dummy" );
    System.setProperty( SchemeProperties.MAIL_SEND_TO, "dummy" );
    System.setProperty( SchemeProperties.MAIL_SEND_CC, "dummy" );
    System.setProperty( BatchReportMail.TEST_MAIL_FILE, BatchReportFile.REPORT_DIRECTORY + "ipcloadscheme.mail" );
    System.setProperty( SchemeProperties.CONFIG_PATH, "C:\\jp\\projects\\ipcloadscheme\\install\\programme\\ige\\ipcloadscheme\\config\\" );

    for ( Locale acceptedLanguage: IPCLoad.ACCEPTED_LANGUAGES )
    {
      System.setProperty( SchemeProperties.XSL_FILE + acceptedLanguage.getLanguage(),
          "c:\\jp\\projects\\ipcloadscheme\\install\\programme\\ige\\ipcloadscheme\\config\\ipcr_scheme_" + acceptedLanguage.getLanguage() + ".xsl" );
    }
  }
}
