package ch.ige.ipcloadscheme.server;

import ch.ige.util.ServiceLocator;
import java.util.*;
import ch.ige.ipcloadscheme.vo.IpcKlasseVO;
import ch.ige.ipcloadscheme.vo.CountVO;
import ch.ige.ipcloadscheme.vo.IpcBildVO;


/**
 * Delegate
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $ Id: $
 */
public class IpcSchemeDelegate
{

  private static IpcSchemeDelegate ipcSchemeDelegate;
  private IpcSchemeFacade facade;
  private static final Class HOME_CLASS = IpcSchemeFacadeHome.class;


  // Singleton
  private IpcSchemeDelegate() throws Exception
  {
    /** TODO schlaue meldung zurückgeben */
    IpcSchemeFacadeHome home = (IpcSchemeFacadeHome)
        ServiceLocator.getInstance().getHome("IpcSchemeFacade", HOME_CLASS);
    facade = home.create();
  }


  /**
   * Gibt die einzige Instanz zurück (Singleton)
   * @return EpbandDelegate
   * @throws EpbandException
   */
  public static IpcSchemeDelegate getInstance() throws Exception
  {
    if (ipcSchemeDelegate == null)
    {
      ipcSchemeDelegate = new IpcSchemeDelegate();
    }
    return ipcSchemeDelegate;
  }



  public CountVO insertKlasse( Map mapKlassen ) throws Exception
  {
    return facade.insertKlassen( mapKlassen );
  }


  public CountVO insertBildKlasse( Map mapBilder ) throws Exception
  {
    return facade.insertBildKlassen(mapBilder);
  }


  public CountVO alterKlassen( Map mapIpcVOs ) throws Exception
  {
    return facade.alterKlassen( mapIpcVOs );
  }


  public CountVO alterBildKlassen( Map mapBilder ) throws Exception
  {
    return facade.alterBildKlassen( mapBilder );
  }


  public void insert( IpcKlasseVO vo ) throws Exception
  {
    facade.insert(vo);
  }


  public void insertImage( IpcBildVO ipcBildVO ) throws Exception
  {
    facade.insertImage( ipcBildVO );
  }

}
