package ch.ige.ipcloadvalidity.client;

import java.io.File;
import java.io.FilenameFilter;

import ch.ige.ipcloadvalidity.util.ValidityProperties;


/**
 * Filter für Validity-File
 * Werte werden anhand Config-Datei ipcloadvalidity.properties ermittelt
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger
 * @version $Id: ValidityFilter.java,v 1.12 2008/07/01 06:31:40 kuenzli Exp $
 */
public class ValidityFilter implements FilenameFilter
{

  public ValidityFilter()
  {
  }


  /**
   * Überprüft ob es sich bei der Datei um ein Validity-File handelt
   * @param dir File Datei
   * @param name String Dateiname
   * @return boolean true falls akzeptiert
   */
  public boolean accept(File dir, String name)
  {
    File unzipDir = new File(ValidityProperties.getInstance().getProperty(ValidityProperties.UNZIP_DIRECTORY));

    return  dir != null &&
            dir.getAbsolutePath().equals( unzipDir.getAbsolutePath() ) &&
            name.matches(ValidityProperties.getInstance().getProperty( ValidityProperties.VALIDITY_NAME) );
  }
}
