
package ch.ige.ipcloadvalidity.xml.generate;

import java.io.IOException;
import java.io.InputStream;
import javax.xml.bind.ConversionException;
import javax.xml.bind.Dispatcher;
import javax.xml.bind.DuplicateAttributeException;
import javax.xml.bind.Element;
import javax.xml.bind.InvalidAttributeException;
import javax.xml.bind.LocalValidationException;
import javax.xml.bind.MarshallableObject;
import javax.xml.bind.Marshaller;
import javax.xml.bind.MissingAttributeException;
import javax.xml.bind.StructureValidationException;
import javax.xml.bind.UnmarshalException;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.Validator;
import javax.xml.marshal.XMLScanner;
import javax.xml.marshal.XMLWriter;


public class IpcrSymbol
    extends MarshallableObject
    implements Element
{

    private String _ClassificationLevel;
    private String _EntryType;
    private String _ValidityDateFrom;
    private String _ValidityDateTo;
    private String _CorePredecessor;
    private String _MainGroup;
    private String _Subgroup;

    public String getClassificationLevel() {
        return _ClassificationLevel;
    }

    public void setClassificationLevel(String _ClassificationLevel) {
        this._ClassificationLevel = _ClassificationLevel;
        if (_ClassificationLevel == null) {
            invalidate();
        }
    }

    public String getEntryType() {
        return _EntryType;
    }

    public void setEntryType(String _EntryType) {
        this._EntryType = _EntryType;
        if (_EntryType == null) {
            invalidate();
        }
    }

    public String getValidityDateFrom() {
        return _ValidityDateFrom;
    }

    public void setValidityDateFrom(String _ValidityDateFrom) {
        this._ValidityDateFrom = _ValidityDateFrom;
        if (_ValidityDateFrom == null) {
            invalidate();
        }
    }

    public String getValidityDateTo() {
        return _ValidityDateTo;
    }

    public void setValidityDateTo(String _ValidityDateTo) {
        this._ValidityDateTo = _ValidityDateTo;
        if (_ValidityDateTo == null) {
            invalidate();
        }
    }

    public String getCorePredecessor() {
        return _CorePredecessor;
    }

    public void setCorePredecessor(String _CorePredecessor) {
        this._CorePredecessor = _CorePredecessor;
        if (_CorePredecessor == null) {
            invalidate();
        }
    }

    public String getMainGroup() {
        return _MainGroup;
    }

    public void setMainGroup(String _MainGroup) {
        this._MainGroup = _MainGroup;
        if (_MainGroup == null) {
            invalidate();
        }
    }

    public String getSubgroup() {
        return _Subgroup;
    }

    public void setSubgroup(String _Subgroup) {
        this._Subgroup = _Subgroup;
        if (_Subgroup == null) {
            invalidate();
        }
    }

    public void validateThis()
        throws LocalValidationException
    {
        if (_ClassificationLevel == null) {
            throw new MissingAttributeException("classification-level");
        }
        if (_EntryType == null) {
            throw new MissingAttributeException("entry-type");
        }
        if (_ValidityDateFrom == null) {
            throw new MissingAttributeException("validity-date-from");
        }
    }

    public void validate(Validator v)
        throws StructureValidationException
    {
    }

    public void marshal(Marshaller m)
        throws IOException
    {
        XMLWriter w = m.writer();
        w.start("ipcr-symbol");
        w.attribute("classification-level", _ClassificationLevel.toString());
        w.attribute("entry-type", _EntryType.toString());
        w.attribute("validity-date-from", _ValidityDateFrom.toString());
        if (_ValidityDateTo!= null) {
            w.attribute("validity-date-to", _ValidityDateTo.toString());
        }
        if (_CorePredecessor!= null) {
            w.attribute("core-predecessor", _CorePredecessor.toString());
        }
        if (_MainGroup!= null) {
            w.leaf("main-group", _MainGroup.toString());
        }
        if (_Subgroup!= null) {
            w.leaf("subgroup", _Subgroup.toString());
        }
        w.end("ipcr-symbol");
    }

    public void unmarshal(Unmarshaller u)
        throws UnmarshalException
    {
        XMLScanner xs = u.scanner();
        Validator v = u.validator();
        xs.takeStart("ipcr-symbol");
        while (xs.atAttribute()) {
            String an = xs.takeAttributeName();
            if (an.equals("classification-level")) {
                if (_ClassificationLevel!= null) {
                    throw new DuplicateAttributeException(an);
                }
                _ClassificationLevel = xs.takeAttributeValue();
                continue;
            }
            if (an.equals("entry-type")) {
                if (_EntryType!= null) {
                    throw new DuplicateAttributeException(an);
                }
                _EntryType = xs.takeAttributeValue();
                continue;
            }
            if (an.equals("validity-date-from")) {
                if (_ValidityDateFrom!= null) {
                    throw new DuplicateAttributeException(an);
                }
                _ValidityDateFrom = xs.takeAttributeValue();
                continue;
            }
            if (an.equals("validity-date-to")) {
                if (_ValidityDateTo!= null) {
                    throw new DuplicateAttributeException(an);
                }
                _ValidityDateTo = xs.takeAttributeValue();
                continue;
            }
            if (an.equals("core-predecessor")) {
                if (_CorePredecessor!= null) {
                    throw new DuplicateAttributeException(an);
                }
                _CorePredecessor = xs.takeAttributeValue();
                continue;
            }
            throw new InvalidAttributeException(an);
        }
        if (xs.atStart("main-group")) {
            xs.takeStart("main-group");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _MainGroup = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("main-group", x);
            }
            xs.takeEnd("main-group");
        }
        if (xs.atStart("subgroup")) {
            xs.takeStart("subgroup");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _Subgroup = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("subgroup", x);
            }
            xs.takeEnd("subgroup");
        }
        xs.takeEnd("ipcr-symbol");
    }

    public static IpcrSymbol unmarshal(InputStream in)
        throws UnmarshalException
    {
        return unmarshal(XMLScanner.open(in));
    }

    public static IpcrSymbol unmarshal(XMLScanner xs)
        throws UnmarshalException
    {
        return unmarshal(xs, newDispatcher());
    }

    public static IpcrSymbol unmarshal(XMLScanner xs, Dispatcher d)
        throws UnmarshalException
    {
        return ((IpcrSymbol) d.unmarshal(xs, (IpcrSymbol.class)));
    }

    public boolean equals(Object ob) {
        if (this == ob) {
            return true;
        }
        if (!(ob instanceof IpcrSymbol)) {
            return false;
        }
        IpcrSymbol tob = ((IpcrSymbol) ob);
        if (_ClassificationLevel!= null) {
            if (tob._ClassificationLevel == null) {
                return false;
            }
            if (!_ClassificationLevel.equals(tob._ClassificationLevel)) {
                return false;
            }
        } else {
            if (tob._ClassificationLevel!= null) {
                return false;
            }
        }
        if (_EntryType!= null) {
            if (tob._EntryType == null) {
                return false;
            }
            if (!_EntryType.equals(tob._EntryType)) {
                return false;
            }
        } else {
            if (tob._EntryType!= null) {
                return false;
            }
        }
        if (_ValidityDateFrom!= null) {
            if (tob._ValidityDateFrom == null) {
                return false;
            }
            if (!_ValidityDateFrom.equals(tob._ValidityDateFrom)) {
                return false;
            }
        } else {
            if (tob._ValidityDateFrom!= null) {
                return false;
            }
        }
        if (_ValidityDateTo!= null) {
            if (tob._ValidityDateTo == null) {
                return false;
            }
            if (!_ValidityDateTo.equals(tob._ValidityDateTo)) {
                return false;
            }
        } else {
            if (tob._ValidityDateTo!= null) {
                return false;
            }
        }
        if (_CorePredecessor!= null) {
            if (tob._CorePredecessor == null) {
                return false;
            }
            if (!_CorePredecessor.equals(tob._CorePredecessor)) {
                return false;
            }
        } else {
            if (tob._CorePredecessor!= null) {
                return false;
            }
        }
        if (_MainGroup!= null) {
            if (tob._MainGroup == null) {
                return false;
            }
            if (!_MainGroup.equals(tob._MainGroup)) {
                return false;
            }
        } else {
            if (tob._MainGroup!= null) {
                return false;
            }
        }
        if (_Subgroup!= null) {
            if (tob._Subgroup == null) {
                return false;
            }
            if (!_Subgroup.equals(tob._Subgroup)) {
                return false;
            }
        } else {
            if (tob._Subgroup!= null) {
                return false;
            }
        }
        return true;
    }

    public int hashCode() {
        int h = 0;
        h = ((127 *h)+((_ClassificationLevel!= null)?_ClassificationLevel.hashCode(): 0));
        h = ((127 *h)+((_EntryType!= null)?_EntryType.hashCode(): 0));
        h = ((127 *h)+((_ValidityDateFrom!= null)?_ValidityDateFrom.hashCode(): 0));
        h = ((127 *h)+((_ValidityDateTo!= null)?_ValidityDateTo.hashCode(): 0));
        h = ((127 *h)+((_CorePredecessor!= null)?_CorePredecessor.hashCode(): 0));
        h = ((127 *h)+((_MainGroup!= null)?_MainGroup.hashCode(): 0));
        h = ((127 *h)+((_Subgroup!= null)?_Subgroup.hashCode(): 0));
        return h;
    }

    public String toString() {
        StringBuffer sb = new StringBuffer("<<ipcr-symbol");
        if (_ClassificationLevel!= null) {
            sb.append(" classification-level=");
            sb.append(_ClassificationLevel.toString());
        }
        if (_EntryType!= null) {
            sb.append(" entry-type=");
            sb.append(_EntryType.toString());
        }
        if (_ValidityDateFrom!= null) {
            sb.append(" validity-date-from=");
            sb.append(_ValidityDateFrom.toString());
        }
        if (_ValidityDateTo!= null) {
            sb.append(" validity-date-to=");
            sb.append(_ValidityDateTo.toString());
        }
        if (_CorePredecessor!= null) {
            sb.append(" core-predecessor=");
            sb.append(_CorePredecessor.toString());
        }
        if (_MainGroup!= null) {
            sb.append(" main-group=");
            sb.append(_MainGroup.toString());
        }
        if (_Subgroup!= null) {
            sb.append(" subgroup=");
            sb.append(_Subgroup.toString());
        }
        sb.append(">>");
        return sb.toString();
    }

    public static Dispatcher newDispatcher() {
        Dispatcher d = new Dispatcher();
        d.register("ipcr-symbol", (IpcrSymbol.class));
        d.register("ipcr-validity-list", (IpcrValidityList.class));
        d.register("subclass-description", (SubclassDescription.class));
        d.register("subclass-list", (SubclassList.class));
        d.freezeElementNameMap();
        return d;
    }

}
