
package ch.ige.ipcloadvalidity.xml.generate;

import java.io.IOException;
import java.io.InputStream;
import javax.xml.bind.ConversionException;
import javax.xml.bind.Dispatcher;
import javax.xml.bind.Element;
import javax.xml.bind.InvalidAttributeException;
import javax.xml.bind.LocalValidationException;
import javax.xml.bind.MarshallableObject;
import javax.xml.bind.Marshaller;
import javax.xml.bind.MissingContentException;
import javax.xml.bind.StructureValidationException;
import javax.xml.bind.UnmarshalException;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.Validator;
import javax.xml.marshal.XMLScanner;
import javax.xml.marshal.XMLWriter;


public class SubclassDescription
    extends MarshallableObject
    implements Element
{

    private String _Section;
    private String _Ipcclass;
    private String _Subclass;

    public String getSection() {
        return _Section;
    }

    public void setSection(String _Section) {
        this._Section = _Section;
        if (_Section == null) {
            invalidate();
        }
    }

    public String getIpcclass() {
        return _Ipcclass;
    }

    public void setIpcclass(String _Ipcclass) {
        this._Ipcclass = _Ipcclass;
        if (_Ipcclass == null) {
            invalidate();
        }
    }

    public String getSubclass() {
        return _Subclass;
    }

    public void setSubclass(String _Subclass) {
        this._Subclass = _Subclass;
        if (_Subclass == null) {
            invalidate();
        }
    }

    public void validateThis()
        throws LocalValidationException
    {
        if (_Section == null) {
            throw new MissingContentException("section");
        }
        if (_Ipcclass == null) {
            throw new MissingContentException("class");
        }
        if (_Subclass == null) {
            throw new MissingContentException("subclass");
        }
    }

    public void validate(Validator v)
        throws StructureValidationException
    {
    }

    public void marshal(Marshaller m)
        throws IOException
    {
        XMLWriter w = m.writer();
        w.start("subclass-description");
        w.leaf("section", _Section.toString());
        w.leaf("class", _Ipcclass.toString());
        w.leaf("subclass", _Subclass.toString());
        w.end("subclass-description");
    }

    public void unmarshal(Unmarshaller u)
        throws UnmarshalException
    {
        XMLScanner xs = u.scanner();
        Validator v = u.validator();
        xs.takeStart("subclass-description");
        while (xs.atAttribute()) {
            String an = xs.takeAttributeName();
            throw new InvalidAttributeException(an);
        }
        if (xs.atStart("section")) {
            xs.takeStart("section");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _Section = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("section", x);
            }
            xs.takeEnd("section");
        }
        if (xs.atStart("class")) {
            xs.takeStart("class");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _Ipcclass = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("class", x);
            }
            xs.takeEnd("class");
        }
        if (xs.atStart("subclass")) {
            xs.takeStart("subclass");
            String s;
            if (xs.atChars(XMLScanner.WS_COLLAPSE)) {
                s = xs.takeChars(XMLScanner.WS_COLLAPSE);
            } else {
                s = "";
            }
            try {
                _Subclass = String.valueOf(s);
            } catch (Exception x) {
                throw new ConversionException("subclass", x);
            }
            xs.takeEnd("subclass");
        }
        xs.takeEnd("subclass-description");
    }

    public static SubclassDescription unmarshal(InputStream in)
        throws UnmarshalException
    {
        return unmarshal(XMLScanner.open(in));
    }

    public static SubclassDescription unmarshal(XMLScanner xs)
        throws UnmarshalException
    {
        return unmarshal(xs, newDispatcher());
    }

    public static SubclassDescription unmarshal(XMLScanner xs, Dispatcher d)
        throws UnmarshalException
    {
        return ((SubclassDescription) d.unmarshal(xs, (SubclassDescription.class)));
    }

    public boolean equals(Object ob) {
        if (this == ob) {
            return true;
        }
        if (!(ob instanceof SubclassDescription)) {
            return false;
        }
        SubclassDescription tob = ((SubclassDescription) ob);
        if (_Section!= null) {
            if (tob._Section == null) {
                return false;
            }
            if (!_Section.equals(tob._Section)) {
                return false;
            }
        } else {
            if (tob._Section!= null) {
                return false;
            }
        }
        if (_Ipcclass!= null) {
            if (tob._Ipcclass == null) {
                return false;
            }
            if (!_Ipcclass.equals(tob._Ipcclass)) {
                return false;
            }
        } else {
            if (tob._Ipcclass!= null) {
                return false;
            }
        }
        if (_Subclass!= null) {
            if (tob._Subclass == null) {
                return false;
            }
            if (!_Subclass.equals(tob._Subclass)) {
                return false;
            }
        } else {
            if (tob._Subclass!= null) {
                return false;
            }
        }
        return true;
    }

    public int hashCode() {
        int h = 0;
        h = ((127 *h)+((_Section!= null)?_Section.hashCode(): 0));
        h = ((127 *h)+((_Ipcclass!= null)?_Ipcclass.hashCode(): 0));
        h = ((127 *h)+((_Subclass!= null)?_Subclass.hashCode(): 0));
        return h;
    }

    public String toString() {
        StringBuffer sb = new StringBuffer("<<subclass-description");
        if (_Section!= null) {
            sb.append(" section=");
            sb.append(_Section.toString());
        }
        if (_Ipcclass!= null) {
            sb.append(" class=");
            sb.append(_Ipcclass.toString());
        }
        if (_Subclass!= null) {
            sb.append(" subclass=");
            sb.append(_Subclass.toString());
        }
        sb.append(">>");
        return sb.toString();
    }

    public static Dispatcher newDispatcher() {
        return IpcrSymbol.newDispatcher();
    }

}
