package ch.ige.jipps;

import javax.ejb.CreateException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;

import ch.ige.jipps.dao.InfoDAO;

/**
 * JIPPSInfoBean: Bean für DB-Meta-Daten.
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author   Marc Bouquet
 * @version  $Id: JIPPSInfoBean.java,v 1.21 2007/01/31 12:35:13 lewis_lee Exp $
 * 
 * @ejb.bean 
 *  name="JIPPSInfo"  
 *  description="An EJB named JIPPSInfo"
 *  display-name="JIPPSInfo"
 *  view-type="both"
 *  jndi-name="JIPPSInfo"
 *  type="Stateless"
 *  transaction-type="Container"
 * @ejb.transaction type="RequiresNew"
 */
public class JIPPSInfoBean implements SessionBean
{
  SessionContext sessionContext;

  public void ejbCreate() throws CreateException
  {
  }

  public void ejbRemove()
  {
  }

  public void ejbActivate()
  {
  }

  public void ejbPassivate()
  {
  }

  public void setSessionContext( SessionContext sessionContext )
  {
    this.sessionContext = sessionContext;
  }

  /**
   * Gibt die Meta-Daten von der Bagis-DB zurück.
   * @return String URL
   * @ejb.interface-method
   */
  public String getBagisDbUrl()
  {
    return InfoDAO.getBagisDbURL();
  }

  /**
   * Gibt die Meta-Daten von der Jipps-DB zurück.
   * @return String URL
   * @ejb.interface-method
   */
  public String getJippsDbUrl()
  {
    return InfoDAO.getJippsDbURL();
  }
}
