package ch.ige.jipps;

import javax.ejb.CreateException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;

/**
 * JIPPSPropertiesBean: Bean für JIPPSProperty-Daten
 * <p>
 * Copyright (c) 2004, Eidgenössisches Institut für Geistiges Eigentum
 * 
 * @author Marc Bouquet
 * @version $Id: JIPPSPropertiesBean.java,v 1.37 2007/04/26 12:58:21 lewis_lee Exp $

 * @ejb.bean 
 *  name="JIPPSProperties"  
 *  description="An EJB named JIPPSProperties"
 *  display-name="JIPPSProperties"
 *  view-type="both"
 *  jndi-name="JIPPSProperties"
 *  type="Stateless"
 *  transaction-type="Container"
 *  local-business-interface="ch.ige.jipps.JIPPSPropertiesServices"
 * @ejb.home local-class="ch.ige.jipps.JIPPSPropertiesLocalHome"
 * @ejb.interface local-class="ch.ige.jipps.JIPPSPropertiesLocal"
 * @ejb.transaction type="RequiresNew"
 *                       
 * @ejb.resource-ref
 *   res-ref-name="mail/JavaMailSession"
 *   res-type="javax.mail.Session"
 *   res-auth="Container"
 *   
 * @jboss.resource-ref
 *   res-ref-name="mail/JavaMailSession"
 *   jndi-name="java:/mail/IGESession"
 */
public class JIPPSPropertiesBean extends JIPPSPropertiesServicesImpl implements SessionBean
{
  SessionContext sessionContext;

  public void ejbCreate() throws CreateException
  {
  }

  public void ejbRemove()
  {
  }

  public void ejbActivate()
  {
  }

  public void ejbPassivate()
  {
  }

  public void setSessionContext( SessionContext sessionContext )
  {
    this.sessionContext = sessionContext;
  }

  /**
   * @ejb.interface-method
   */
  public int getDrucker( String propertyKey ) throws Exception
  {
    return super.getDrucker( propertyKey );
  }

  /**
   * @ejb.interface-method
   */
  public String getDirectoryPath( String propertyKey ) throws Exception
  {
    return super.getDirectoryPath( propertyKey );
  }

  /**
   * @ejb.interface-method
   */
  public void doMail( String betreffText, String meldung, String propertyKey )
  {
    super.doMail( betreffText, meldung, propertyKey );
  }

  /**
   * @ejb.interface-method
   */
  public void doMail( int batchId, String betreffText, String meldung, String errorMsg, String propertyKey, int anzahl, int fehler, int drucker, String path )
  {
    super.doMail( batchId, betreffText, meldung, errorMsg, propertyKey, anzahl, fehler, drucker, path );
  }

  /**
   * @ejb.interface-method
   */
  public void doMailNoData( String betreffText, String meldung, String errorMsg, String propertyKey, int fehler )
  {
    super.doMailNoData( betreffText, meldung, errorMsg, propertyKey, fehler );
  }

  /**
   * @ejb.interface-method
   */
  public String getProperty( String key )
  {
    return super.getProperty( key );
  }
}
