package ch.ige.jipps.constants;

/**
 * Contains constants for files and directories where JIPPS writes or reads.
 *
 * <p>Copyright (c) 2006, Swiss Federal Institute of Intellectual Property</p>
 * @author    Eric Lewis
 * @version   $Id: FileConstants.java,v 1.12 2009/05/05 15:46:26 lewis_lee Exp $
 */
public interface FileConstants
{
  /**
   * The file extension for PDF files.
   */
  public final static String EXTENSION_PDF = ".pdf";

  /**
   * One of the file extensions for JPEG files.
   */
  public final static String EXTENSION_JPG = ".jpg";

  /**
   * One of the file extensions for JPEG files.
   */
  public final static String EXTENSION_JPEG = ".jpeg";

  /**
   * One of the file extensions for TIFF files.
   */
  public final static String EXTENSION_TIF = ".tif";

  /**
   * One of the file extensions for TIFF files.
   */
  public final static String EXTENSION_TIFF = ".tiff";

  /**
   * The file extension for PNG files.
   */
  public final static String EXTENSION_PNG = ".png";

  /**
   * The file extension for XML files.
   */
  public final static String EXTENSION_XML = ".xml";

  /**
   * The file extension for XSL files.
   */
  public final static String EXTENSION_XSL = ".xsl";

  /**
   * The file extension for XSD files.
   */
  public final static String EXTENSION_XSD = ".xsd";
}
