package ch.ige.jipps.constants;

/**
 * Contains constants for image types, which mostly correspond to their extension found in {@link FileConstants}, but without the dot.
 *
 * <p>Copyright (c) 2009, Swiss Federal Institute of Intellectual Property</p>
 * @author   lewis_lee
 * @version  $Id: ImageTypeConstants.java,v 1.1 2009/05/05 15:46:26 lewis_lee Exp $
 */
public interface ImageTypeConstants
{
  /**
   * The image type (content type) of a TIFF.
   */
  public final static String IMAGE_TYPE_TIFF = "tiff";

  /**
   * The image type (content type) of a JPEG.
   */
  public final static String IMAGE_TYPE_JPEG = "jpeg";

  /**
   * The image type (content type) of a JPG.
   */
  public final static String IMAGE_TYPE_JPG = "jpg";

  /**
   * The image type (content type) of a PNG.
   */
  public final static String IMAGE_TYPE_PNG = "png";
}
