package ch.ige.jipps.dao.test;

import ch.ige.dbutils.dao.test.BaseDAOTestTemplate;
import ch.ige.jipps.dao.FaktparDAO;
import ch.ige.jipps.vo.FaktparVO;

/**
 * Tests {@link ch.ige.jipps.dao.FaktparDAO}.
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Eric Lewis
 * @version  $Id: FaktparDAOTest.java,v 1.1 2007/04/20 14:51:54 lewis_lee Exp $
 */
public class FaktparDAOTest extends BaseDAOTestTemplate<FaktparDAO, FaktparVO>
{

  /**
   * The only constructor
   * @param name The test's name
   */
  public FaktparDAOTest( String name )
  {
    super( name );
  }

  // @see ch.ige.dbutils.dao.test.BaseDAOTestTemplate#getDAOClass()
  @Override
  protected Class<FaktparDAO> getDAOClass()
  {
    return FaktparDAO.class;
  }

  /**
   * Tests {@link ch.ige.jipps.dao.FaktparDAO#select(int)}.
   * @throws Exception if the test fails
   */
  public void testSelect() throws Exception
  {
    FaktparVO parameters = getDAO().select( 99999999 );
    assertNull( "Checking for unknown address", parameters );

    parameters = getDAO().select( 500304 );
    assertEquals( "Checking address number", 500304, parameters.adrNr );
    assertEquals( "Checking print recipient group", "5", parameters.druckperi );
    assertEquals( "Checking list type", "0", parameters.listenart );
    assertEquals( "Checking tray", 0, parameters.fachNr );
    assertEquals( "Checking sorting", "0", parameters.sortCd );
  }

  // @see ch.ige.dbutils.dao.test.BaseDAOTestTemplate#getSerializableVO()
  @Override
  protected FaktparVO getSerializableVO()
  {
    FaktparVO parameters = new FaktparVO();
    parameters.adrNr = 514;
    parameters.druckperi = "9";
    parameters.fachNr = 43;
    parameters.listenart = "0";
    parameters.sortCd = "2";
    return parameters;
  }

  // @see ch.ige.dbutils.dao.test.BaseDAOTestTemplate#assertVOEqual(ch.ige.dbutils.vo.AbstractVO, ch.ige.dbutils.vo.AbstractVO)
  @Override
  protected boolean assertVOEqual( FaktparVO originalVO, FaktparVO serializedVO )
  {
    return originalVO.adrNr == serializedVO.adrNr && originalVO.druckperi.equals( serializedVO.druckperi ) && originalVO.fachNr == serializedVO.fachNr
        && originalVO.listenart.equals( serializedVO.listenart ) && originalVO.sortCd.equals( serializedVO.sortCd );
  }
}
