package ch.ige.jipps.ftp.web.util;

import org.apache.commons.configuration.Configuration;

import ch.ige.dbutils.vo.AbstractVO;
import ch.ige.ftp.fileselector.util.FileType;

public class FTPServletConfigVO extends AbstractVO
{
  private String path_dir_upload;

  private String path_dir_download;

  private FileType upload_file_type;

  private FileType download_file_type;

  public FTPServletConfigVO( String path_dir_upload, String path_dir_download, FileType upload_file_type, FileType download_file_type )
  {
    this.path_dir_download = path_dir_download;
    this.path_dir_upload = path_dir_upload;
    this.upload_file_type = upload_file_type;
    this.download_file_type = download_file_type;
  }

  public String getPathToTemporaryUploadDir()
  {
    return path_dir_upload;
  }

  public String getPathToTemporaryDownloadDir()
  {
    return path_dir_download;
  }

  public FileType getUploadFileType()
  {
    return upload_file_type;
  }

  public FileType getDownloadFileType()
  {
    return download_file_type;
  }

  public static FTPServletConfigVO fromConfiguration( Configuration table )
  {
    String entryForFileTypeUpload = table.getString( "upload_file_type" );
    String entryForFileTypeDownload = table.getString( "download_file_type" );
    return new FTPServletConfigVO( table.getString( "path_dir_upload" ), table.getString( "path_dir_download" ), entryForFileTypeUpload == null ? null
        : FileType.valueOf( entryForFileTypeUpload ), entryForFileTypeDownload == null ? null : FileType.valueOf( entryForFileTypeDownload ) );
  }

}
