package ch.ige.jipps.signature.stamp;

/**
 * Contains stamp specific information. A stamp is printed after the signature
 * depending on the department and the report which one to take. 
 *
 * <p>Copyright (c) 2008, Swiss Federal Institute of Intellectual Property</p>
 * @author   Esther Bandschapp
 * @version  $Id: Stamp.java,v 1.1 2008/05/21 08:27:41 bandschapp Exp $
 */
public interface Stamp
{
  /**
   * The path and file name of the image (for the src attribute).
   * @return The image source
   */
  public String getImageScr();

  /**
   * The height (size) of the file. This is the full value of an attribute,
   * so information like 'cm' has to be considered.
   * @return The height of the file
   */
  public String getImageHeight();

  /**
   * The width (size) of the file. This is the full value of an attribute,
   * so information like 'cm' has to be considered.
   * @return The width of the file
   */
  public String getImageWidth();
}
