package ch.ige.jipps.test;

import junit.framework.Test;
import junit.framework.TestSuite;
import ch.ige.jipps.currentstate.test.FacadeXmlCurrentStateTest;
import ch.ige.jipps.header.test.FacadeXmlIpHeaderTest;
import ch.ige.jipps.header.test.FacadeXmlPrintHeaderTest;
import ch.ige.jipps.header.test.SpecialPrintHeaderTest;
import ch.ige.jipps.history.test.FacadeXmlHistoryTest;
import ch.ige.jipps.signature.test.FacadeXmlSignatureTest;
import ch.ige.jipps.snapshot.test.FacadeXmlRegistrationSnapshotTest;
import ch.ige.jipps.test.imagelist.FacadeXmlDesignImageListPart1Test;
import ch.ige.jipps.test.imagelist.FacadeXmlDesignImageListPart2Test;
import ch.ige.jipps.test.imagelist.FacadeXmlDesignImageListPart3Test;
import ch.ige.jipps.test.imagelist.FacadeXmlDesignImageListPart4Test;
import ch.ige.jipps.test.imagelist.FacadeXmlDesignImageListPart5Test;
import ch.ige.jipps.test.imagelist.FacadeXmlDesignImageListPart6Test;
import ch.ige.jipps.test.imagelist.FacadeXmlDesignImageListPart7Test;
import ch.ige.jipps.test.imagelist.FacadeXmlDesignImageListPart8Test;
import ch.ige.jipps.test.xslfo.FacadeXslFoPart1Test;
import ch.ige.jipps.test.xslfo.FacadeXslFoPart2Test;
import ch.ige.jipps.test.xslfo.FacadeXslFoPart3Test;

/**
 * Runs all business test of JIPPS which compare the output of a print job with
 * the saved same on the database.
 * <strong>WARNING: This takes a very long time to run!</strong>
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Eric Lewis
 * @version  $Id: AllBusinessTests.java,v 1.4 2008/05/27 06:49:29 bandschapp Exp $
 */
public class AllBusinessTests
{
  /**
   * Creates a test suite containing all JIPPS business tests.
   * @return A tests suite containing all JIPPS business tests
   */
  public static Test suite()
  {
    TestSuite suite = new TestSuite();
    suite.addTestSuite( FacadeXmlPrintHeaderTest.class );
    suite.addTestSuite( SpecialPrintHeaderTest.class );
    suite.addTestSuite( FacadeXmlIpHeaderTest.class );
    suite.addTestSuite( FacadeXmlCurrentStateTest.class );
    suite.addTestSuite( FacadeXmlRegistrationSnapshotTest.class );
    suite.addTestSuite( FacadeXmlHistoryTest.class );
    suite.addTestSuite( FacadeXmlSignatureTest.class );
    suite.addTestSuite( FacadeXmlDesignImageListPart1Test.class );
    suite.addTestSuite( FacadeXmlDesignImageListPart2Test.class );
    suite.addTestSuite( FacadeXmlDesignImageListPart3Test.class );
    suite.addTestSuite( FacadeXmlDesignImageListPart4Test.class );
    suite.addTestSuite( FacadeXmlDesignImageListPart5Test.class );
    suite.addTestSuite( FacadeXmlDesignImageListPart6Test.class );
    suite.addTestSuite( FacadeXmlDesignImageListPart7Test.class );
    suite.addTestSuite( FacadeXmlDesignImageListPart8Test.class );
    suite.addTestSuite( FacadeXslFoPart1Test.class );
    suite.addTestSuite( FacadeXslFoPart2Test.class );
    suite.addTestSuite( FacadeXslFoPart3Test.class );
    return suite;
  }
}
