package ch.ige.jipps.test;

import ch.ige.dbutils.test.TestCaseWithDBInit;
import ch.ige.ipobjects.ServicesFactory;
import ch.ige.jipps.EintrBeschControl;
import ch.ige.jipps.configuration.PathConfiguration;
import ch.ige.jipps.constants.PropertyConstants;
import ch.ige.jipps.constants.StatusConstants;

/**
 * Tests {@link ch.ige.jipps.EintrBeschControl}.
 *
 * <p>Copyright (c) 2008, Swiss Federal Institute of Intellectual Property</p>
 * @author   lewis_lee
 * @version  $Id: EintrBeschControlTest.java,v 1.4 2008/05/22 13:18:55 lewis_lee Exp $
 */
public class EintrBeschControlTest extends TestCaseWithDBInit
{
  /**
   * The only constructor.
   * @param name The test's name
   */
  public EintrBeschControlTest( String name )
  {
    super( name );
    ServicesFactory.getStandaloneServices(); // Initialize
    PathConfiguration.setPathsForLocalTest();
  }

  /**
   * Tests {@link ch.ige.jipps.EintrBeschControl#printEintrBesch(boolean)}.
   */
  public void testPrintEintrBesch()
  {
    System.setProperty( PropertyConstants.BATCH_MAIL_RESULT, "true" ); // Don't send a mail, log it.
    int status = new EintrBeschControl().printEintrBesch( false );
    assertEquals( "Checking status", StatusConstants.OK, status );
  }
}
