package ch.ige.jipps.test;

import ch.ige.jipps.JIPPSFacadeServices;
import ch.ige.jipps.JIPPSFacadeServicesImpl;
import ch.ige.jipps.vo.PropertyJippsVO;
import ch.ige.jipps.xml.test.BaseDaoXmlTestTemplate;

/**
 * Tests {@link ch.ige.jipps.JIPPSFacade} for general stuff.
 * <p>
 * Copyright (c) 2006, Eidgenössisches Institut für Geistiges Eigentum
 * </p>
 * @author Eric Lewis
 * @version $Id: JIPPSFacadeTest.java,v 1.2 2008/06/30 14:54:30 finger Exp $
 */
public class JIPPSFacadeTest extends BaseDaoXmlTestTemplate
{

  /**
   * The unit under test
   */
  private JIPPSFacadeTestClass jippsFacade = new JIPPSFacadeTestClass();

  private PropertyJippsVO propertyJippsVO = new PropertyJippsVO();

  /**
   * The only constructor.
   * @param name The test's name
   */
  public JIPPSFacadeTest( String name )
  {
    super( name );
  }

  /**
   * Tests {@link JIPPSFacadeServices#getPrintersAsMap()}.
   * @throws Exception
   */
  public void testGetPrintersAsMap() throws Exception
  {
    assertTrue( this.jippsFacade.getPrintersAsMap().size() > 0 );
  }

  /**
   * Tests if the CheckPrinterPriority works correctly.
   */
  public void testCheckPrinterPriority()
  {
    propertyJippsVO.description = "_drucker";
    propertyJippsVO.key = "_drucker";
    propertyJippsVO.value = "18";
    jippsFacade.checkPrinterPriority( propertyJippsVO );
    assertEquals( propertyJippsVO.description, "U141_Saphir : _drucker" );
  }

  private static class JIPPSFacadeTestClass extends JIPPSFacadeServicesImpl
  {
    /**
     * Is needed to test the method.
     * @param propertyJippsVO
     */
    public void checkPrinterPriority( PropertyJippsVO propertyJippsVO )
    {
      super.checkPrinterProperty( propertyJippsVO );
    }
  }
}
