package ch.ige.jipps.vo;

import java.sql.Timestamp;

import ch.ige.dbutils.vo.AbstractVO;

/**
 * A trademark renewal that has gone wrong.
 * 
 * <p>Copyright (c) 2004, Eidgenössisches Institut für Geistiges Eigentum</p>
 * @author  Marc Bouquet
 * @version $Id: AmvErrorVO.java,v 1.8 2007/04/20 13:36:20 lewis_lee Exp $
 */
public class AmvErrorVO extends AbstractVO
{
  /**
   * The unique ID of the trademark renewal batch run
   */
  public int amvLaufId = 0;

  /**
   * The unique ID of the address to which the renewal is sent
   */
  public int adrNr = 0;

  /**
   * The unique key of the trademark which was renewed
   */
  public int schutitKey = 0;

  /**
   * The error message of the batch run
   */
  public String errorMsg = "";

  /**
   * The creation date.
   * Note that this is set automatically when this is saved in the database,
   * so don't set it and try to save it.
   */
  public Timestamp createdDat = null;

  /**
   * The date of the latest update.
   * Note that this is set automatically when this is saved in the database,
   * so don't set it and try to save it.
   */
  public Timestamp changedDat = null;
}
