package ch.ige.jipps.vo;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * Contains the answers to print job requests.
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author    Priska Steiner, Marc Bouquet
 * @version   $Id: AnswerVO.java,v 1.14 2008/05/15 12:29:41 bandschapp Exp $
 */
public class AnswerVO implements Serializable
{
  /**
   * Shows in {@link #printStatus} that everything went right.
   */
  public static final String STATUS_OK = "ok";

  /**
   * Contains either {@link #STATUS_OK} if the print job was printed successfully
   * or the corresponding error message.
   */
  public String printStatus = "";

  /**
   * Contains the type of form (letter) or report.
   * @see ch.ige.jipps.vo.PrintJobVO#formTyp
   */
  public String formTyp = "";

  /**
   * The print job IDs of the print jobs
   */
  public List<Integer> listPrintId = null;

  /**
   * The application number
   */
  public String gesuchNr = "";

  /**
   * The ip number.
   */
  public String schutitNr = "";

  /**
   * The IP's key for which this answer is created
   */
  public int schutitKey = 0;

  /**
   * Creates this and initializes Collections.
   */
  public AnswerVO()
  {
    this.listPrintId = new ArrayList<Integer>();
  }
}
