package ch.ige.jipps.vo;

import java.util.ArrayList;
import java.util.List;

import ch.ige.util.enums.BAGISLanguageDomain;

/**
 * Contains the data for the design image list.
 * <p>
 * Copyright (c) 2003, Eidgenössisches Institut für Geistiges Eigentum
 * </p>
 * @author Priska Steiner
 * @version   $Id: DesignImagesVO.java,v 1.6 2008/05/15 12:29:53 bandschapp Exp $
 */
public class DesignImagesVO
{
  /**
   * The report's language.
   */
  public BAGISLanguageDomain language = null;

  /**
   * The report's title
   */
  public String reportTitle = "";

  /**
   * The formatted date showing for what date the report was created
   */
  public String reportDate = null;

  /**
   * The design's unique key
   */
  public int ipKey = 0;

  /**
   * The design's formatted IP number
   */
  public String ipNumber = "";

  /**
   * The design's formatted application number.
   */
  public String applicationNo = null;

  /**
   * The individual images for the design
   */
  public List<DesignImageVO> images = null;

  /**
   * The individual images for the design's history
   */
  public List<DesignImageVO> historyImages = null;

  /**
   * If this is <code>true</code>, the IPI's address is printed on the report.
   */
  public boolean printIpiHeader = false;

  /**
   * Creates this
   */
  public DesignImagesVO()
  {
    this.images = new ArrayList<DesignImageVO>();
  }
}
