package ch.ige.jipps.vo;

import ch.ige.dbutils.vo.AbstractVO;

/**
 * Represents a JIPPS printer.
 * 
 * <p>Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum</p>
 * @author Priska Steiner
 * @version $Id: DruckerVO.java,v 1.17 2008/09/25 12:34:44 lang Exp $
 */

public class DruckerVO extends AbstractVO
{
  /**
   * The printer's unique identifier
   */
  public int druckerId = 0;

  /**
   * The name used in the JIPPS GUI
   */
  public String druckerName = "";

  /**
   * The name used in the JIPPS GUI
   */
  public String optionalPrintArgs = "";

  /**
   * The JIPPS print server where this is used
   */
  public String controlServer = "";

  /**
   * The room where the printer stands
   */
  public String raum = "";

  /**
   * If this is <code>true</code>, it's a color printer, otherwise it's black and white
   */
  public boolean farbe = false;

  /**
   * The ID of the paper tray containing pre-printed IPI paper
   */
  public int igePaperId = 0;

  /**
   * The ID of the paper tray containing plain white paper
   */
  public int whitePaperId = 0;

  /**
   * The ID of the paper tray containing paper for the cover sheet
   */
  public int coverPaperId = 0;

  /**
   * the optional print arguments for the ige-papertray 
   */
  public String igePrintArgs = "";

  /**
   * the optional print arguments for the white-papertray 
   */
  public String whitePrintArgs = "";

  /**
   * the optional print arguments for the cover-papertray 
   */
  public String coverPrintArgs = "";
}
