package ch.ige.pctedi.vo;

import java.io.Serializable;

/**
 * value object for table PCTADR
 * address information of PCT are stored in an separate table 
 *
 * <p>Copyright (c) 2008, Swiss Federal Institute of Intellectual Property</p>
 * @author   ruegsegger
 * @version  $Id: PctAdrVO.java,v 1.11 2008/07/01 07:43:05 kuenzli Exp $
 */
public class PctAdrVO implements Serializable, Cloneable
{
  /**
   * Default id.
   */
  private static final long serialVersionUID = 1L;
  public static final int INHABER = 1; // Inhaber/Hinterleger(alle Schutztitel: pro

  // Schutztitel sind mehrere möglich)
  public static final int VERTRETER = 3; // Vertreter(alle Schutztitel: pro Schutztitel

  // ist nur einer möglich,Ausnahme: bei Marken sind
  // mehrere möglich)
  public static final int ERFINDER = 4; // Erfinder(Patente: pro Schutztitel sind mehrere

  // möglich)

  public int schutitKey = 0;

  public int pctAdrLnr = 0;

  public String blandCd = null;

  public int schutitTyp = 0;

  public int adrRolleCd = 0;

  public String pctName = null;

  public String pctAdresse = null;

  public int version = 0;

  /**
   * Gibt den Inhalt des ValueObject PctAdrVO zurück
   * @return Inhalt von PctAdrVO
   */
  @Override
  public String toString()
  {
    StringBuffer buf = new StringBuffer();

    buf.append( "  schutitKey       = <" + this.schutitKey + ">\n" );
    buf.append( "  pctAdrLnr        = <" + this.pctAdrLnr + ">\n" );
    buf.append( "  blandCd          = <" + this.blandCd + ">\n" );
    buf.append( "  schutitTyp       = <" + this.schutitTyp + ">\n" );
    buf.append( "  adrRolleCd       = <" + this.adrRolleCd + ">\n" );
    buf.append( "  pctName          = <" + this.pctName + ">\n" );
    buf.append( "  pctAdresse       = <" + this.pctAdresse + ">\n" );
    buf.append( "  version          = <" + this.version + ">\n" );

    return buf.toString();
  }
}
