package ch.ige.pctedi.vo.test;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import ch.ige.pctedi.vo.EreignisVO;
import ch.ige.pctedi.vo.IpcVO;
import ch.ige.pctedi.vo.PatIpcVO;
import ch.ige.pctedi.vo.PatVO;
import ch.ige.pctedi.vo.PctAdrVO;
import ch.ige.pctedi.vo.PrioritaetVO;
import ch.ige.pctedi.vo.SchutitVO;
import ch.ige.util.IGEDate;

/**
 * <p>Überschrift: Europäische Patente (EP) einlesen</p>
 * <p>Beschreibung: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Organisation: Eidgenössisches Institut für Geistiges Eigentum</p>
 * @author unbekannt
 * @version $id: $
 */

public class Testdata
{
  private static int schutitKey = 1300000002;

  private static int ereigIdat = 2005121405;

  private static SimpleDateFormat sdf = new SimpleDateFormat( "yyyyMMdd" );

  public static SchutitVO createSchutit() throws ParseException
  {
    SchutitVO schutitVO = new SchutitVO();

    schutitVO.schutitKey = schutitKey;
    schutitVO.schutitTyp = SchutitVO.SCHUTIT_TYP_PCT;
    schutitVO.sprache = 1;
    schutitVO.gesuchNr = "022974250";
    schutitVO.schutitNr = "016177200";
    schutitVO.schutzBegin = IGEDate.stringToDate( "13.11.1996" );
    schutitVO.schutzEnde = IGEDate.stringToDate( "12.11.2016" );
    schutitVO.loeschDat = IGEDate.stringToDate( "23.05.2002" );
    schutitVO.beschreibung = "Junit-Test äöü @$()éèàñâï";
    schutitVO.erfassDat = IGEDate.stringToDate( "13.11.1996" );
    schutitVO.mutDat = IGEDate.stringToDate( "13.11.1996" );
    schutitVO.erstEreigDat = IGEDate.stringToDate( "13.11.1996" );
    schutitVO.faelligJahr = 2300;

    return schutitVO;
  }

  public static PrioritaetVO createPrioritaet() throws Exception
  {
    PrioritaetVO priortaetVO = new PrioritaetVO();

    priortaetVO.schutitKey = schutitKey;
    priortaetVO.blandCd = "CH";
    priortaetVO.prioNr = "PP904799";
    priortaetVO.regStat = 8;
    priortaetVO.prioDat = sdf.parse( "19990304" );
    priortaetVO.prioLnr = 1;

    return priortaetVO;
  }

  public static PatVO createPat() throws Exception
  {
    PatVO patVO = new PatVO();

    patVO.schutitKey = schutitKey;
    patVO.pctAnmSpra = "";
    patVO.patVerfahr = 6;
    patVO.epAnmSpra = "De";
    patVO.epApublSpra = "De";
    patVO.epApublDat = IGEDate.stringToDate( "20.05.1998" );
    patVO.version = 0;

    return patVO;
  }

  public static EreignisVO createEreignisErsterfassung()
  {
    EreignisVO ereignisVO = new EreignisVO();

    ereignisVO.schutitKey = schutitKey;
    ereignisVO.ereigIdat = ereigIdat;
    ereignisVO.maNr = 199;
    ereignisVO.ereigStatNr = 20;
    ereignisVO.artNr = EreignisVO.ERSTERFASSUNG;
    ereignisVO.regStat = 8;

    return ereignisVO;
  }

  public static EreignisVO createEreignisCHZuruecknahme()
  {
    EreignisVO ereignisVO = new EreignisVO();

    ereignisVO.schutitKey = schutitKey;
    ereignisVO.ereigIdat = ereigIdat;

    return ereignisVO;
  }

  public static PctAdrVO createPctAdr() throws Exception
  {
    PctAdrVO pctAdrVO = new PctAdrVO();

    pctAdrVO.schutitKey = schutitKey;
    pctAdrVO.schutitTyp = SchutitVO.SCHUTIT_TYP_PCT;
    pctAdrVO.adrRolleCd = PctAdrVO.INHABER;
    pctAdrVO.blandCd = "CH";
    pctAdrVO.pctAdresse = "Musterstrasse 8";
    pctAdrVO.pctName = "Hans Muster";
    pctAdrVO.pctAdrLnr = 1;

    return pctAdrVO;
  }

  /**
   * Erstellt ein IpcVO
   * @return IpcVO
   */
  public static IpcVO createIpc() throws Exception
  {
    IpcVO ipcVO = new IpcVO();

    ipcVO.ipcSymb = "A01B000116";
    ipcVO.zusatz = IpcVO.ZUSATZ_CLASSIFICATION;
    ipcVO.gueltigVon = sdf.parse( "20060101" );
    ipcVO.gueltigBis = null;
    ipcVO.classLevel = "A";
    ipcVO.corePred = "A01B0001000000";
    ipcVO.version = 0;

    return ipcVO;
  }

  /**
   * Erstellt ein PatIpcVO
   * @return PatIpcVO
   */
  public static PatIpcVO createPatIpc() throws Exception
  {
    PatIpcVO patIpcVO = new PatIpcVO();

    patIpcVO.schutitKey = 2100393404;
    patIpcVO.patIpcCd = PatIpcVO.IPC_CD_N;
    patIpcVO.patIpcLnr = 1;
    patIpcVO.ipcSymb = "B25B000712";
    patIpcVO.ipcGueltigVon = sdf.parse( "20060101" );
    patIpcVO.erfassDat = new Date();

    return patIpcVO;
  }
}
