package ch.ige.rbbagisexport.common;

import ch.ige.rbbagisexport.server.ejb.RBBagisExport;
import ch.ige.rbbagisexport.server.ejb.RBBagisExportHome;
import ch.ige.util.ServiceLocator;

public class RBBagisExportDelegate
{
  private RBBagisExport rbBagisExportSessionBean;

  /**
   * private constructor
   * @throws Exception error
   */
  private RBBagisExportDelegate() throws Exception
  {
    try
    {
      RBBagisExportHome home = (RBBagisExportHome) ServiceLocator.getInstance().getHome( RBBagisExportHome.JNDI_NAME, RBBagisExportHome.class );
      rbBagisExportSessionBean = home.create();
    }
    catch ( Exception ex )
    {
      // alter RemoteException into application exception
      throw new Exception( ex.toString() );
    }
  }

  /**
   * returns an instance of the delegate
   * @return ImportDelegate instance
   * @throws Exception error
   */
  public static RBBagisExportDelegate getInstance() throws Exception
  {
    return new RBBagisExportDelegate();
  }

  public String exportPatentApplication( Integer schutitKey ) throws Exception
  {
    return rbBagisExportSessionBean.exportPatentApplication( schutitKey );
  }

  public RBBagisExportSummary exportAllPatentApplication() throws Exception
  {
    return rbBagisExportSessionBean.exportAllPatentApplications();
  }

  public RBBagisExportConfiguration getConfiguration() throws Exception
  {
    return rbBagisExportSessionBean.getConfiguration();
  }
}
