package ch.ige.rbbagisexport.server.dao;

import java.sql.SQLException;
import ch.ige.dbutils.dao.AbstractBagisDAO;
import ch.ige.dbutils.sql.SQL;
import ch.ige.dbutils.sql.SQLStatement;

/**
 * DAO for BAGIS table xx_sysparams.
 * <p>
 * Copyright (c) 2007, Eidgenössisches Institut für Geistiges Eigentum
 * @author M. Künzli
 * @version $Id: XxSysparamsDAO.java,v 1.8 2008/04/24 14:16:31 kuenzli Exp $
 */
public class XxSysparamsDAO extends AbstractBagisDAO
{
  /**
   * 
   */
  private static final long serialVersionUID = 1L;

  //----------------------------------------------------------------------------
  // Private Members
  //----------------------------------------------------------------------------
  // Sql Statement
  private static final SQLStatement<String> SELECT_PARAM_BY_ID = SQL.select( "SELECT value FROM xx_sysparams WHERE id = ?" );

  //----------------------------------------------------------------------------
  // Public Methods
  //----------------------------------------------------------------------------
  /**
   * Fetches value of a arbitrary parameter.
   *
   * @param id int ID of Parameter
   * @return String Value of Parameter
   * @throws SQLException 
   */
  public String getParameter( Integer paramterId ) throws SQLException
  {
    return selectString( getQueryRunner(), SELECT_PARAM_BY_ID, paramterId );
  }

}
