package ch.ige.rbbagisexport.server.datacontainer;

/**
 * Container for ch-search-report xml data of a certain CH Patent
 * Application.
 * <p>
 * Copyright (c) 2007, Eidgenössisches Institut für Geistiges Eigentum
 * @author M. Künzli
 * @version $Id: ExportDataContainer.java,v 1.6 2008/02/06 12:39:43 kuenzli Exp $
 */
public class ExportDataContainer
{
  //----------------------------------------------------------------------------
  // Private Members
  //----------------------------------------------------------------------------
  private String xml = null;

  private String appNr = null; // Application Number in BAGIS

  private String fileName = null;

  //----------------------------------------------------------------------------
  // Public Members
  //----------------------------------------------------------------------------
  public static final String EXP_FILE_NAME_PREFIX = "EXP_";
  public static final String EXP_FILE_NAME_POSTFIX = "xml";
  public static final String EXP_FILE_NAME_PATTERN = EXP_FILE_NAME_PREFIX+"*."+EXP_FILE_NAME_POSTFIX;
  //----------------------------------------------------------------------------
  // Constructors
  //----------------------------------------------------------------------------
  protected ExportDataContainer( String xml, String appNr )
  {
    this.xml = xml;
    this.appNr = appNr;

    int lengthAppNr = appNr.length();
    // Construct filename: "EXP_"<Application Number; Format 0000>-<Year: Format YY>".xml"
    // Example: EXP_0003-02.xml
    this.fileName = EXP_FILE_NAME_PREFIX + appNr.substring( 0, lengthAppNr - 3 ) + "-" + appNr.substring( lengthAppNr - 3, lengthAppNr - 1 ) + "."+EXP_FILE_NAME_POSTFIX;
  };

  //----------------------------------------------------------------------------
  // Public Methods
  //----------------------------------------------------------------------------
  public String getFileName()
  {
    return this.fileName;
  }

  public String getXml()
  {
    return this.xml;
  }

  @Override
  public String toString()
  {
    StringBuffer retVal = new StringBuffer();
    retVal.append( "Application Number: >" ).append( this.appNr ).append( "<" );
    retVal.append( "; File name: >" ).append( this.fileName ).append( "<" );
    return retVal.toString();
  }
}
