package ch.ige.rbbagisimport.client;

import org.apache.log4j.Logger;

import ch.ige.rbbagisimport.common.vo.XxSysparamsVO;
import ch.ige.rbbagisimport.server.RBDelegate;

/**
 * Programmeigenschaften anhand Property Datei setzen
 * Pfad der Property Datei wird in der Batch-Prozedur gesetzt
 * <p>
 * Copyright (c) 2005, Eidgenössisches Institut für Geistiges Eigentum
 * @author A. Rueegsegger, P. Bolzli
 * @version $Id: ImportProperties.java,v 1.4 2008/02/05 18:42:52 wild Exp $
 */
public class ImportProperties
{
  private static final Logger LOG = Logger.getLogger( ImportProperties.class );

  private static ImportProperties importProperties;

  private XxSysparamsVO sysParams;

  private ImportProperties()
  {
    try
    {
      RBDelegate delegate = RBDelegate.getInstance();
      this.sysParams = delegate.getConfiguration();
    }
    catch ( Exception ex )
    {
      LOG.error( "Problem loanding Properties : " + ex.getMessage() );
      System.out.println( ex );
    }

  }

  /**
   * Singelton Methode...
   * 
   * @return ImportProperties 
   */
  public static ImportProperties getInstance()
  {
    if ( importProperties == null )
    {
      importProperties = new ImportProperties();
    }
    return importProperties;
  }

  /**
   * Den Wert von einer Einstellung zurückgeben. 
   * 
   * @param paramId
   * @return String Wert des Systemparameters
   */
  public String getValue( Integer paramId )
  {
    return this.sysParams.getParam( paramId );
  }

  @Override
  public String toString()
  {
    return sysParams.toString();
  }

}
