package ch.ige.rbbagisimport.server;

/**
 * Class for Server Exception Handling.
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   bolzli
 * @version  $Id: RBServerException.java,v 1.2 2008/04/23 13:28:09 wild Exp $
 */
@SuppressWarnings( "serial" )
public class RBServerException extends Exception
{
  private String fErrorMsg = null;

  public RBServerException( String errorMsg )
  {
    super();
    fErrorMsg = errorMsg;
  }

  /**
   * extend super function with error number nad error message
   *
   * @return String   error information and original message
   */
  public String getMessage()
  {
    return ( getErrorMsg() + "\n" + super.getMessage() );
  }

  public String getErrorMsg()
  {
    return fErrorMsg;
  }

}
