package ch.ige.rbbagisimport.server.dao;

import java.sql.SQLException;

import ch.ige.dbutils.dao.AbstractBagisDAO;
import ch.ige.dbutils.sql.SQL;
import ch.ige.dbutils.sql.SQLStatement;

/**
 * Data Access Object for Table SCHUTIT
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   bolzli
 * @version  $Id: SchutitDAO.java,v 1.9 2008/05/22 11:52:30 wild Exp $
 */
public class SchutitDAO extends AbstractBagisDAO
{
  private static final long serialVersionUID = 1L;

  private static final SQLStatement<Integer> STMT_SELECT_SCHUTIT_KEY = SQL
      .select( "Select schutit_key From SCHUTIT Where gesuch_nr like ? And schutit_typ = 1" );

  //----------------------------------------------------------------------------
  // Public Methods
  //----------------------------------------------------------------------------
  /**
   * Fetches schutit_key of a ch-pat with the value of the gesuch_nr
   * If there ist no entry in Table Schutit the return is zero
   * @param gesuchNr String
   * @return int Value of Schutit_key
   * @throws SQLException 
   */
  public int selectSchutitKeyByApplNr( String gesuchNr ) throws SQLException
  {
    gesuchNr = gesuchNr.replaceAll( "-", "" ) + '%';
    Integer schutitKey = selectInteger( getQueryRunner(), STMT_SELECT_SCHUTIT_KEY, gesuchNr );
    if ( schutitKey == null )
    {
      return 0;
    }
    else
    {
      return schutitKey;
    }
  }

} // end class