package ch.ige.rbbagisimport.server.dao;

import ch.ige.dbutils.dao.DAOPool;
import ch.ige.ipobjects.key.IPIdentifier;
import ch.ige.ipobjects.key.vo.IPKeyVO;
import ch.ige.ipobjects.patent.dao.SearchReportDAO;
import ch.ige.ipobjects.patent.vo.SearchReportVO;

/**
 * Wraper Klasse, mit der das Searchreport DAO von IPIObjects eingebunden wird. 
 * Der Grund ist das NCLOB-Feld, das auf eine spezielle Art geschrieben werden muss
 *
 * <p>Copyright (c) 2008, Swiss Federal Institute of Intellectual Property</p>
 * @author   wild
 * @version  $Id: SearchRepDAOWraper.java,v 1.2 2008/02/08 13:09:18 wild Exp $
 */
public class SearchRepDAOWraper
{
  /**
   * Aufruf der Ipiobject-Methode für den delete einer Searchrep Row
   * @param searchReportId
   */
  public void delete( int searchReportId )
  {
    SearchReportDAO searchRepDAO = DAOPool.get( SearchReportDAO.class );
    searchRepDAO.delete( searchReportId );
  }

  /**
   * Einfügen von einem SearchReport über die Funktionalität von IpiObjects
   * 
   * @param searchRecVO
   * @param schutit_key
   */
  public void insert( SearchReportVO searchRecVO, int schutit_key )
  {
    SearchReportDAO searchRepDAO = DAOPool.get( SearchReportDAO.class );
    IPIdentifier key = IPKeyVO.create( schutit_key );
    searchRepDAO.insert( key, searchRecVO );
  }
}