package ch.ige.rbbagisimport.server.vo;

import java.sql.Date;

/**
 * Represents a SearchReport
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   bolzli
 * @version  $Id: ReportVO.java,v 1.5 2007/12/18 16:03:35 bolzli Exp $
 */
public class ReportVO
{
  // constants
  
  public static final int   TYPE_DRAFT                  = 0;
  public static final int   TYPE_FINAL                  = 1;
  
  public static final int   STATE_NOT_SENT              = 0;
  public static final int   STATE_SENT                  = 1;
  public static final int   STATE_SENT_TO_THIRD_PARTY   = 2;
  
  
  // fields
  private int       searchReportId;
  private int       schutitKey;
  private int       type;
  private int       state;
  private Date      importDate;
  private String    xml;
  
  
  /**
   * Constructor
   * @param searchReportId
   * @param schutitKey
   * @param type
   * @param state
   * @param importDate
   * @param xml
   */
  public ReportVO( int searchReportId, int schutitKey, int type, int state, Date importDate, String xml )
  {
    this(schutitKey, type, xml);
    this.searchReportId = searchReportId;
    this.state          = state;
    this.importDate     = importDate;
  }
  
  public ReportVO( int schutitKey, int type, String xml )
  {
    this.schutitKey = schutitKey;
    this.type = type;
    this.xml = xml;
    this.state = STATE_NOT_SENT;
  }
   
  
  /**
   * Gets the importDate.
   * @return the importDate
   */
  public Date getImportDate()
  {
    return this.importDate;
  }
  /**
   * Sets the importDate.
   * @param importDate The importDate to set
   */
  public void setImportDate( Date importDate )
  {
    this.importDate = importDate;
  }
    
  /**
   * Gets the schutitKey.
   * @return the schutitKey
   */
  public int getSchutitKey()
  {
    return this.schutitKey;
  }
  /**
   * Sets the schutitKey.
   * @param schutitKey The schutitKey to set
   */
  public void setSchutitKey( int schutitKey )
  {
    this.schutitKey = schutitKey;
  }
  /**
   * Gets the searchReportId.
   * @return the searchReportId
   */
  public int getSearchReportId()
  {
    return this.searchReportId;
  }
  /**
   * Sets the searchReportId.
   * @param searchReportId The searchReportId to set
   */
  public void setSearchReportId( int searchReportId )
  {
    this.searchReportId = searchReportId;
  }
  /**
   * Gets the state.
   * @return the state
   */
  public int getState()
  {
    return this.state;
  }
  /**
   * Sets the state.
   * @param state The state to set
   */
  public void setState( int state )
  {
    this.state = state;
  }
  /**
   * Gets the type.
   * @return the type
   */
  public int getType()
  {
    return this.type;
  }
  /**
   * Sets the type.
   * @param type The type to set
   */
  public void setType( int type )
  {
    this.type = type;
  }
  /**
   * Gets the xml.
   * @return the xml
   */
  public String getXml()
  {
    return this.xml;
  }
  /**
   * Sets the xml.
   * @param xml The xml to set
   */
  public void setXml( String xml )
  {
    this.xml = xml;
  }

} // end class

