package ch.ige.st36xmlgenerator.builder;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.List;

import org.apache.log4j.Logger;

import ch.ige.st36xmlgenerator.format.XMLElementConverter;

public class ContainerObjectBuilder extends AbstractTreeObjectBuilder
{

  private static final Logger LOG = Logger.getLogger( AbstractTreeObjectBuilder.class );

  protected Object getNextObject( Object actualObject, String nextElement ) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException
  {

    Object nextNode = getContainer( actualObject, getGetterMethodName( nextElement ) );
    return nextNode;

  }

  private List getContainer( Object navigateToElementObject, String getterMethodName )
  {
    Method getter = getMethod( navigateToElementObject.getClass(), getterMethodName );
    List container = null;
    if ( getter != null )
    {
      try
      {
        container = (List) getter.invoke( navigateToElementObject, new Object[] {} );
      }
      catch ( IllegalAccessException e )
      {
        LOG.error( e );
      }
      catch ( InvocationTargetException e )
      {
        LOG.error( e );
      }
    }
    return container;
  }

  public void setObject( RecursionInformation info )
  {
    Object actualObject = info.getActualObject();
    Object objectToSet = info.getObjectToSet();
    String getterMethod = XMLElementConverter.toGetter( info.getNextElement() );
    List container = getContainer( actualObject, getterMethod );
    if ( container.isEmpty() )
    {
      container.add( objectToSet );
      System.out.println( "object set :" + objectToSet );
    }

  }

  public boolean appliesTo( RecursionInformation info )
  {
    return info.hasMoreElements() && info.isContainer();
  }

}
