package ch.ige.st36xmlgenerator.builder;

import java.util.StringTokenizer;

import ch.ige.st36xmlgenerator.format.XMLElementConverter;

public class RecursionInformation
{

  private String actualElement;

  private String nextElement;

  private Object objectTree;

  private Object objectToSet;

  private Object actualObject;

  private boolean valueSet = false;

  public void setActualElement( String actualElement )
  {
    this.actualElement = actualElement;
  }

  private StringTokenizer tokenizer;

  public RecursionInformation( String xpathFromRoot, Object rootObject )
  {
    this.objectTree = rootObject;
    tokenizer = new StringTokenizer( xpathFromRoot, "/" );

    // initialize recursion
    this.actualElement = (String) tokenizer.nextElement();
    this.actualObject = rootObject;

    String name = XMLElementConverter.toClassName( (String) actualElement );
    if ( actualElement == null || !rootObject.getClass().getSimpleName().startsWith( name ) )
    { // !this.identifier.trim().equals(rootElement.trim())
      throw new IllegalArgumentException( actualElement.toString() + " is not expected root " );
    }

  }

  public String getActualElement()
  {
    return actualElement;
  }

  public void setObjectToSet( Object objectToSet )
  {
    this.objectToSet = objectToSet;
  }

  public Object getObjectToSet()
  {
    return objectToSet;
  }

  public void setObjectTree( Object objectTree )
  {
    this.objectTree = objectTree;
  }

  public Object getObjectTree()
  {
    return objectTree;
  }

  public void setActualObject( Object actualObject )
  {
    this.actualObject = actualObject;
  }

  public Object getActualObject()
  {
    return actualObject;
  }

  public boolean hasMoreElements()
  {
    boolean hasMore = tokenizer.hasMoreElements();
    this.nextElement = matchElement( (String) tokenizer.nextElement(), actualElement );
    return hasMore;

  }

  public String getNextElement()
  {

    return nextElement;
  }

  protected String matchElement( String nextElement, String actualElement )
  {
    if ( nextElement.equals( "document-id" ) && actualElement.endsWith( "publication-reference" ) )
    {
      return "ch-document-id";
    }
    else if ( nextElement.equals( "document-id" ) )
    {
      return "document-id-content";
    }
    else if ( nextElement.equals( "parent-doc" ) || nextElement.equals( "pct-or-regional-filing-data" )
        || nextElement.equals( "pct-or-regional-publishing-data" ) )
    {
      return "document-id";
    }
    return nextElement;
  }

  protected boolean isContainer( String actualXpathElementName, String nextXpathElementName )
  {
    if ( actualXpathElementName.equals( "invention-title" ) || nextXpathElementName.equals( "applicant" ) || nextXpathElementName.equals( "inventor" )
        || nextXpathElementName.equals( "agent" ) || nextXpathElementName.equals( "priority-claim" ) || nextXpathElementName.equals( "classification-ipcr" ) )
    {
      return true;
    }
    return false;
  }

  public boolean isContainer()
  {
    return isContainer( actualElement, nextElement );
  }

}
