package ch.ige.st36xmlgenerator.metadata;

import java.util.List;
import java.util.Map;

import ch.ige.st36xmlgenerator.builder.Factory;
import ch.ige.st36xmlgenerator.exception.MissingMandatoryValueException;
import ch.ige.st36xmlgenerator.metadata.XPathXMLAccessor.AttributeDefinition;

/**
 * The Accessor derived from an entry in the metadata file that allows to elaborate the values corresponding the definitions in the metadata file 
 * @author fabrizioli
 *
 */
public interface XMLAccessor
{
  public boolean createPathAndSetValue( Factory<?> factory, Object values ) throws ClassNotFoundException, MissingMandatoryValueException;

  public boolean createPathAndSetValue( Factory<?> factory, Object values, Map<String, List<AttributeDefinition>> attributes ) throws ClassNotFoundException,
      MissingMandatoryValueException;

  public boolean createPathAndSetValue( Factory<?> factory, Object[] values ) throws ClassNotFoundException, MissingMandatoryValueException;

  public boolean createPathAndSetValue( Factory<?> factory, Object[] values, Map<String, List<AttributeDefinition>>[] attributes ) throws ClassNotFoundException,
      MissingMandatoryValueException;

}
