package ch.ige.st36xmlgenerator.test;

import java.io.File;
import java.io.IOException;

import ch.ige.ipobjects.patent.vo.PatentDocumentSchemaVO;
import ch.ige.st36xmlgenerator.metadata.JAXBMetadataExtractorFactory;
import ch.ige.util.IOUtil;

/**
 * <p>
 * Copyright (c) 2007, Swiss Federal Institute of Intellectual Property
 * </p>
 * 
 * @author fabrizioli
 * @version $Id: JAXBWellKnownSchemas.java,v 1.9 2008/07/18 19:02:49 fabrizioli Exp $
 */
class JAXBWellKnownSchemas
{

  public static final void initializeMetadataExtractorFactoryFromWellKnownFiles() throws IOException
  {
    JAXBMetadataExtractorFactory.initialize( readWellKnownSchemaFromFile() );
  }

  private static final PatentDocumentSchemaVO readWellKnownSchemaFromFile() throws IOException
  {

    return createWellKnown( 7, "ch-patent-doc-v1-2-ige1-1" );

  }

  private static PatentDocumentSchemaVO createWellKnown( int id, String identifierString ) throws IOException
  {
    String fullIdentifier = identifierString + ".xsd";
    File xsd = new File( "C:/jp/projects/patdocutil/schemas", fullIdentifier );
    File metadataDescription = new File( "C:/jp/projects/patdocutil/schemas", "metadata_" + identifierString + ".xml" );
    File xmlgenmetadataDescription = new File( "C:/jp/projects/st36xmlgenerator/src/res", "xmlgenerator_metadata_" + identifierString + ".xml" );
    return readFromFiles( id, fullIdentifier, xsd, metadataDescription, xmlgenmetadataDescription );
  }

  private static PatentDocumentSchemaVO readFromFiles( Integer id, String identifier, File xsd, File metadataDescription, File xmlgenmetadataDescription )
      throws IOException
  {
    String xsdContent = IOUtil.toString( xsd, IOUtil.createStrictUTF8Decoder() );
    String metadataDescriptionContent = IOUtil.toString( metadataDescription, IOUtil.createStrictUTF8Decoder() );
    String xmlgenmetadataDescriptionContent = ( xmlgenmetadataDescription.exists() ? IOUtil.toString( xmlgenmetadataDescription, IOUtil
        .createStrictUTF8Decoder() ) : "" );
    return new PatentDocumentSchemaVO( id, identifier, xsdContent, metadataDescriptionContent,Boolean.TRUE )
    {
    };
  }

}
