package ch.ige.ses.client.cypher;

import java.awt.AWTEvent;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import ch.ige.ses.client.saputil.SapProperties;

/**
 * Cypher - Passwort Encode/Decode
 * <p>
 * Copyright (c) 2004, Eidgenössisches Institut für Geistiges Eigentum
 * @author T. Iten
 * @version $Id: MainFrame.java,v 1.6 2007/07/09 06:12:19 iten Exp $
 */
public class MainFrame extends JFrame
{
  JPanel contentPane;
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel2 = new JPanel();
  JPanel jPanel3 = new JPanel();
  JTextField uncodedTextField = new JTextField();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JTextField codedTextField = new JTextField();
  JButton encodeButton = new JButton();
  JButton decodeButton = new JButton();
  FlowLayout flowLayout2 = new FlowLayout();
  FlowLayout flowLayout3 = new FlowLayout();


  //---------------------------------------------------------------------------
  // constructors
  //---------------------------------------------------------------------------

  public MainFrame(boolean enableDecode)
  {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);

    try
    {
      jbInit();

      decodeButton.setVisible(enableDecode);
      if (enableDecode)
      {
        this.setTitle("Cypher - Passwort Encode/Decode");
      }
      else
      {
        this.setTitle("Cypher - Passwort Encode");
      }

    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }


  //---------------------------------------------------------------------------
  //  methods
  //---------------------------------------------------------------------------

  /**
   * Initialisierung Frame
   *
   * @throws Exception
   */
  private void jbInit() throws Exception
  {
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(borderLayout1);
    this.setResizable(false);
    this.setSize(new Dimension(280,100));
    jLabel1.setText("Text uncodiert:");
    jLabel2.setText("Text codiert:    ");
    jPanel2.setLayout(flowLayout2);
    encodeButton.setActionCommand("jButton1");
    encodeButton.setText("Encode");
    encodeButton.addActionListener(new MainFrame_encodeButton_actionAdapter(this));
    decodeButton.setActionCommand("");
    decodeButton.setText("Decode");
    decodeButton.addActionListener(new MainFrame_decodeButton_actionAdapter(this));
    jPanel3.setLayout(flowLayout3);
    jPanel2.setMinimumSize(new Dimension(80, 100));
    jPanel2.setPreferredSize(new Dimension(80, 100));
    jPanel3.setMinimumSize(new Dimension(100, 100));
    jPanel3.setPreferredSize(new Dimension(100, 100));
    uncodedTextField.setMinimumSize(new Dimension(100, 21));
    uncodedTextField.setPreferredSize(new Dimension(100, 21));
    uncodedTextField.setText("");
    contentPane.setAlignmentX((float) 0.5);
    contentPane.setMinimumSize(new Dimension(300, 100));
    contentPane.setPreferredSize(new Dimension(250, 70));
    codedTextField.setMinimumSize(new Dimension(100, 21));
    codedTextField.setPreferredSize(new Dimension(100, 21));
    flowLayout2.setAlignment(FlowLayout.LEFT);
    flowLayout3.setAlignment(FlowLayout.LEFT);
    contentPane.add(jPanel2, BorderLayout.EAST);
    jPanel2.add(encodeButton, null);
    jPanel2.add(decodeButton, null);
    contentPane.add(jPanel3, BorderLayout.CENTER);
    jPanel3.add(jLabel1, null);
    jPanel3.add(uncodedTextField, null);
    jPanel3.add(jLabel2, null);
    jPanel3.add(codedTextField, null);
  }

  /**
   * Fenster schliessen. Überschrieben, so dass eine Beendigung beim
   * Schließen des Fensters möglich ist
   *
   * @param e WindowEvent
   */
  protected void processWindowEvent(WindowEvent e)
  {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
    {
      System.exit(0);
    }
  }


  /**
   * Wert vom Feld "uncodedTextField" wird codiert und in das Text Feld
   * "codedTextField" gespeichert.
   *
   * @param e ActionEvent
   */
  void encodeButton_actionPerformed(ActionEvent e)
  {
    codedTextField.setText
      ( SapProperties.encodeProperty(uncodedTextField.getText()) );
  }


  /**
   * Wert vom Fels "codedTextField" wird decodiert und in das Text Feld
   * "uncodedTextField" gespeichert.
   *
   * @param e ActionEvent
   */
  void decodeButton_actionPerformed(ActionEvent e)
  {
    uncodedTextField.setText
      ( SapProperties.decodeProperty(codedTextField.getText()) );

  }

} // end class


class MainFrame_encodeButton_actionAdapter implements java.awt.event.ActionListener
{
  MainFrame adaptee;

  MainFrame_encodeButton_actionAdapter(MainFrame adaptee)
  {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e)
  {
    adaptee.encodeButton_actionPerformed(e);
  }
} // end class


class MainFrame_decodeButton_actionAdapter implements java.awt.event.ActionListener
{
  MainFrame adaptee;

  MainFrame_decodeButton_actionAdapter(MainFrame adaptee)
  {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e)
  {
    adaptee.decodeButton_actionPerformed(e);
  }

} // end class

