package ch.ige.ses.client.sapinbound;

import java.util.ArrayList;

import org.apache.log4j.Logger;

import ch.ige.ses.client.saputil.Convert;

import com.sap.mw.jco.IRepository;
import com.sap.mw.jco.JCO;

/**
 * SAP Remote Function Module Z_BAPI_STAKO_GET_ARTIKEL
 * <p>
 * Copyright (c) 2003, Eidgenössisches Institut für Geistiges Eigentum
 * <p>Organisation: Eidgenössisches Institut für Geistiges Eigentum
 * @author Patrick Bolzli
 * @version $Id: RFM_Z_BAPI_STAKO_GET_ARTIKEL.java,v 1.7 2008/11/06 16:31:24 iten Exp $
 */

class RFM_Z_BAPI_STAKO_GET_ARTIKEL extends RFM
{
  //
  // const
  //
  private static final Logger LOG = Logger.getLogger( RFM_Z_BAPI_STAKO_GET_ARTIKEL.class );

  //
  // fields
  //
  public String fNextStep = "";  // next step in process

  //------------------------------------------------------------------
  // constructors
  //------------------------------------------------------------------

  public RFM_Z_BAPI_STAKO_GET_ARTIKEL (IRepository repository)
  {
    super ("Z_BAPI_STAKO_GET_ARTIKEL" ,repository);
  }

  //------------------------------------------------------------------
  // public methods
  //------------------------------------------------------------------

  public ArrayList getArtikel()
  {
    fNextStep = "getArtikel";
    
    JCO.Table tbl = fJCoFunc.getTableParameterList().getTable("ARTIKEL");
    ArrayList al = new ArrayList();

    if (tbl.getNumRows() > 0)
    {
      do
      {
        String art = tbl.getString("ARTIKEL");
        
        if ( (art == null) || (art.trim().length()==0) ) 
        {
          LOG.warn( "getArtikel - received <null or empty string> instead of an artikel nummer!" );
        }
        else
        {
          al.add( Convert.toBagisArtNr(art) );
        }
        
      } while( tbl.nextRow() );
    }
    return al;
  }


  /**
   * toStringArtikel
   * 
   * @return al ArrayList mit stakorelevanten Artikeln
   */
  public String toStringArtikel()
  {
    fNextStep = "toStringArtikel";

    JCO.Table tbl = fJCoFunc.getTableParameterList().getTable("ARTIKEL");
    StringBuffer      buf    = new StringBuffer();

    if (tbl.getNumRows() > 0)
    {
      do
      {
        buf.append("ARTIKEL:\t" + tbl.getString("ARTIKEL") + "\n");
      } while(tbl.nextRow());
    }
    
    return buf.toString();
    
  }

} // end class

