package ch.ige.ses.client.sapinbound;

import java.util.*;
import java.lang.*;
import java.math.BigDecimal;
import com.sap.mw.jco.*;
import org.apache.log4j.*;
import ch.ige.ses.vo.bagis.*;
import ch.ige.ses.client.saputil.*;

/**
 * SAP Remote Function Module RFM_Z_BAPI_ZVL_DELETE_BILLING_REQ
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author T. Iten
 * @version $Id: RFM_Z_BAPI_ZVL_DELETE_BILLING_REQ.java,v 1.6 2006/12/11 12:43:32 iten Exp $
 */

public class RFM_Z_BAPI_ZVL_DELETE_BILLING_REQ extends RFM
{
  //
  // const
  //
  private static final Logger  LOG = Logger.getLogger(RFM_Z_BAPI_ZVL_DELETE_BILLING_REQ.class);

  //
  // fields
  //
  public  String  fNextStep = "";           // next step in process (trace info)


  //---------------------------------------------------------------------------
  // constructors
  //---------------------------------------------------------------------------

  public RFM_Z_BAPI_ZVL_DELETE_BILLING_REQ(IRepository repository)
  {
    super("Z_BAPI_ZVL_DELETE_BILLING_REQ",repository);
  }

  //---------------------------------------------------------------------------
  // public methods
  //---------------------------------------------------------------------------

  public void delRechnung(SAPRechnungVO re)
  {
    try
    {
      setImportParam(re);

    }
    catch (Exception ex)
    {
      LOG.error("exception: " + ex.toString());
      LOG.error("hint (next step): " + fNextStep);
      throw new RfmException(ex.toString());
    }
  }


  public String toStringDeleteRechnung()
  {
    JCO.ParameterList in  = this.fJCoFunc.getImportParameterList();
    StringBuffer      buf = new StringBuffer();

    // import params
    buf.append(in.toString());

    return buf.toString();
  }

  //---------------------------------------------------------------------------
  // private methods
  //---------------------------------------------------------------------------

  private void setImportParam(SAPRechnungVO re)
  {
    JCO.ParameterList input = this.fJCoFunc.getImportParameterList();

    fNextStep = "setImportParam - DOC_NUMBER / re.bfakt_id";
    input.setValue(Convert.toSapDocNumber(re.bfakt_id),"DOC_NUMBER");
  }

} // end class

