package ch.ige.ses.client.saprequest;

import java.io.Serializable;
import ch.ige.ses.client.sapinbound.RFC;

/**
 * Diese Klasse enthält die Antwort eines SAP Request und beinhaltet
 * folgende Felder:
 *
 *    rfcCode     Status des SAP RFC Calls. Die möglichen Werte sind in der
 *                Klasse RFC definiert.
 *
 *    rfcMessage  Im Falle des rfcCode ungleich RET_CODE_SUCCESS ist,
 *                ist in diesem Feld die Fehlermeldung des Sap Systems oder
 *                der aufgetretenen Exception abgelegt.
 *
 *    data        Enthält mögliche Daten des SAP Aufrufs.
 *
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author T. Iten
 * @version $Id: SapReturn.java,v 1.5 2006/12/13 14:54:56 iten Exp $
 */
public class SapReturn implements Serializable
{
  public int          rfcCode    = RFC.RET_CODE_SUCCESS;
  public StringBuffer rfcMessage = null;
  public Object       sapData    = null;


  public SapReturn()
  {
    // lazy bone
  }

  public SapReturn(int code, StringBuffer message)
  {
    this(code,message,null);
  }

  public SapReturn(int code, StringBuffer message, Object data)
  {
    rfcCode     = code;
    rfcMessage  = message;
    sapData     = data;
  }

}

