package ch.ige.ses.client.saputil;

import java.util.*;
import ch.ige.ses.client.sapinbound.SapInbound;

/**
 * Konvertierung der BAGIS LänderCodes ins die Ländercodes von SAP
 * <p>
 * Copyright (c) 2003, Eidgenössisches Institut für Geistiges Eigentum
 * @author Stefan Nydegger
 * @version $Id: ConvertCountry.java,v 1.14 2007/02/07 15:57:12 iten Exp $
 */
public class ConvertCountry
{
  private static Properties fMapLandCdToSapCountryCd = new Properties();

  //
  // static initialization block
  //
  static
  {
    // BAGIS to SAP
    fMapLandCdToSapCountryCd.setProperty("AD","AD");
    fMapLandCdToSapCountryCd.setProperty("AE","AE");
    fMapLandCdToSapCountryCd.setProperty("AF","AF");
    fMapLandCdToSapCountryCd.setProperty("AG","AG");
    fMapLandCdToSapCountryCd.setProperty("AI","AI");
    fMapLandCdToSapCountryCd.setProperty("AL","AL");
    fMapLandCdToSapCountryCd.setProperty("AM","AM");
    fMapLandCdToSapCountryCd.setProperty("AN","AN");
    fMapLandCdToSapCountryCd.setProperty("AO","AO");
    fMapLandCdToSapCountryCd.setProperty("AQ","AQ");
    fMapLandCdToSapCountryCd.setProperty("AR","AR");
    fMapLandCdToSapCountryCd.setProperty("XZ","AS");
    fMapLandCdToSapCountryCd.setProperty("A","AT");
    fMapLandCdToSapCountryCd.setProperty("AU","AU");
    fMapLandCdToSapCountryCd.setProperty("AW","AW");
    fMapLandCdToSapCountryCd.setProperty("AZ","AZ");
    fMapLandCdToSapCountryCd.setProperty("BIH","BA");
    fMapLandCdToSapCountryCd.setProperty("BB","BB");
    fMapLandCdToSapCountryCd.setProperty("BD","BD");
    fMapLandCdToSapCountryCd.setProperty("B","BE");
    fMapLandCdToSapCountryCd.setProperty("BF","BF");
    fMapLandCdToSapCountryCd.setProperty("BG","BG");
    fMapLandCdToSapCountryCd.setProperty("BH","BH");
    fMapLandCdToSapCountryCd.setProperty("BI","BI");
    fMapLandCdToSapCountryCd.setProperty("BJ","BJ");
    fMapLandCdToSapCountryCd.setProperty("BM","BM");
    fMapLandCdToSapCountryCd.setProperty("BN","BN");
    fMapLandCdToSapCountryCd.setProperty("BO","BO");
    fMapLandCdToSapCountryCd.setProperty("BR","BR");
    fMapLandCdToSapCountryCd.setProperty("BS","BS");
    fMapLandCdToSapCountryCd.setProperty("BT","BT");
    fMapLandCdToSapCountryCd.setProperty("BV","BV");
    fMapLandCdToSapCountryCd.setProperty("BW","BW");
    fMapLandCdToSapCountryCd.setProperty("BY","BY");
    fMapLandCdToSapCountryCd.setProperty("BZ","BZ");
    fMapLandCdToSapCountryCd.setProperty("CA","CA");
    fMapLandCdToSapCountryCd.setProperty("CC","CC");
    fMapLandCdToSapCountryCd.setProperty("CG","CG");
    fMapLandCdToSapCountryCd.setProperty("XV","CF");
    fMapLandCdToSapCountryCd.setProperty("CD","CD");
    fMapLandCdToSapCountryCd.setProperty("CH","CH");
    fMapLandCdToSapCountryCd.setProperty("CI","CI");
    fMapLandCdToSapCountryCd.setProperty("CK","CK");
    fMapLandCdToSapCountryCd.setProperty("CL","CL");
    fMapLandCdToSapCountryCd.setProperty("CM","CM");
    fMapLandCdToSapCountryCd.setProperty("CN","CN");
    fMapLandCdToSapCountryCd.setProperty("CO","CO");
    fMapLandCdToSapCountryCd.setProperty("CR","CR");
    fMapLandCdToSapCountryCd.setProperty("CU","CU");
    fMapLandCdToSapCountryCd.setProperty("CV","CV");
    fMapLandCdToSapCountryCd.setProperty("CX","CX");
    fMapLandCdToSapCountryCd.setProperty("CY","CY");
    fMapLandCdToSapCountryCd.setProperty("CZ","CZ");
    fMapLandCdToSapCountryCd.setProperty("XU","CZ");
    fMapLandCdToSapCountryCd.setProperty("D","DE");
    fMapLandCdToSapCountryCd.setProperty("DJ","DJ");
    fMapLandCdToSapCountryCd.setProperty("DK","DK");
    fMapLandCdToSapCountryCd.setProperty("DM","DM");
    fMapLandCdToSapCountryCd.setProperty("DO","DO");
    fMapLandCdToSapCountryCd.setProperty("DZ","DZ");
    fMapLandCdToSapCountryCd.setProperty("EC","EC");
    fMapLandCdToSapCountryCd.setProperty("EE","EE");
    fMapLandCdToSapCountryCd.setProperty("EG","EG");
    fMapLandCdToSapCountryCd.setProperty("EH","EH");
    fMapLandCdToSapCountryCd.setProperty("XT","ER");
    fMapLandCdToSapCountryCd.setProperty("E","ES");
    fMapLandCdToSapCountryCd.setProperty("ET","ET");
    fMapLandCdToSapCountryCd.setProperty("FIN","FI");
    fMapLandCdToSapCountryCd.setProperty("FJ","FJ");
    fMapLandCdToSapCountryCd.setProperty("FK","FK");
    fMapLandCdToSapCountryCd.setProperty("XS","FM");
    fMapLandCdToSapCountryCd.setProperty("FR","FO");
    fMapLandCdToSapCountryCd.setProperty("F","FR");
    fMapLandCdToSapCountryCd.setProperty("GA","GA");
    fMapLandCdToSapCountryCd.setProperty("GB","GB");
    fMapLandCdToSapCountryCd.setProperty("GD","GD");
    fMapLandCdToSapCountryCd.setProperty("XR","GE");
    fMapLandCdToSapCountryCd.setProperty("GF","GF");
    fMapLandCdToSapCountryCd.setProperty("GG","GG");
    fMapLandCdToSapCountryCd.setProperty("GH","GH");
    fMapLandCdToSapCountryCd.setProperty("GI","GI");
    fMapLandCdToSapCountryCd.setProperty("GL","GL");
    fMapLandCdToSapCountryCd.setProperty("GM","GM");
    fMapLandCdToSapCountryCd.setProperty("GN","GN");
    fMapLandCdToSapCountryCd.setProperty("GP","GP");
    fMapLandCdToSapCountryCd.setProperty("GQ","GQ");
    fMapLandCdToSapCountryCd.setProperty("GR","GR");
    fMapLandCdToSapCountryCd.setProperty("XQ","GS");
    fMapLandCdToSapCountryCd.setProperty("GT","GT");
    fMapLandCdToSapCountryCd.setProperty("GU","GU");
    fMapLandCdToSapCountryCd.setProperty("GW","GW");
    fMapLandCdToSapCountryCd.setProperty("GY","GY");
    fMapLandCdToSapCountryCd.setProperty("HK","HK");
    fMapLandCdToSapCountryCd.setProperty("HM","HM");
    fMapLandCdToSapCountryCd.setProperty("HN","HN");
    fMapLandCdToSapCountryCd.setProperty("HR","HR");
    fMapLandCdToSapCountryCd.setProperty("HT","HT");
    fMapLandCdToSapCountryCd.setProperty("H","HU");
    fMapLandCdToSapCountryCd.setProperty("ID","ID");
    fMapLandCdToSapCountryCd.setProperty("IE","IE");
    fMapLandCdToSapCountryCd.setProperty("IL","IL");
    fMapLandCdToSapCountryCd.setProperty("IM","IM");
    fMapLandCdToSapCountryCd.setProperty("IN","IN");
    fMapLandCdToSapCountryCd.setProperty("IO","IO");
    fMapLandCdToSapCountryCd.setProperty("IQ","IQ");
    fMapLandCdToSapCountryCd.setProperty("IR","IR");
    fMapLandCdToSapCountryCd.setProperty("IS","IS");
    fMapLandCdToSapCountryCd.setProperty("I","IT");
    fMapLandCdToSapCountryCd.setProperty("JE","JE");
    fMapLandCdToSapCountryCd.setProperty("JM","JM");
    fMapLandCdToSapCountryCd.setProperty("JO","JO");
    fMapLandCdToSapCountryCd.setProperty("JP","JP");
    fMapLandCdToSapCountryCd.setProperty("KE","KE");
    fMapLandCdToSapCountryCd.setProperty("KG","KG");
    fMapLandCdToSapCountryCd.setProperty("KH","KH");
    fMapLandCdToSapCountryCd.setProperty("KI","KI");
    fMapLandCdToSapCountryCd.setProperty("KM","KM");
    fMapLandCdToSapCountryCd.setProperty("KN","KN");
    fMapLandCdToSapCountryCd.setProperty("KP","KP");
    fMapLandCdToSapCountryCd.setProperty("KR","KR");
    fMapLandCdToSapCountryCd.setProperty("KW","KW");
    fMapLandCdToSapCountryCd.setProperty("KY","KY");
    fMapLandCdToSapCountryCd.setProperty("KZ","KZ");
    fMapLandCdToSapCountryCd.setProperty("LA","LA");
    fMapLandCdToSapCountryCd.setProperty("LB","LB");
    fMapLandCdToSapCountryCd.setProperty("LC","LC");
    fMapLandCdToSapCountryCd.setProperty("FL","LI");
    fMapLandCdToSapCountryCd.setProperty("XP","LK");
    fMapLandCdToSapCountryCd.setProperty("LR","LR");
    fMapLandCdToSapCountryCd.setProperty("LS","LS");
    fMapLandCdToSapCountryCd.setProperty("LT","LT");
    fMapLandCdToSapCountryCd.setProperty("L","LU");
    fMapLandCdToSapCountryCd.setProperty("LV","LV");
    fMapLandCdToSapCountryCd.setProperty("LY","LY");
    fMapLandCdToSapCountryCd.setProperty("MA","MA");
    fMapLandCdToSapCountryCd.setProperty("MC","MC");
    fMapLandCdToSapCountryCd.setProperty("MD","MD");
    fMapLandCdToSapCountryCd.setProperty("MG","MG");
    fMapLandCdToSapCountryCd.setProperty("MH","MH");
    fMapLandCdToSapCountryCd.setProperty("XO","MK");
    fMapLandCdToSapCountryCd.setProperty("ML","ML");
    fMapLandCdToSapCountryCd.setProperty("XN","MM");
    fMapLandCdToSapCountryCd.setProperty("MN","MN");
    fMapLandCdToSapCountryCd.setProperty("MO","MO");
    fMapLandCdToSapCountryCd.setProperty("MP","MP");
    fMapLandCdToSapCountryCd.setProperty("MQ","MQ");
    fMapLandCdToSapCountryCd.setProperty("MR","MR");
    fMapLandCdToSapCountryCd.setProperty("MS","MS");
    fMapLandCdToSapCountryCd.setProperty("MT","MT");
    fMapLandCdToSapCountryCd.setProperty("MU","MU");
    fMapLandCdToSapCountryCd.setProperty("MV","MV");
    fMapLandCdToSapCountryCd.setProperty("MW","MW");
    fMapLandCdToSapCountryCd.setProperty("MX","MX");
    fMapLandCdToSapCountryCd.setProperty("MY","MY");
    fMapLandCdToSapCountryCd.setProperty("MZ","MZ");
    fMapLandCdToSapCountryCd.setProperty("NA","NA");
    fMapLandCdToSapCountryCd.setProperty("NC","NC");
    fMapLandCdToSapCountryCd.setProperty("NE","NE");
    fMapLandCdToSapCountryCd.setProperty("NF","NF");
    fMapLandCdToSapCountryCd.setProperty("NG","NG");
    fMapLandCdToSapCountryCd.setProperty("NI","NI");
    fMapLandCdToSapCountryCd.setProperty("NL","NL");
    fMapLandCdToSapCountryCd.setProperty("N","NO");
    fMapLandCdToSapCountryCd.setProperty("NP","NP");
    fMapLandCdToSapCountryCd.setProperty("NR","NR");
    fMapLandCdToSapCountryCd.setProperty("NU","NU");
    fMapLandCdToSapCountryCd.setProperty("NZ","NZ");
    fMapLandCdToSapCountryCd.setProperty("OM","OM");
    fMapLandCdToSapCountryCd.setProperty("PA","PA");
    fMapLandCdToSapCountryCd.setProperty("PE","PE");
    fMapLandCdToSapCountryCd.setProperty("PF","PF");
    fMapLandCdToSapCountryCd.setProperty("PG","PG");
    fMapLandCdToSapCountryCd.setProperty("PH","PH");
    fMapLandCdToSapCountryCd.setProperty("PK","PK");
    fMapLandCdToSapCountryCd.setProperty("PL","PL");
    fMapLandCdToSapCountryCd.setProperty("PM","PM");
    fMapLandCdToSapCountryCd.setProperty("PN","PN");
    fMapLandCdToSapCountryCd.setProperty("PR","PR");
    fMapLandCdToSapCountryCd.setProperty("P","PT");
    fMapLandCdToSapCountryCd.setProperty("PW","PW");
    fMapLandCdToSapCountryCd.setProperty("PY","PY");
    fMapLandCdToSapCountryCd.setProperty("QA","QA");
    fMapLandCdToSapCountryCd.setProperty("RE","RE");
    fMapLandCdToSapCountryCd.setProperty("R","RO");
    fMapLandCdToSapCountryCd.setProperty("RU","RU");
    fMapLandCdToSapCountryCd.setProperty("RW","RW");
    fMapLandCdToSapCountryCd.setProperty("SA","SA");
    fMapLandCdToSapCountryCd.setProperty("SB","SB");
    fMapLandCdToSapCountryCd.setProperty("SC","SC");
    fMapLandCdToSapCountryCd.setProperty("SD","SD");
    fMapLandCdToSapCountryCd.setProperty("S","SE");
    fMapLandCdToSapCountryCd.setProperty("SG","SG");
    fMapLandCdToSapCountryCd.setProperty("SH","SH");
    fMapLandCdToSapCountryCd.setProperty("SI","SI");
    fMapLandCdToSapCountryCd.setProperty("SJ","SJ");
    fMapLandCdToSapCountryCd.setProperty("SK","SK");
    fMapLandCdToSapCountryCd.setProperty("SL","SL");
    fMapLandCdToSapCountryCd.setProperty("SM","SM");
    fMapLandCdToSapCountryCd.setProperty("SN","SN");
    fMapLandCdToSapCountryCd.setProperty("SO","SO");
    fMapLandCdToSapCountryCd.setProperty("SR","SR");
    fMapLandCdToSapCountryCd.setProperty("ST","ST");
    fMapLandCdToSapCountryCd.setProperty("SV","SV");
    fMapLandCdToSapCountryCd.setProperty("SY","SY");
    fMapLandCdToSapCountryCd.setProperty("SZ","SZ");
    fMapLandCdToSapCountryCd.setProperty("TC","TC");
    fMapLandCdToSapCountryCd.setProperty("TD","TD");
    fMapLandCdToSapCountryCd.setProperty("TF","TF");
    fMapLandCdToSapCountryCd.setProperty("TG","TG");
    fMapLandCdToSapCountryCd.setProperty("TH","TH");
    fMapLandCdToSapCountryCd.setProperty("TJ","TJ");
    fMapLandCdToSapCountryCd.setProperty("TK","TK");
    fMapLandCdToSapCountryCd.setProperty("TM","TM");
    fMapLandCdToSapCountryCd.setProperty("TN","TN");
    fMapLandCdToSapCountryCd.setProperty("TO","TO");
    fMapLandCdToSapCountryCd.setProperty("TP","TP");
    fMapLandCdToSapCountryCd.setProperty("TR","TR");
    fMapLandCdToSapCountryCd.setProperty("TT","TT");
    fMapLandCdToSapCountryCd.setProperty("TV","TV");
    fMapLandCdToSapCountryCd.setProperty("TW","TW");
    fMapLandCdToSapCountryCd.setProperty("TZ","TZ");
    fMapLandCdToSapCountryCd.setProperty("UA","UA");
    fMapLandCdToSapCountryCd.setProperty("UG","UG");
    fMapLandCdToSapCountryCd.setProperty("UM","UM");
    fMapLandCdToSapCountryCd.setProperty("USA","US");
    fMapLandCdToSapCountryCd.setProperty("UY","UY");
    fMapLandCdToSapCountryCd.setProperty("ZU","UZ");
    fMapLandCdToSapCountryCd.setProperty("VA","VA");
    fMapLandCdToSapCountryCd.setProperty("VC","VC");
    fMapLandCdToSapCountryCd.setProperty("VE","VE");
    fMapLandCdToSapCountryCd.setProperty("VG","VG");
    fMapLandCdToSapCountryCd.setProperty("VI","VI");
    fMapLandCdToSapCountryCd.setProperty("VN","VN");
    fMapLandCdToSapCountryCd.setProperty("VU","VU");
    fMapLandCdToSapCountryCd.setProperty("WF","WF");
    fMapLandCdToSapCountryCd.setProperty("WS","WS");
    fMapLandCdToSapCountryCd.setProperty("YD","YE");
    fMapLandCdToSapCountryCd.setProperty("YE","YE");
    fMapLandCdToSapCountryCd.setProperty("XL","YT");
    fMapLandCdToSapCountryCd.setProperty("YU","YU");
    fMapLandCdToSapCountryCd.setProperty("ZA","ZA");
    fMapLandCdToSapCountryCd.setProperty("ZM","ZM");
    fMapLandCdToSapCountryCd.setProperty("RH","ZW");
    fMapLandCdToSapCountryCd.setProperty("ZW","ZW");
    fMapLandCdToSapCountryCd.setProperty("BX","BE");
    fMapLandCdToSapCountryCd.setProperty("J","JP");
    fMapLandCdToSapCountryCd.setProperty("BU","BG");
    fMapLandCdToSapCountryCd.setProperty("ME","ME");
    fMapLandCdToSapCountryCd.setProperty("RS","RS");
  }

  //---------------------------------------------------------------------------
  // constructors
  //---------------------------------------------------------------------------

  /**
   * Constructs a ConvertCountry Object<br>
   * Note: In the most cases no spezific instance is used, since mainly all
   * methods to convert data are static !
   */
  public ConvertCountry()
  {
    // lazy bone
  }

  //---------------------------------------------------------------------------
  //  methods
  //---------------------------------------------------------------------------

  /**
   * convert bagis landCd to sap country code.
   * if conversion is disabled within the property file, then the country
   * will be returned unchanged.
   *
   * @param   country   bagis land code
   * @return            SAP Country Code
   */
  public static String toSAPCountry(String country)
  {
    String convert = SapInbound.getProperties().getProperty("sap.adr.convert.enabled");

    if(convert.equals("0"))
    {
      return country;
    }
    else
    {
      return fMapLandCdToSapCountryCd.getProperty(country);
    }
  }


  /**
   * test conversion without reading the option within the property file.
   * note: this mehtod is ONLY used for JUNIT tests, since the reading of
   * the property file does not work propery for junit tests !
   *
   * @param   country   bagis land code
   * @return            SAP Country Code
   */
  public static String testConversion (String country)
  {
    return fMapLandCdToSapCountryCd.getProperty(country);
  }

} // end class

