package ch.ige.ses.client.saputil;

/**
 * Remote Function Module Excetion</p><br>
 * Das ganze Handling der SAP Java Connector (JCo) Schnittstelle ist mit Hilfe
 * der RFC und RFM Klassen gekappselt. Neben den JCo Exceptions können innerhalb
 * einer RFM Klasse bei der Konvertierung der Daten ins SAP Format Fehler auftreten.
 * In diesem Fall ist eine RfmException zu werfen. Damit innerhalb der RFC und RFM
 * Klassen ein identisches Fehlerhandling möglich ist, wird (gleich wie bei der
 * JCoException) auch die RfmException von der RuntimeException abgeleitet.
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author T. Iten
 * @version $Id: RfmException.java,v 1.6 2006/12/11 12:43:31 iten Exp $
 */
public class RfmException extends RuntimeException
{
  /**
   * Constructs a RfmException.
   */
  public RfmException()
  {
    super();
  }

  /**
   * Constructs a RfmException.
   *
   * @param message exception message text
   */
  public RfmException(String message)
  {
    super(message);
  }

} // end class

