/*
 * Generated by XDoclet - Do not edit!
 */
package ch.ige.ses.server.batchctrl;

/**
 * Remote interface for BatchJob.
 * @wtp generated
 */
public interface BatchJob
   extends javax.ejb.EJBObject
{
   /**
    * send email notification if enabled. the mail settings will be read from the property table.
    * @param jobName name of bathch job (reserverd for further use)
    * @param subject mail subject
    * @param body mail content
    * @throws Exception unexpected error condition
    */
   public void batchNotifyEmail( java.lang.String jobName,java.lang.String subject,java.lang.String body )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * Diese Methode überprüft, ob der Batch Job aktiviert ist. Dabei muss in der Property Tabelle ein Eintrag in der folgenden Form vorhanden sein: key = 'batch.jobName.job.enabled' value = '1' (aktiviert) oder '0' (nicht aktiviert) Beachte: Diese Abfrage muss im Batch Job explizit eingebaut werden.
    * @param jobName Name des Jobs, wird benutzt um den key zu setzen
    * @return true falls aktiviert, sonst false
    * @throws Exception Unerwarteter Fehler
    */
   public boolean batchJobEnabled( java.lang.String jobName )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * get property
    * @param key
    * @return result
    * @throws Exception
    */
   public java.lang.String getProperty( java.lang.String key )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * get property
    * @param key
    * @param defaultKey
    * @return result
    * @throws Exception
    */
   public java.lang.String getProperty( java.lang.String key,java.lang.String defaultKey )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * frist select bfakt_id list
    * @return result
    * @throws Exception
    */
   public java.util.List fristSelectBfaktIdList(  )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * jgb frist select bfakt_id list
    * @return result
    * @throws Exception
    */
   public java.util.List jgbfristSelectBfaktIdList(  )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * starts new controlling job
    * @param modus batch job mode
    * @param bisDate end date. if null -> start date + one month
    */
   public void controllingStart( int modus,java.sql.Date bisDate )
      throws java.rmi.RemoteException;

   /**
    * returns the newest stakoKontrolleId
    * @return kontrollId des Stako-Laufes
    */
   public int controllingGetNewId(  )
      throws java.rmi.RemoteException;

   /**
    * controllingCtrlJobState
    * @param kontrollID der aktuellen Verarbeitung
    * @return der Status der entsprechenden Verarbeitung
    * @throws Exception
    */
   public int controllingCtrlJobState( int kontrollID )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * start new jgb job and return id from last job. this id will be used to evaluate the new job id for monitioring the state of the batch job.
    * @param modus batch job mode
    * @param bfaktIdVon start id
    * @param bfaktIdBis end id
    * @return id of last job or 0 if no job was found in table jgb_lauf
    * @throws Exception unexpected exception
    */
   public int jgbStart( java.lang.String modus,int bfaktIdVon,int bfaktIdBis )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * jgb get new lauf id
    * @param lastLaufId
    * @return result
    * @throws Exception
    */
   public int jgbGetNewLaufId( int lastLaufId )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * jgb ctrl job state
    * @param newLaufId
    * @return result
    * @throws Exception
    */
   public int jgbCtrlJobState( int newLaufId )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * Liefert eine Liste mit den Rechnungsnummern (bfakt_id's) für die automatische Markenverlängerung für den angegebenen Rechnungscode (Erinnerung 1 oder Erinnerung 2) von Bagis.
    * @param amvRechnungCd Rechnungscode (Erinnerung 1 oder 2)
    * @return ArrayList Integer Liste mit Rechnungsnummern (bfakt_id)
    * @throws Exception Unerwarteter Fehler
    */
   public java.util.ArrayList amvBagisGetRechnungNrList( int amvRechnungCd )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * Selektiert die Daten für die angegebene Rechnung auf Bagis und sendent diese via JMS an den SapInbound Service zur weiteren Verarbeitung.
    * @param amvLaufId AMV Lauf Identifikaton (Id)
    * @param amvLaufNr AMV Laufnummer
    * @param amvRechnungCd Rechnungscode (Erinnerung 1 oder 2)
    * @param bfaktId Rechnungsnummer
    * @throws Exception Unerwarteter Fehler
    */
   public void amvBagisCreateRechnung( int amvLaufId,java.lang.String amvLaufNr,int amvRechnungCd,int bfaktId )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * Aktualisiert das Feld status_druck auf Bagis auf den angegebenen Status für alle Rechnungsnummern in der mitgegebenen Liste.
    * @param list Integer Liste mit Rechnungsnummern (bfakt_id)
    * @param status Status der gesetzt werden soll
    * @throws Exception Unerwarteter Fehler
    */
   public void amvBagisSetRechnungStatusDruck( java.util.ArrayList list,java.lang.String status )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * Überprüft ob der letzte ausgeführte Lauf beendet wurde.
    * @return boolean Lauf wurde beendet (true) oder nicht (false)
    * @throws Exception Unerwarteter Fehler
    */
   public boolean amvSesIsLastLaufFinished(  )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * Erstellt einen neuen Laufeintrag und liefert die Daten zurück.
    * @return AmvLaufVO Eintrag zur neuen Verarbeitung
    * @throws Exception Unerwarteter Fehler
    */
   public ch.ige.ses.vo.ses.AmvLaufVO amvSesCreateLauf(  )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * Return Lauf Data for the given Lauf Id
    * @param amvLaufId Lauf Id to get data set
    * @return AmvLaufVO Lauf Data
    * @throws Exception Unexpected Error
    */
   public ch.ige.ses.vo.ses.AmvLaufVO amvSesGetLauf( int amvLaufId )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * Fügt die Erinnerungen 1 und 2 Rechnungen in die SES Tabelle AMV_RECHNUNG ein und aktualisiert den Status auf der SES Tabelle AMV_LAUF auf "Rechnungsnummern fertig selektiert".
    * @param amvLaufId Lauf Id to get data set
    * @param e1List Integer Liste mit Erinnerungen 1 (bfakt_id)
    * @param e2List Integer Liste mit Erinnerungen 1 (bfakt_id)
    * @throws Exception Unexpected Error
    */
   public void amvSesInsertRechnung( int amvLaufId,java.util.ArrayList e1List,java.util.ArrayList e2List )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * Gibt an ob die Erinnerungen 2 nach SAP gesendet werden sollen oder nicht. Die Einstellung erfolgt auf der SES Tabelle Property (via SesMonitor) mit der Eigenschaft "batch.SesAmvStart.e2.enabled".
    * @throws Exception Unerwarteter Fehler
    * @return boolean Erinnerungen 2 werden übertragen (true) oder nicht (false)
    */
   public boolean amvSesIsErinnerung2Enabled(  )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * Gibt an ob vor dem Start eines neuen Laufes überprüft werden soll, ob der alte Lauf abgeschlossen ist oder nicht. Ist die Überprüfung einge- schaltet, so kann nur ein neuer Lauf gestartet werden, wenn der letzte Lauf auf dem Status "finished" ist. Ist die Überprüfung ausgeschaltet, so kann jederzeit ein neuer Lauf gestartet werden.
    * @return boolean Überprüfung durchführen (true) oder nicht (false)
    * @throws Exception Unexpected Error
    */
   public boolean amvSesIsCheckLastStateEnabled(  )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * Aktualisiert einen Eintrag in der SES Tabelle AMV_Rechnung.
    * @param vo Amv Rechnungsdaten
    * @throws Exception Unerwarteter Fehler
    */
   public void amvSesSetRechnungStatus( ch.ige.ses.vo.ses.AmvRechnungVO vo )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * Aktualisiert das Feld LAUF_STAT der SES Tabelle AMV_LAUF.
    * @param amvLaufId Lauf Identifikation
    * @param laufStat Status
    * @throws Exception Unerwarteter Fehler
    */
   public void amvSesSetLaufStatus( int amvLaufId,int laufStat )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * Gibt einen Array mit der Anzahl Rechnungen der Tabelle AMV_RECHNUNG pro Status zurück. Der Array-Index entspricht dabei der Status-Code !
    * @param amvLaufId Lauf Id
    * @return int[] Array mit der Anzahl Rechnungsempfänger
    * @throws Exception Unerwarter Fehler
    */
   public int[] amvSesGetRechnungCount( int amvLaufId )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * Gibt die einen Array mit der Anzahl Rechnungsempfänger der Tabelle AMV_RECHNUNG pro Rechnungscode (Erinnerung 1 oder 2) und Status zurück. Der Array-Index entspricht dabei der Status-Code !
    * @param amvLaufId Lauf Id
    * @param rechnungCd Rechnungstyp (Erinnerung 1 oder 2)
    * @return int[] Array mit der Anzahl Rechnungsempfänger
    * @throws Exception Unerwarter Fehler
    */
   public int[] amvSesGetRechnungEmpfCount( int amvLaufId,int rechnungCd )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * Prüft für einen Lauf, ob die Verarbeitung noch am Laufen ist, oder ob alle Rechnungen an SAP übertragen wurden.
    * @param amvLaufId Lauf Identifikation
    * @return boolean Lauf ist noch nicht fertig (true) oder ist fertig (false)
    * @throws Exception Unerwarter Fehler
    */
   public boolean amvSesIsRunning( int amvLaufId )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * Prüft ob eine Verarbeitung Fehler hat oder nicht. Beachte: Bevor diese Methode aufgerufen wird, muss sichergestellt werden, dass die Verarbeitung beendet wurde, da nicht verarbeitete Datensätze bei dieser Abfrage nicht berücksichtigt werden.
    * @param amvLaufId Lauf Identifikation
    * @return boolean Verarbeitung weist Fehler auf (true) oder nicht (false)
    * @throws Exception Unerwarter Fehler
    */
   public boolean amvSesHasErrors( int amvLaufId )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * Reset Status Feld aller fehlerhaften Datensätze. Die Fehlermeldung wird auf 'reset' gesetzt, damit ersichtlich bleibt, dass der Datensatz bereits zurückgesetzt wurde.
    * @param amvLaufId Lauf Identifikation
    * @return int Anzahl aktualisierter Datensätze
    * @throws Exception Unerwarteter SQL Fehler
    */
   public int amvSesResetErrors( int amvLaufId )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * Liefert eine Liste mit den Rechnungsnummern (bfakt_id's) für die automatische Markenverlängerung für den angegebenen Rechnungscode (Erinnerung 1 oder Erinnerung 2) von der SES Tabelle AMV_RECHNUNG mit Status "selektiert"
    * @param amvLaufId Lauf Identifikation
    * @param amvRechnungCd Rechnungscode (Erinnerung 1 oder 2)
    * @return ArrayList Integer Liste mit Rechnungsnummern (bfakt_id)
    * @throws Exception Unerwarteter Fehler
    */
   public java.util.ArrayList amvSesGetRechnungNrList( int amvLaufId,int amvRechnungCd )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * Selektiert eine Array Liste mit Datensätzen der Tabelle AMV_RECHNUNG für die gegebene LaufId und RechnungStat sortiert nach rechnungCd und BfaktId. Werden keine Daten gefunden wird eine leere Liste zurückgegeben.
    * @param amvLaufId Lauf Id
    * @param rechnungStat Status
    * @throws Exception Unerwarteter SQL-Fehler
    * @return ArrayList Data Access Object oder null
    */
   public java.util.ArrayList amvSesGetRechnungListByStat( int amvLaufId,int rechnungStat )
      throws java.lang.Exception, java.rmi.RemoteException;

   /**
    * Löscht alle Einträge der Tabelle, welche älter sind als die angegebene Anzahl Monate.
    * @param table Tabelle [jgb_lauf,amv_lauf,stako_kontrolle,trace]
    * @param months Anzahl Monate
    * @throws Exception unerwartete Fehlermeldung
    * @return String Log Meldung mit Angabe zur ausgeführten Aktion
    */
   public java.lang.String reorgDatabase( java.lang.String table,int months )
      throws java.lang.Exception, java.rmi.RemoteException;

}
