package ch.ige.ses.server.dao.bagis.test;

import ch.ige.ses.server.dao.bagis.*;
import junit.framework.*;

/**
 * junit test class
 * <p>
 * Copyright (c) 2005, Swiss Federal Institute of Intellectual Property
 * @author T. Iten
 * @version $Id: JoinJgbStatistikDAOTest.java,v 1.8 2007/12/28 09:23:57 iten Exp $
 */
public class JoinJgbStatistikDAOTest extends BagisTestCase
{
  //
  // fields
  //
  int   idVon           = 5818918;                    // test data for
  int   idBis           = 5818920;                    // - getCntFakturen
  int   cntFakturenSoll = 3;                          // - getCntRechEmpf
  int   cntRechEmpfSoll = 3;

  int[]     adrNrs      = {500040,500042,500305};     // test data for
  String[]  landCds     = {"CH ","DE ","FR "};        // - getLandCd

  //---------------------------------------------------------------------------
  // consturctor
  //---------------------------------------------------------------------------

  public JoinJgbStatistikDAOTest(String s)
  {
    super(s);
  }

  //---------------------------------------------------------------------------
  // init / clean-up
  //---------------------------------------------------------------------------

  public static Test suite()
  {
     return new TestSuite(JoinJgbStatistikDAOTest.class);
  }


  protected void setUp()
  {
    // lazy bone
  }


  protected void tearDown()
  {
    // lazy bone
  }

  //---------------------------------------------------------------------------
  // tests - select
  //---------------------------------------------------------------------------

  public void testGetCntFakturen()
  {
    JoinJgbStatistikDAO dao = new  JoinJgbStatistikDAO();
    int                 cnt = -1;

    try
    {
      System.out.println();
      System.out.println("testGetCntFakturen:");

      cnt = dao.getCntFakturen(idVon,idBis);
      System.out.println("  count soll = " + cntFakturenSoll);
      System.out.println("  count ist  = " + cnt);
      // assert is only possible if testdata is checked before execution  
      // assertEquals(cnt,cntFakturenSoll);
    }
    catch (Exception e)
    {
      e.printStackTrace();
      fail(e.toString());
    }
  }


  public void testGetCntRechEmpf()
  {
    JoinJgbStatistikDAO dao = new  JoinJgbStatistikDAO();
    int                 cnt = -1;

    try
    {
      System.out.println();
      System.out.println("testGetCntRechEmpf:");

      cnt = dao.getCntRechEmpf(idVon,idBis);
      System.out.println("  count soll = " + cntRechEmpfSoll);
      System.out.println("  count ist  = " + cnt);
      
      // assert is only possible if testdata is checked before execution  
      // assertEquals(cnt,cntRechEmpfSoll);
    }
    catch (Exception e)
    {
      e.printStackTrace();
      fail(e.toString());
    }
  }


  public void testGetLandCd()
  {
    JoinJgbStatistikDAO dao = new  JoinJgbStatistikDAO();
    String              cd  = null;

    try
    {
      System.out.println();
      System.out.println("testGetLandCd:");

      for (int i = 0; i < adrNrs.length; i++)
      {
        cd = dao.getLandCd(adrNrs[i]);

        System.out.println("  adr nr " + adrNrs[i] + ":");
        System.out.println("    land cd soll = <" + landCds[i] + ">");
        System.out.println("    land cd ist  = <" + cd + ">");

        assertEquals(cd,landCds[i]);
      }
    }
    catch (Exception e)
    {
      e.printStackTrace();
      fail(e.toString());
    }
  }

} // end class
