package ch.ige.ses.server.dao.ses;

import java.io.*;
import java.sql.*;
import java.util.*;


/**
 * Basic Ses DAO. Stellt gemeinsame Grundfunktionen zur Verfügung.
 * Wird teilweise von den DAO's welche auf SES zugreiffen erweitert.
 * <p>
 * Copyright (c) 2006, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Thomas Iten
 * @version $Id: SesDAO.java,v 1.6 2006/12/28 07:44:42 iten Exp $
 */
public class SesDAO
{

  //---------------------------------------------------------------------------
  // methods
  //---------------------------------------------------------------------------


  public SesDAO()
  {
    // lazy bone
  }

  //---------------------------------------------------------------------------
  // methods - some helpers used for db migration from ingres to oracle
  //---------------------------------------------------------------------------

  public java.sql.Date toSqlDate(java.util.Date date)
  {
    if (date == null) return null;

    return new java.sql.Date( date.getTime() );
  }

  public java.sql.Date toSqlDatePlusOneDay(java.util.Date date)
  {
    if (date == null) return null;
    return toSqlDate( addDays(date,1) );
  }

  public java.util.Date addDays (java.util.Date date, int days)
  {
    Calendar cal = new GregorianCalendar();

    if (date == null) return null;

    cal.setTime(date);
    cal.add(Calendar.DAY_OF_MONTH,days);

    return cal.getTime();
  }

  public String getClobAsString(ResultSet rs, String colName) throws SQLException, IOException
  {
    Clob clob = rs.getClob(colName);

    if(clob != null)
    {
      char[] buf = new char[(int)clob.length()];
      clob.getCharacterStream().read(buf);

      return new String(buf).trim();
    }
    else
    {
      return null;
    }
  }

} // end class
