package ch.ige.ses.server.dao.ses.test;

import junit.framework.TestCase;
import java.math.BigDecimal;
import java.util.*;

import ch.ige.ses.server.dao.ses.*;
import ch.ige.ses.vo.bagis.*;


/**
 * Test der Klasse JoinSESRechnungDAO
 * <p>
 * Copyright (c) 2003, Eidgenössisches Institut für Geistiges Eigentum
 * @author  Stefan Nydegger
 * @version $Id: JoinSESRechnungDAOTest.java,v 1.6 2007/01/04 15:58:08 iten Exp $
 */

public class JoinSESRechnungDAOTest extends SesTestCase
{
  public JoinSESRechnungDAOTest(String s)
  {
    super(s);
  }

  /**
   * Selektiert eine Range von kompletten Jahresgebührrechnungen aus den Tabellen bfaktur_ses,
   * bfaktpos_ses und bfaktjgb_ses
   * Vorbereitung:
   *  - key's bfaktId und jgbLaufId initialisieren
   */
  public void testSelectJGBRechnung()
  {
    int     bfaktIdFrom = 3561614;      // init with valid value !
    int     bfaktIdTo   = 3561614;      // init with valid value !
    int     jgbLaufId   = 440;          // init with valid value !
    String  status      = null;         // init with valid value or null !

    JoinSESRechnungDAO  dao = new JoinSESRechnungDAO();
    SAPRechnungVO       vo  = null;
    ArrayList           al  = null;

    try
    {
      System.out.println("### Test selectJGBRechnung ###");
      System.out.println("  jgbLaufId   = " + jgbLaufId);
      System.out.println("  bfaktIdFrom = " + bfaktIdFrom);
      System.out.println("  bfaktIdTo   = " + bfaktIdTo);
      System.out.println("  status      = " + status);

      al = dao.selectJGBRechnung(bfaktIdFrom,bfaktIdTo,jgbLaufId,status);

      if (al.size() > 0)
      {
        System.out.println("selected list is:");

        for (int i = 0; i < al.size(); i++)
        {
          vo = (SAPRechnungVO)al.get(i);
          System.out.println(vo.toString());
        }

        System.out.println("total records: " + al.size());

      }
      else
      {
        System.out.println("no data selected !");
      }
    }
    catch(Exception ex)
    {
      System.out.println("Exception: " + ex.toString());
      ex.printStackTrace();
    }
  }

  /**
   * Selektiert Einträge aus den Tabellen JGB_LAUF BFAKTUR_SES BFAKTJGB_SES
   * die den übergebenen Selektionskriterien entsprechen
   */
  public void testselectJGBSort()
  {
    JoinSESRechnungDAO dao = new JoinSESRechnungDAO();
    SAPRechnungVO selKritVO = new SAPRechnungVO();
    selKritVO.zusatzRechEmpf = new ArrayList();
    ArrayList al  = null;

    try
    {
      selKritVO.jgbLaufNr="2003042801";

      System.out.println("### Test selectJGBSort ###");
      System.out.println(" Lauf-Nr  = " + selKritVO.jgbLaufNr);

      al = dao.selectJGBSort(selKritVO);

      if (al.size() > 0)
      {
        System.out.println("total records: " + al.size());
      }
      else
      {
        System.out.println("no data selected !");
      }
    }
    catch(Exception ex)
    {
      System.out.println("Exception: " + ex.toString());
      ex.printStackTrace();
    }
  }

} // end class

