package ch.ige.ses.util;

import java.util.*;


/**
 * <p>Ist für die Datenhaltung der DBValues zuständig (Mapping key - value).
 * Stellt Methoden zur Verfügung um auf diese Werte zuzugreifen</p>
 * <p>
 * <p>Copyright: Copyright (c) 2001-2003, Eidgenössisches Institut für Geistiges Eigentum</p>
 * @author A.Rüegsgger
 * @version $Id: DBValuesMap.java,v 1.6 2006/12/13 14:54:56 iten Exp $
 */

public class DBValuesMap extends TreeMap
{

  public DBValuesMap()
  {
    // lazy bone
  }


  /**
   * Gibt den hash code Wert dieser Map zurück.
   * Der hash code einer Map ist die Summe der hash codes aller Entries dieser Map
   * @return den hash code Wert dieser Map
   */
  public int hashCode()
  {
    return super.hashCode();
  }


  /**
   * Vergleicht die Mappings der beider Objekte miteinander
   * Wenn beide die gleichen Member beinhalten wird true zurückgegeben
   * @param object das auf  Gleichheit mit dieser Hashmap überprüft werden soll
   * @return true sofern das übergebene Object dieselben Mappings beinhaltet
   */
  public boolean equals(Object object)
  {
    return super.equals(object);
  }


  /**
   * Gibt alle Einträge dieser Map in einem Array aus Objekte zurück.<br>
   * Pro Eintrag(Entry) wird ein ComboBoxObject erstellt worin key und value
   * als public-Member angelegt werden.
   * @return Array von ComboBoxObjects
   */
  public ComboBoxObject[] getEntries()
  {
    ComboBoxObject[] combo = new ComboBoxObject[this.size()];
    int i = 0;

    for (Iterator iter = entrySet().iterator(); iter.hasNext(); i++)
    {
      Map.Entry entry = (Map.Entry)iter.next();

      combo[i] = new ComboBoxObject();
      combo[i].key = (String)entry.getKey();
      combo[i].value = (String)entry.getValue();
    }
    return combo;
  }
}



