package ch.ige.ses.util.test;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.apache.log4j.BasicConfigurator;

import ch.ige.ses.util.SESADSHelper;
import ch.ige.util.server.DBHelper;

/**
 * <p>Überschrift: SESADSHelperTest</p>
 * <p>Beschreibung:Test der Util-Klasse SESADSHelper</p>
 * <p>Copyright: Copyright (c) 2003, Eidgenössisches Institut für Geistiges Eigentum</p>
 * <p>Organisation: Eidgenössisches Institut für Geistiges Eigentum</p>
 * @author Stefan Nydegger
 * @version $Id: SESADSHelperTest.java,v 1.8 2009/03/12 16:55:44 locher Exp $
 */

public class SESADSHelperTest extends TestCase
{
  public SESADSHelperTest( String parName )
  {
    super( parName );

    // init log4j
    BasicConfigurator.configure();

    // init test as standalone client
    DBHelper.setRunOnServer( false );
  }

  /**
   * suite überschreibt Klassenmethode. Gibt die eigene Klasse als Testsuite zurück
   * @return new TestSuite()
   */
  public static Test suite()
  {
    return new TestSuite( SESADSHelperTest.class );
  }

  /**
   * Main-Methode der Testklasse SESADSHelperTest
   * @param   args    Übergebene Parameter
   */
  public static void main( String[] args )
  {
    junit.textui.TestRunner.run( suite() );
  }

  /**
   * Test der Methode getEmailFromEmployeeID der Klasse SESADSHelper
   */
  public void testGetEmailFromEmployeeID()
  {
    try
    {
      SESADSHelper sesADSHelper = SESADSHelper.createSESADSHelper();
      System.out.println( "Test ADSHelper Default Connection Settings" );
      assertEquals( "Email", "Thomas.Iten@ipi.ch", sesADSHelper.getEmailFromEmployeeID( "1187" ) );
    }
    catch ( Exception e )
    {
      e.printStackTrace();
      fail( e.getMessage() );
    }
  }
}
