package ch.ige.ses.vo.bagis;

import java.io.*;
import java.util.Date;

/**
 * SES Value Object für eine Rechnungsposition.
 * <p>
 * Copyright (c) 2001, Eidgenössisches Institut für Geistiges Eigentum
 * @author    Pirmin Suter, Thomas Iten
 * @version   $Id: SAPJGBParamVO.java,v 1.5 2006/12/13 14:58:40 iten Exp $
 */

public class SAPJGBParamVO  implements Serializable
{

  //
  // fields
  //
	public int      bfakt_id        = 0;
	public int      adr_nr          = 0;
  public String   druckperi       = "";
	public String   listenart       = "";
  public int      fach_nr         = 0;
  public String   druck_art       = "";
  public int      adr_nr_vtr      = 0;
  public String   sort_text       = "";
  public Date     created_dat     = null;
	public Date     changed_dat     = null;



  //---------------------------------------------------------------------------
  // constructors
  //---------------------------------------------------------------------------

  public SAPJGBParamVO()
  {
    // lazy bone
  }

  //---------------------------------------------------------------------------
  // methods
  //---------------------------------------------------------------------------

  public String toString()
  {
    StringBuffer  buf = new StringBuffer();

    buf.append ("  bfakt_id          = <"  + this.bfakt_id   + "> \n");
		buf.append ("  adr_nr            = <"  + this.adr_nr     + "> \n");
		buf.append ("  druck_periode     = <"  + this.druckperi  + "> \n");
		buf.append ("  listen_art        = <"  + this.listenart  + "> \n");
    buf.append ("  fach_nr           = <"  + this.fach_nr    + "> \n");
    buf.append ("  druck_art         = <"  + this.druck_art  + "> \n");
    buf.append ("  adr_nr_vtr        = <"  + this.adr_nr_vtr + "> \n");
    buf.append ("  sort_text         = <"  + this.sort_text  + "> \n");

    buf.append ("  INTERNE FELDER \n");
    if (created_dat == null)
      buf.append ("    created_dat     = null \n");
    else
      buf.append ("    created_dat     = <"  + this.created_dat   + ">\n");

    if (changed_dat == null)
      buf.append ("    changed_dat     = null \n");
    else
      buf.append ("    changed_dat     = <"  + this.changed_dat   + ">\n");

    return buf.toString();
  } // end toString

} // end class

