package ch.ige.ses.vo.bagis;

import java.math.BigDecimal;
import java.io.Serializable;
import java.sql.Date;

/**
 * SES Value Object für einen StakoArtikel
 * <p>
 * Copyright (c) 2003, Eidgenössisches Institut für Geistiges Eigentum
 * @author    Stefan Nydegger
 * @version   $Id: StakoVO.java,v 1.5 2006/12/13 14:58:39 iten Exp $
 */

public class StakoVO implements Serializable
{
  //
  // fields
  //
  public int        stakoId    = 0;
  public int        kontrollId = 0;
  public int        bfaktId    = 0;
  public int        bfaktPosNr = 0;
  public String     employeeId = null;  //String, weil später ev. von ADS selektiert wird
  public String     schutitNr  = null;
  public String     artNr      = null;
  public Date       datum      = null;
  public BigDecimal anzahl     = null;
  public String     herkunft   = null;

  //----------------------------------------------------------------------------
  // constructors
  //----------------------------------------------------------------------------

  public StakoVO()
  {
    // lazy bone
  }

  //----------------------------------------------------------------------------
  // methods
  //----------------------------------------------------------------------------

  public String toString()
  {
    StringBuffer buf = new StringBuffer();

    buf.append(" stakoId        =  " + this.stakoId       + "\n");
    buf.append(" kontrollId     =  " + this.kontrollId    + "\n");
    buf.append(" bfaktId        =  " + this.bfaktId       + "\n");
    buf.append(" bfaktPosNr     =  " + this.bfaktPosNr    + "\n");
    buf.append(" employeeId     =  " + this.employeeId    + "\n");
    buf.append(" schutitNr      =  " + this.schutitNr     + "\n");
    buf.append(" artNr          =  " + this.artNr         + "\n");
    buf.append(" datum          =  " + this.datum         + "\n");
    buf.append(" anzahl         =  " + this.anzahl        + "\n");
    buf.append(" herkunft       =  " + this.herkunft      + "\n");
    return buf.toString();
  }
}

