package ch.ige.ses.vo.ses;

import java.io.Serializable;
import java.sql.Date;

/**
 * Value Object für einen Eintrag der Tabelle AMV_RECHNUNG
 * <p>
 * Copyright (c) 2004, Eidgenössisches Institut für Geistiges Eigentum
 * @author    T. Iten
 * @version   $Id: AmvRechnungVO.java,v 1.5 2006/12/13 14:58:39 iten Exp $
 */
public class AmvRechnungVO implements Serializable
{
  //
  // const
  //
  public static final int RE_CD_ERINNERUNG_1  = 1;
  public static final int RE_CD_ERINNERUNG_2  = 2;

  public static final int RE_STAT_SELECTED    = 0;
  public static final int RE_STAT_SENT        = 1;
  public static final int RE_STAT_SAP_OK      = 2;
  public static final int RE_STAT_SAP_ERROR   = 3;
  public static final int RE_STAT_SUPPRESS_E2 = 4;


  //
  // fields
  //
  public int        amvLaufId     = 0;
  public int        rechnungCd    = 0;
  public int        bfaktId       = 0;
  public int        anzRechEmpf   = 0;
  public int        rechnungStat  = RE_STAT_SELECTED;
  public String     errorMsg      = null;
  public Date       createdDat    = null;
  public Date       changedDat    = null;

  //----------------------------------------------------------------------------
  // constructors
  //----------------------------------------------------------------------------

  public AmvRechnungVO()
  {
    // lazy bone
  }

  public AmvRechnungVO(int amvLaufId,int rechnungCd,int bfaktId, int rechnungStat)
  {
    this.amvLaufId    = amvLaufId;
    this.rechnungCd   = rechnungCd;
    this.bfaktId      = bfaktId;
    this.rechnungStat = rechnungStat;
  }

  //----------------------------------------------------------------------------
  // methods
  //----------------------------------------------------------------------------

  public void clear()
  {
    amvLaufId     = 0;
    rechnungCd    = 0;
    bfaktId       = 0;
    anzRechEmpf   = 0;
    rechnungStat  = RE_STAT_SELECTED;
    errorMsg      = null;
    createdDat    = null;
    changedDat    = null;
  }

  public String toString()
  {
    StringBuffer buf = new StringBuffer();

    buf.append("  amvLaufId     =  " + this.amvLaufId     + "\n");
    buf.append("  rechnungCd    =  " + this.rechnungCd    + "\n");
    buf.append("  bfaktId       =  " + this.bfaktId       + "\n");
    buf.append("  anzRechEmpf   =  " + this.anzRechEmpf   + "\n");
    buf.append("  rechnungStat  =  " + this.rechnungStat  + "\n");
    buf.append("  errorMsg       = " + this.errorMsg      + "\n");
    buf.append("  createdDat    =  " + this.createdDat    + "\n");
    buf.append("  changedDat    =  " + this.changedDat    + "\n");

    return buf.toString();
  }

} // end class

