package ch.ige.ses.vo.ses;

import java.sql.Date;
import java.io.Serializable;

/**
 * SES Value Object für einen STAKO-Lauf
 * <p>
 * Copyright (c) 2003, Eidgenössisches Institut für Geistiges Eigentum
 * @author    Stefan Nydegger
 * @version   $Id: StakoKontrolleVO.java,v 1.5 2006/12/13 14:58:39 iten Exp $
 */

public class StakoKontrolleVO implements Serializable
{
  //----------------------------------------------------------------------------
  // const
  //----------------------------------------------------------------------------
  public static final int STATUS_VERARBEITUNG_STARTED       = 0;
  public static final int STATUS_VERARBEITUNG_CANCELLED     = 1;
  public static final int STATUS_VERARBEITUNG_FINISHED_WITH_ERRORS = 8;
  public static final int STATUS_VERARBEITUNG_FINISHED      = 9;
  public static final int STATUS_HERKUNFT_NOTHING_SAVED     = 0;  // keine herkunft ist gespeichert
  public static final int STATUS_HERKUNFT_MITARBEITER_SAVED = 1;  // 1 Herkunft auf SES gespeichert
  public static final int STATUS_HERKUNFT_ALL_SAVED         = 2;  // beide Herkünfte gespeichert

  //----------------------------------------------------------------------------
  // fields
  //----------------------------------------------------------------------------
  public int  stakoKontrolleId = 0;
  public Date verarbeitungDat = null;
  public Date vonDat = null;
  public Date bisDat = null;
  public int  anzahlEreignisMaGelesen = 0;
  public int  anzahlBfakturGelesen = 0;
  public int  anzahlEreignisMaAnSap = 0;
  public int  anzahlBfakturAnSap = 0;
  public int  anzahlEreignisMaAnSapOK = 0;
  public int  anzahlBfakturAnSapOK = 0;
  public int  stakoStat = 0;
  public int  herkunftStat = 0;
  public Date createdDat = null;
  public Date changedDat = null;

  //----------------------------------------------------------------------------
  // constructors
  //----------------------------------------------------------------------------

  public StakoKontrolleVO()
  {
    // lazy bone
  }

  //----------------------------------------------------------------------------
  // methods
  //----------------------------------------------------------------------------

  public String toString()
  {
    StringBuffer buf = new StringBuffer();

    buf.append("  stakoKontrolleId        =  " + this.stakoKontrolleId        + "\n");
    buf.append("  verarbeitungDat         =  " + this.verarbeitungDat         + "\n");
    buf.append("  vonDat                  =  " + this.vonDat                  + "\n");
    buf.append("  bisDat                  =  " + this.bisDat                  + "\n");
    buf.append("  anzahlEreignisMaGelesen =  " + this.anzahlEreignisMaGelesen + "\n");
    buf.append("  anzahlBfakturGelesen    =  " + this.anzahlBfakturGelesen    + "\n");
    buf.append("  anzahlEreignisMaAnSap   =  " + this.anzahlEreignisMaAnSap   + "\n");
    buf.append("  anzahlBfakturAnSap      =  " + this.anzahlBfakturAnSap      + "\n");
    buf.append("  anzahlEreignisMaAnSapOK =  " + this.anzahlEreignisMaAnSapOK + "\n");
    buf.append("  anzahlBfakturAnSapOK    =  " + this.anzahlBfakturAnSapOK    + "\n");
    buf.append("  stakoStat               =  " + this.stakoStat               + "\n");
    buf.append("  herkunftStat            =  " + this.herkunftStat            + "\n");
    buf.append("  createdDat              =  " + this.createdDat              + "\n");
    buf.append("  changedDat              =  " + this.changedDat              + "\n");
    return buf.toString();
  }
}

