package ch.ige.ses.vo.ses;

import java.io.Serializable;
import java.sql.Date;


/**
 * SES Value Object beinhaltet Selektionskriterien für die Tabelle TRACE
 * <p>
 * Copyright (c) 2002, Eidgenössisches Institut für Geistiges Eigentum
 * @author Anita Rueegsegger
 * @version $Id: TraceSelKritVO.java,v 1.5 2006/12/13 14:58:39 iten Exp $
 */
public class TraceSelKritVO implements Serializable
{

  //
  // fields
  //
  public String   process       = null;     // SapInbound or SapOutbound
  public String   action        = null;     // Action performed
  public String   data          = null;     // Data used
  public Date     createdDatVon = null;
  public Date     createdDatBis = null;
  public int      maxRow        = 0;        // 0 -> Anazhl wird nicht berücksichtigt

  //----------------------------------------------------------------------------
  // constructors
  //----------------------------------------------------------------------------

  public TraceSelKritVO()
  {
    // lazy bone
  }

  //----------------------------------------------------------------------------
  // methods
  //----------------------------------------------------------------------------

  public String toString()
  {
    StringBuffer buf = new StringBuffer();

    buf.append("  process           =  " + process          + "\n");
    buf.append("  action            =  " + action           + "\n");
    buf.append("  data              =  " + data             + "\n");
    buf.append("  createdDatVon     =  " + createdDatVon    + "\n");
    buf.append("  createdDatBis     =  " + createdDatBis    + "\n");
    buf.append("  maxRow            =  " + maxRow           + "\n");

    return buf.toString();
  }
}


