package ch.ige.wdltool.ejb.impl;

import java.sql.SQLException;

import ch.ige.wdltool.dao.NegativeIpiTermDAO;
import ch.ige.wdltool.vo.NegativeIpiTermVO;

/**
 * Implements CRUD services for negative IPI terms.
 * <p>
 * Copyright (c) 2007, Swiss Federal Institute of Intellectual Property
 * </p>
 * 
 * @author Eric Lewis
 * @version $Id: NegativeIpiTermImpl.java,v 1.8 2008/05/08 10:44:32 lewis_lee Exp $
 */
public class NegativeIpiTermImpl extends BaseTermServicesImpl<NegativeIpiTermDAO, NegativeIpiTermVO, Integer>
{

  // @see ch.ige.wdltool.ejb.impl.BaseServicesImpl#getObjectName()
  @Override
  protected String getObjectName()
  {
    return "negative IPI term";
  }

  // @see ch.ige.wdltool.ejb.impl.BaseServicesImpl#getDAOClass()
  @Override
  protected Class<NegativeIpiTermDAO> getDAOClass()
  {
    return NegativeIpiTermDAO.class;
  }

  // @see ch.ige.wdltool.ejb.impl.BaseServicesImpl#find(ch.ige.dbutils.dao.DAO, java.io.Serializable)
  @Override
  protected NegativeIpiTermVO find( NegativeIpiTermDAO dao, Integer id ) throws SQLException
  {
    return dao.find( id );
  }

  // @see ch.ige.wdltool.ejb.impl.BaseServicesImpl#insert(ch.ige.dbutils.dao.DAO, ch.ige.dbutils.vo.AbstractVO)
  @Override
  protected NegativeIpiTermVO insert( NegativeIpiTermDAO dao, NegativeIpiTermVO vo )
  {
    dao.insert( vo );
    return vo;
  }

  // @see ch.ige.wdltool.ejb.impl.BaseServicesImpl#update(ch.ige.dbutils.dao.DAO, ch.ige.dbutils.vo.AbstractVO)
  @Override
  protected void update( NegativeIpiTermDAO dao, NegativeIpiTermVO vo )
  {
    dao.update( vo );
  }

  // @see ch.ige.wdltool.ejb.impl.BaseServicesImpl#delete(ch.ige.dbutils.dao.DAO, java.io.Serializable)
  @Override
  protected void delete( NegativeIpiTermDAO dao, Integer id )
  {
    dao.delete( id );
  }
}
