package ch.ige.wdltool.performance;

import junit.framework.Test;
import junit.framework.TestSuite;

import com.clarkware.junitperf.ConstantTimer;
import com.clarkware.junitperf.LoadTest;
import com.clarkware.junitperf.TimedTest;
import com.clarkware.junitperf.Timer;

/**
 * Tests the performance of {@link ch.ige.wdltool.checker.WdlCheckerTest}
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Esther Bandschapp
 * @version  $Id: WdlCheckerTest.java,v 1.3 2007/07/13 09:26:52 bandschapp Exp $
 */
public class WdlCheckerTest
{
  
  /**
   * The main testing method
   * @param args No arguments needed
   */
  public static void main( String args[] )
  {
    junit.textui.TestRunner.run( suite() );
  }
  
  /**
   * The summary of the tests
   * @return the test which indicates the success of the suite
   */
  public static Test suite()
  {
    TestSuite suite = new TestSuite();
    suite.addTest( ch.ige.wdltool.performance.WdlCheckerTest.testCheckPunctuationMarks() );
    suite.addTest( ch.ige.wdltool.performance.WdlCheckerTest.testCheckStopwords() );
    suite.addTest( ch.ige.wdltool.performance.WdlCheckerTest.testCheckMultipleBlanks() );
    return suite;
  }

  /**
   * Tests {@link ch.ige.wdltool.checker.WdlCheckerTest#testCheckStopwords()}.
   * @return the Test.
   */
  public static Test testCheckStopwords()
  {
    long maxElapsedTime = 1000;

    Test testCase = new ch.ige.wdltool.checker.WdlCheckerTest( "testCheckStopwords" );
    Test timedTest = new TimedTest( testCase, maxElapsedTime );

    return timedTest;
  }
  
  /**
   * Tests {@link ch.ige.wdltool.checker.WdlCheckerTest#testCheckMultipleBlanks()}.
   * @return the Test.
   */
  public static Test testCheckMultipleBlanks()
  {
    long maxElapsedTime = 1000;

    Test testCase = new ch.ige.wdltool.checker.WdlCheckerTest( "testCheckMultipleBlanks" );
    Test timedTest = new TimedTest( testCase, maxElapsedTime );

    return timedTest;
  }
  
  /**
   * Tests {@link ch.ige.wdltool.checker.WdlCheckerTest#testCheckPunctuationMarks()}
   * with multiple users.
   * @return the Test.
   */
  public static Test testCheckPunctuationMarks()
  {
    int users = 10;
    Timer timer = new ConstantTimer(100);
    Test testCase = new ch.ige.wdltool.checker.WdlCheckerTest( "testCheckPunctuationMarks" );
    long maxElapsedTime = 2000;    
    return new TimedTest(new LoadTest( testCase, users, timer), maxElapsedTime);      
    
  }
}
