package ch.ige.wdltool.validator;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;
import java.lang.annotation.RetentionPolicy;

import org.hibernate.validator.ValidatorClass;

/**
 * Checks for a valid term.
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Eric Lewis
 * @version  $Id: Term.java,v 1.1 2007/08/29 13:42:28 lewis_lee Exp $
 */
@ValidatorClass( TermValidator.class )
@Target( ElementType.METHOD )
@Retention( RetentionPolicy.RUNTIME )
@Documented
public @interface Term
{
  /**
   * The error message to show
   */
  String message() default "{validator.invalidTerm}";
}
