package ch.ige.wdltool.vo;

import org.hibernate.validator.Range;

/**
 * Contains the data for a Nice term group.
 *
 * <p>Copyright (c) 2007, Swiss Federal Institute of Intellectual Property</p>
 * @author   Esther Bandschapp
 * @version  $Id: NiceTermGroupVO.java,v 1.8 2007/09/14 12:25:22 heinzer Exp $
 */
public class NiceTermGroupVO extends TermGroupVO
{
  /**
   * Sets the Nice term number.
   * @param niceTermNumber The Nice term number to set
   */
  public void setNiceTermNumber( Integer niceTermNumber )
  {
    this.niceTermNumber = niceTermNumber;
  }
  
  /**
   * Gets the Nice term number.
   * @return the Nice term number
   */
  @Range(min=10000,max=459999)
  public Integer getNiceTermNumber()
  {
    return this.niceTermNumber;
  }
}
